#! /bin/sh -f
# ====================================================================
#
# OpenCCM: The Open CORBA Component Model Platform
# Copyright (C) 2000-2004 INRIA - USTL - LIFL - GOAL
# Contact: openccm@objectweb.org
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
# USA
#
# Initial developer(s): Christophe Demarey.
# Contributor(s):
#
# ====================================================================
#
#  Starts the OpenCCM Client component.
#
# ====================================================================

host=`cat host`

if ! [ -d ${OpenCCM_CONFIG_DIR} ]
then
  ccm_install
fi

ant wait_for_activation -Dport=2100

if ! [ -f ${OpenCCM_CONFIG_DIR}/NameService.IOR ]
then
  ns_set http://${host}:8080/NameService.IOR
fi

if ! [ -f ${OpenCCM_CONFIG_DIR}/DCI.IOR ]
then
  dci_set http://${host}:8080/DCI.IOR
fi

node_start client_node
ant activate -Dport=2101

ant wait_for_activation -Dport=2100
node_stop client_node
ant activate -Dport=2101

ant wait_for_activation -Dport=2100
if [ -d ${OpenCCM_CONFIG_DIR} ]
then
  ccm_deinstall
fi

# Delete temporary files
rm /tmp/*aar
rm /tmp/*.car