/*====================================================================
 
 Objectweb Browser Framework
 Copyright (C) 2000-2004 INRIA & USTL - LIFL - GOAL
 Contact: openccm@objectweb.org
 
 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or any later version.
 
 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 Lesser General Public License for more details.
 
 You should have received a copy of the GNU Lesser General Public
 License along with this library; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 USA
 
 Initial developer(s): Jerome Moroy.
 Contributor(s): ______________________________________.
 
 ---------------------------------------------------------------------
 $Id: ArchitectRootContext.java,v 1.2 2004/04/28 15:04:13 moroy Exp $
 ====================================================================*/

package org.objectweb.util.browser.plugins.fractal.context;

import java.util.Vector;

import org.objectweb.fractal.adl.ADLException;
import org.objectweb.fractal.adl.FactoryFactory;
import org.objectweb.util.browser.api.Context;
import org.objectweb.util.browser.api.Entry;
import org.objectweb.util.browser.core.api.ContextContainer;
import org.objectweb.util.browser.core.naming.DefaultContextContainer;
import org.objectweb.util.browser.core.naming.DefaultEntry;
import org.objectweb.util.browser.core.naming.DefaultName;
import org.objectweb.util.browser.core.naming.InitialEntry;

/**
 * 
 * 
 * @author <a href="mailto:Jerome.Moroy@lifl.fr">Jerome Moroy</a>
 * @version 0.1
 */
public class ArchitectRootContext 
  implements Context
{
    
    // ==================================================================
    //
    // No internal state.
    //
    // ==================================================================
    
    /** context container for the root node. */
    protected static ContextContainer cc_ = null;
    
    // ==================================================================
    //
    // static block.
    //
    // ==================================================================
    
    // Initializes the ContextContainer.
    static {
        cc_ = new DefaultContextContainer();
        cc_.addEntry("type-factory", new TypeContainer());
        cc_.addEntry("component-factory", new TemplateContainer());
    }
    
    // ==================================================================
    //
    // No Constructors.
    //
    // ==================================================================
    
    // ==================================================================
    //
    // No internal methods.
    //
    // ==================================================================
    
    // ==================================================================
    //
    // Public methods for interface Context.
    //
    // ==================================================================
    
    /**
     * Returns an array containing the entries contained by the target context.
     * @return A new array of entry.
     */
    public Entry[] getEntries(){
        Vector values = new Vector();
        try {
            values.add(new DefaultEntry(new FactoryWrapper(FactoryFactory.getFactory(FactoryFactory.FRACTAL_BACKEND)), 
                                        new DefaultName("Fractal-factory")));
        } catch (ADLException e) {
            System.out.println("[" + getClass().getName() + "] Exception: " + e.getMessage());
        }
        values.add(new InitialEntry("Fractal-container",cc_,1));
        return (Entry[])values.toArray(new Entry[0]);
    }
    
}