/*====================================================================
 
 Objectweb Browser Framework
 Copyright (C) 2000-2004 INRIA & USTL - LIFL - GOAL
 Contact: openccm@objectweb.org
 
 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or any later version.
 
 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 Lesser General Public License for more details.
 
 You should have received a copy of the GNU Lesser General Public
 License along with this library; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 USA
 
 Initial developer(s): Romain Rouvoy.
 Contributor(s): ______________________________________.
 
 ---------------------------------------------------------------------
 $Id: InterfaceWrapper.java,v 1.1 2004/04/20 16:37:26 moroy Exp $
 ====================================================================*/

package org.objectweb.util.browser.plugins.fractal.context;

import org.objectweb.fractal.api.Interface;

/**
 * Basic interface wrapper.
 * @author <a href="mailto:Romain.Rouvoy@lifl.fr">Romain Rouvoy</a>
 * @version 0.1
 */
public class InterfaceWrapper 
{
    /** the wrapped interface. */
    protected Interface itf ;
    
    /**
     * @return Returns the itf.
     */
    public Interface getItf() {
        return itf;
    }

    /**
     * @param itf The itf to set.
     */
    public void setItf(Interface itf) {
        this.itf = itf;
    }
    
    /**
     * Default constructor.
     * @param itf the interface to wrap.
     */
    public InterfaceWrapper(Interface itf) {
        setItf(itf);
    }
}
