/*====================================================================

Objectweb Browser Framework
Copyright (C) 2000-2003 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Philippe Merle, Jerome Moroy.
Contributor(s): ______________________________________.

====================================================================*/

package org.objectweb.util.browser.core.naming;

import org.objectweb.util.browser.core.api.InitialContext;
import org.objectweb.util.browser.core.common.DynamicTree;

/**
 * This context defines the initial structure of the dynamic tree.  
 *
 * @author <a href="mailto:Philippe.Merle@lifl.fr">Philippe Merle</a>,
 *         <a href="mailto:Jerome.Moroy@lifl.fr">Jrme Moroy</a>
 * 
 * @version 0.1
 */
public class InitialContextContainer 
     extends DefaultContextContainer
  implements InitialContext 
{

    //==================================================================
    //
    // Internal state.
    //
    //==================================================================

    /** The associated tree. */
    protected DynamicTree tree_;

    //==================================================================
    //
    // No constructor.
    // 
    //==================================================================

    //==================================================================
    //
    // No internal method.
    //
    //==================================================================

    //==================================================================
    //
    // Public methods.
    //
    //==================================================================

    /**
     * Overriding methods
     * @see org.objectweb.util.browser.core.api.InitialContext#setDynamicTree(org.objectweb.util.browser.core.common.DynamicTree)
     */
    public void setDynamicTree(DynamicTree tree) {
        tree_ = tree;
    }

    //==================================================================
    //
    // Public methods.
    //
    //==================================================================

    /**
     * Overriding methods
     * @see org.objectweb.util.browser.core.api.ContextContainer#removeEntry(java.lang.String)
     */
    public void removeEntry(String id) {
        super.removeEntry(id);
        if(tree_!=null)
            tree_.removeEntry(id);
    }

}