/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2003 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Jerome Moroy.
Contributor(s):  ______________________________________.

====================================================================*/

package org.objectweb.openccm.explorer.CORBA;

/**
 * Wrapper wich contains an attribute of a CORBA Object.
 *
 * @author <a href="mailto:Jerome.Moroy@lifl.fr">Jerome Moroy</a>
 *
 * @version 0.1
 */
public class ViewAttributeWrapper
{

    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================

    /** The attribute name to wrap */
    protected String name_ = null;

    /** The associated CORBA Object */
    protected org.omg.CORBA.Object object_ = null;

    // ==================================================================
    //
    // No Constructor.
    //
    // ==================================================================

    /**
     * Default constructor.
     * @param name The name of the attribute.
     * @param object The CORBA object.
     */
    public ViewAttributeWrapper(String name, org.omg.CORBA.Object object){
        name_ = name;
        object_ = object;
    }

    // ==================================================================
    //
    // No internal method.
    //
    // ==================================================================

    // ==================================================================
    //
    // Public methods.
    //
    // ==================================================================

    /**
     * Provides the name of the attribute.
     */
    public String getName(){
        return name_;    
    }

    /**
     * Provides the associated CORBA Object.
     */
    public org.omg.CORBA.Object getObject(){
        return object_;   
    }

}