/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2004 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Jerome Moroy.
Contributor(s):  ______________________________________.

====================================================================*/
package org.objectweb.openccm.explorer.CosNaming;

import java.util.List;
import java.util.Vector;

import org.objectweb.openccm.explorer.CORBA.ConsoleFactory;
import org.objectweb.util.explorer.api.Context;
import org.objectweb.util.explorer.api.Entry;
import org.objectweb.util.explorer.core.naming.lib.DefaultEntry;
import org.omg.CosNaming.NamingContextExt;

/**
 * Basic implementation of the Context interface
 * for managing NamingContext.
 *
 * @author <a href="mailto:Jerome.Moroy@lifl.fr">Jerome Moroy</a>
 *
 * @version 0.1
 */
public class NameServiceContext 
  implements Context 
{

    // ==================================================================
    //
    // No Internal state.
    //
    // ==================================================================

    // ==================================================================
    //
    // Constructors.
    //
    // ==================================================================

    // ==================================================================
    //
    // No internal methods.
    //
    // ==================================================================

    // ==================================================================
    //
    // Public methods for Context interface.
    //
    // ==================================================================

    public Entry[] getEntries(Object object) {
        NamingContextExt namingContext = (NamingContextExt)object;
        List l = new Vector();
        try{
            org.omg.CosNaming.BindingListHolder bindingList = new org.omg.CosNaming.BindingListHolder();
            org.omg.CosNaming.BindingIteratorHolder bindingIterator = new org.omg.CosNaming.BindingIteratorHolder();
            namingContext.list(100, bindingList, bindingIterator);
            while(true){
                for(int i = 0; i< bindingList.value.length ; i++){
                    try{
                        l.add(new DefaultEntry(namingContext.to_string(bindingList.value[i].binding_name), namingContext.resolve(bindingList.value[i].binding_name)));
                     } catch (org.omg.CosNaming.NamingContextPackage.NotFound e) {
                        System.out.println(getClass().getName() + " : Object Not Found Exception !");
                     } catch (org.omg.CosNaming.NamingContextPackage.CannotProceed e) {
                        System.out.println(getClass().getName() + " : CannotProceed Exception");
                     } catch (org.omg.CosNaming.NamingContextPackage.InvalidName e) {
                        System.out.println(getClass().getName() + " : InvalidName Exception");
                     }                   
                }
                if(!bindingIterator.value.next_n(100, bindingList)) break;
            }
        } catch(Exception e) {
            ConsoleFactory.getDebugConsole().add(e.getMessage()+ "\n");
        }
        return (Entry[])l.toArray(new Entry[0]);  
    }

}
