/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2005 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Jerome Moroy.
Contributor(s):  ______________________________________.

====================================================================
$Id: DefaultApplication.java,v 1.2 2005/07/01 15:55:17 moroy Exp $
====================================================================*/
package org.objectweb.openccm.explorer.commandLine;

/**
 * Interface for adding default browser file.
 * 
 * @author <a href="mailto:Jerome.Moroy@lifl.fr">Jerome Moroy</a>
 *
 * @version 0.1
 */
public interface DefaultApplication {

    /**
     * Fixes the Default Context Configuration file to use
     * @param file The configuration file to use
     */
    public void setDefaultContextConfigFile(String file);

    /**
     * Fixes the Default Explorer Configuration file to use
     * @param file The configuration file to use
     */
    public void setDefaultExplorerConfigFile(String[] file);

}
