/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2004 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Jerome Moroy.
Contributor(s):  ______________________________________.

====================================================================*/
package org.coach.actor.browser;

/** The administration console's API imports */
import org.objectweb.util.browser.api.MenuItem;
import org.objectweb.util.browser.api.MenuItemTreeView;
import org.objectweb.util.browser.api.TreeView;
import javax.swing.JFileChooser;
import java.io.FileWriter;
import org.coach.util.IorPrinter;

/**
 * This action saves the IOR of the CORBA Object into a file on the file system.
 *
 * @author <a href="mailto:Jerome.Moroy@lifl.fr">Jerome Moroy</a>
 *
 * @version 0.1
 */
public class DisplayActor 
  implements MenuItem 
{

    //==================================================================
    //
    // No internal state.
    //
    //==================================================================
   
    //==================================================================
    //
    // No internal methods.
    //
    //==================================================================

    protected String getId(org.omg.CORBA.ORB orb, org.omg.CORBA.Object object){
        IorPrinter iorPrinter = new IorPrinter(orb.object_to_string(object));
        return iorPrinter.getTypeId();
    }
    
    //==================================================================
    //
    // Public methods for MenuItem interface.
    //
    //==================================================================

    /**
     * @see org.objectweb.util.browser.api.MenuItem#getStatus(org.objectweb.util.browser.api.TreeView)
     */
    public int getStatus(TreeView treeView) {
        return MenuItem.ENABLED_STATUS;
    }

    /**
     * The action to execute
     */
    public void actionPerformed(MenuItemTreeView e) throws Exception {
        try {
            org.omg.CORBA.Object object = (org.omg.CORBA.Object)e.getSelectedObject();
            String name = e.getSelectedEntry().getName().toString();
            org.omg.CORBA.ORB orb = org.objectweb.openccm.corba.TheORB.getORB();
            org.coach.idltree.IdlNode.setOrb(orb);
            new org.coach.actor.componentBrowser.MethodFrame((java.awt.Component)e.getActionEvent().getSource(), getId(orb,object), name, object, orb);        
            // ComponentBrowser b = new ComponentBrowser((java.awt.Component)e.getActionEvent().getSource(), orb, name, object);
        } catch (Throwable ex) {
            ex.printStackTrace();
        }
    }

}
