/***************************************************************************/
/* COACH: Component Based Open Source Architecture for                     */
/*        Distributed Telecom Applications                                 */
/* See:   http://www.objectweb.org/                                        */
/*                                                                         */
/* Copyright (C) 2003 Lucent Technologies Nederland BV                     */
/*                    Bell Labs Advanced Technologies - EMEA               */
/*                                                                         */
/* Initial developer(s): Harold Batteram                                   */
/*                                                                         */
/* This library is free software; you can redistribute it and/or           */
/* modify it under the terms of the GNU Lesser General Public              */
/* License as published by the Free Software Foundation; either            */
/* version 2.1 of the License, or (at your option) any later version.      */
/*                                                                         */
/* This library is distributed in the hope that it will be useful,         */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of          */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU        */
/* Lesser General Public License for more details.                         */
/*                                                                         */
/* You should have received a copy of the GNU Lesser General Public        */
/* License along with this library; if not, write to the Free Software     */
/* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA */
/***************************************************************************/
package org.coach.idltree;

import java.io.*;
import java.util.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.tree.*;
import java.awt.*;
import java.awt.event.*;

public class XmlParser {
    public static void main(String argv[]) {

        IdlNode root = null;
        try {
            String xml = "";
            if (argv.length == 1) {
                File f = new File(argv[0]);
                BufferedReader r = new BufferedReader(new FileReader(f));
                StringBuffer sb = new StringBuffer();
                String s = r.readLine();
                while (s != null) {
                    sb.append(s);
                    s = r.readLine();
                }
                xml = sb.toString();
            }
/*
            else {
                XmlWriter w = new XmlWriter();
                XmlTest.MyStructXmlHelper.write(w);
                xml = w.toString();
                System.out.println(xml);
            }
*/
            root = XmlNode.getIdlNodeXml(xml);
        } catch (Exception e) {
            e.printStackTrace();
        }

        IdlEditor.display("XmlEditor", root);
    }
}
