/*
 * TrailLabelDialog.java
 *
 * Created on March 5, 2003, 12:39 PM
 */

package org.coach.tracing.server.viewer;

import javax.swing.*;

/**
 *
 * @author  batteram
 */
public class TrailLabelDialog extends javax.swing.JDialog {
    private JColorChooser colorChooser = new JColorChooser();
    private TrailLabelData[] labels;
    private JCheckBox[] checkBoxes;
    private JButton[] buttons;
    
    /** Creates new form TrailLabelDialog */
    public TrailLabelDialog(JFrame frame, TrailLabelData[] labels) {
        super(frame, true);
        this.labels = labels;
        checkBoxes = new JCheckBox[labels.length];
        buttons = new JButton[labels.length];

        getContentPane().setLayout(new java.awt.GridLayout(labels.length, 1));

        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                closeDialog(evt);
            }
        });

        for (int i = 0; i < labels.length; i++) {
            JPanel panel = new javax.swing.JPanel();
            checkBoxes[i] = new JCheckBox();
            checkBoxes[i].setText(labels[i].name);
            checkBoxes[i].setSelected(labels[i].active);
            buttons[i] = new JButton();
            buttons[i].setText("color");
            buttons[i].setBackground(labels[i].color);
            buttons[i].addActionListener(new java.awt.event.ActionListener() {
                public void actionPerformed(java.awt.event.ActionEvent evt) {
                    buttonActionPerformed(evt);
                }
            });
            panel.add(checkBoxes[i]);
            panel.add(buttons[i]);
            getContentPane().add(panel);
        }
        setLocationRelativeTo(frame);
        pack();
        setVisible(true);
    }
    
    public TrailLabelData[] getTrailLabelData() {
        for (int i = 0; i < labels.length; i++) {
            labels[i].active = checkBoxes[i].isSelected();
            labels[i].color = buttons[i].getBackground();
        }
        return labels;
    }

    private void buttonActionPerformed(java.awt.event.ActionEvent evt) {
        JButton button = (JButton)evt.getSource();
        button.setBackground(colorChooser.showDialog(button, "Select trail color", button.getBackground()));
    }
    
    /** Closes the dialog */
    private void closeDialog(java.awt.event.WindowEvent evt) {
        setVisible(false);
        dispose();
    } 
}
