@echo off
rem # ====================================================================
rem #
rem # OpenCCM: The Open CORBA Component Model Platform
rem # Copyright (C) 2004-2005 INRIA - USTL - LIFL - GOAL
rem # Contact: openccm@objectweb.org
rem #
rem # This library is free software; you can redistribute it and/or
rem # modify it under the terms of the GNU Lesser General Public
rem # License as published by the Free Software Foundation; either
rem # version 2.1 of the License, or any later version.
rem #
rem # This library is distributed in the hope that it will be useful,
rem # but WITHOUT ANY WARRANTY; without even the implied warranty of
rem # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
rem # Lesser General Public License for more details.
rem #
rem # You should have received a copy of the GNU Lesser General Public
rem # License along with this library; if not, write to the Free Software
rem # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
rem # USA
rem #
rem # Initial developer(s): Philippe Merle.
rem # Contributor(s): Christophe Demarey.
rem #
rem # ====================================================================
rem #
rem # Starting the OpenCCM Comanche Server.
rem #
rem # ====================================================================
rem # $Id$
rem # ====================================================================

setlocal

rem # We first assume the whole OpenCCM environment has been sourced
set COMANCHE_HOMEDIR=%OpenCCM_HOMEDIR%
set COMANCHE_CONFIGDIR=%OpenCCM_CONFIG_DIR%

rem # then, in case we only sourced the Launcher environment
if "%COMANCHE_HOMEDIR%" == "" goto standalone
goto homedir_set

:standalone
set COMANCHE_HOMEDIR=%OW_HOMEDIR%
set COMANCHE_CONFIGDIR=%OW_CONFIGDIR%
goto homedir_set

:homedir_set
rem # Anyway, the Launcher needs to know the used HOMEDIR
set OW_HOMEDIR=%COMANCHE_HOMEDIR%
set OW_CONFIGDIR=%COMANCHE_CONFIGDIR%

rem # Check if the sublayer platform has been installed
call "%COMANCHE_HOMEDIR%\bin\ow_installed"
if %OW_INSTALLED%==0 goto :eof

rem # Check if the Comancher Server is already started.
if not exist "%COMANCHE_CONFIGDIR%\Comanche.PID" goto :do_start

echo Error: The Comanche Server is already started!
goto :eof

:do_start
echo Launching the Comanche Server...

set LAUNCHER_JVM_ARGS="-DCOMANCHE_CONFIGDIR=%COMANCHE_CONFIGDIR%"
set LAUNCHER_ARGS="file:%COMANCHE_HOMEDIR%/xml/launcher/Comanche.xml" %*
call launcher fork "%COMANCHE_CONFIGDIR%\Comanche.output" "%COMANCHE_CONFIGDIR%\Comanche.PID"

echo The Comanche Server is started.
