/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Briclet Frederic
Contributor(s): ---------------------------------------------

====================================================================*/

package org.objectweb.openccm.OpenCCM_DCI.cif;

import org.objectweb.openccm.OpenCCM_DCI.*;
/**
 * This is the implementation of the 
 * OpenCCM_DCI::ComponentServerManagerRegistration interface.
 * 
 * This class inherits from the skeleton
 * generated by the OpenCCM's CIF to Java mapping generator.
 *
 * @author <a href="mailto:Frederic.Briclet@lifl.fr">Briclet Frederic</A>
 */
public class ComponentServerManagerRegistrationImpl  
    extends org.objectweb.openccm.OpenCCM_DCI.
            NodeManagerSessionComposition.ComponentServerManagerRegistrationSeg
{
    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================
    // ==================================================================
    //
    // Internal methods.
    //
    // ==================================================================
    // ==================================================================
    //
    // Constructor.
    //
    // ==================================================================
    // ==================================================================
    //
    // Public methods.
    //
    // ==================================================================

    /**
     * Registration method to register a ComponentServerManager to a node
     * manager.
     * @param component_server_manager The component to register
     * @ return a connection cookie.
     */
    public org.omg.Components.Cookie
    register_component_server_manager(
                              org.objectweb.openccm.OpenCCM_DCI
                              .ComponentServerManager component_server_manager)
    {
        try{      
            //connect the ComponentServerManager and return the cookie
            return  
                ((org.objectweb.openccm
                  .OpenCCM_DCI.NodeManagerCCM)get_context())
                .connect_component_server_managers(component_server_manager) ;
        }
        catch(Exception e){e.printStackTrace();}        
        System.err.println("Error occured during component server manager connection");
     return null;   
    }
        
        
    /**
     * Unregistration method to unregister a ComponentServerManager to a node
     * manager.
     * @param component_server_manager The component to register
     * @ return a connection cookie.
     */
    public void
    unregister_component_server_manager(org.omg.Components.Cookie cookie)
    throws org.omg.Components.CookieRequired
        {
           try{               
               //Break the connection
               ((org.objectweb.openccm.OpenCCM_DCI.NodeManagerCCM)
                get_context())
                   .disconnect_component_server_managers(cookie);
           }
           catch(Exception e){
               e.printStackTrace();
               throw new org.omg.Components.CookieRequired();
           }
        }
    
}
