/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Briclet Frederic
Contributor(s): ---------------------------------------------

====================================================================*/

package org.objectweb.openccm.OpenCCM_DCI.cif;

import org.objectweb.openccm.OpenCCM_DCI.*;

/**
 * This is the implementation of the DCIManager  component type.
 *
 * This class inherits from the skeleton
 * generated by the OpenCCM's CIF to Java mapping generator.
 *
 * @author <a href="mailto:Frederic.Briclet@lifl.fr">Briclet Frederic</A>
 */

public class DCIManagerImpl
     extends org.objectweb.openccm.OpenCCM_DCI.
             DCIManagerSessionComposition.DCIManagerImpl
{
    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================    
    //The dci name
    private String dciName;
    
    // ==================================================================
    //
    // Internal methods.
    //
    // ==================================================================
    
    // ==================================================================
    //
    // Public methods.
    //
    // ==================================================================
    
    public void 
    configuration_complete()
    {
        try{
            ((DCIInformationSegImpl)
             obtain_executor("dci_information")).setupDCI();
            ((DCIDeploymentSegImpl)
             obtain_executor("dci_deployment")).setupDCI();
            ((NodeManagementSegImpl)
             obtain_executor("node_management")).setupDCI();
             ((HomeManagementSegImpl)
             obtain_executor("home_finder")).setupDCI();
        }
        catch(Exception e){
            e.printStackTrace();
        }
    }
    

    public void
    ccm_remove()
    throws org.omg.Components.CCMException
    {
        (new org.objectweb.openccm.Deployment.ShutDownThread()).start();
    }
   
    public void
    push(org.ist.coach.DCI.NodeChanged code_changed){
        
    }

    // ==================================================================
    //
    // Accessor methods.
    //
    // ==================================================================
    
    public void
    dci_name(java.lang.String dciName)
    {
        this.dciName=dciName;
    }
    
    public String
    dci_name()
    {
        return this.dciName;
    }

        
    
    
}
