/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2004 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Briclet Frdric.
Contributor(s): ______________________________________.

====================================================================*/
package org.objectweb.openccm.descriptor.componentassembly.ccm.deployer.base;

/**
 * The BaseDeployerState class is an abstract class which implements uniquely
 * the String getName() method of the DeployerState interface to unify its
 * implementation accros the differents DeployerState implementations.
 * 
 * @author <a href="mailto:briclet@lifl.fr">Frederic Briclet</a>
 *
 * @version 0.1
 */
public abstract class BaseDeployerState 
    implements DeployerState 
{
    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================
      

    // ==================================================================
    //
    // Constructors.
    //
    // ==================================================================  
    
    // ==================================================================
    //
    // Internal methods.
    //
    // ==================================================================
    
    // ==================================================================
    //
    //  Public methods for DeployerState.
    //
    // ==================================================================
    
    /**
     * The getStateName method allow to retrieve a String identifier of 
     * this state. The string identifier return is base on computation of 
     * the state class name.
     * 
     * @return The string name of the DeloyerState
     */
    public String 
    getStateName() 
    {
        String name = this.getClass().getName();
        return name.substring(name.lastIndexOf(".") + 1);
    }
}
