/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2004 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Briclet Frdric.
Contributor(s): ______________________________________.

====================================================================*/
package org.objectweb.openccm.descriptor.componentassembly.ccm.deployer.binder;

import org.omg.Components.CCMHome;

/**
 * The homeinterface deployer is in charge to resolve the define home interface.
 *
 * @author <a href="mailto:briclet@lifl.fr">Briclet Frdric</a>
 *
 * @version 0.1
 */
public class HomeinterfaceDeployer 
       extends HomeinterfaceDeployerContext 
    {
    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================
    // ==================================================================
    //
    // Constructors.
    //
    // ==================================================================
    // ==================================================================
    //
    // Internal methods.
    //
    // ==================================================================
    // ==================================================================
    //
    //  Public methods.
    //
    // ==================================================================
    /**
     * Resolve the home reference.
     * 
     * @return The home reference.
     * @throws CannotResolveHomeInterfaceException
     */
    public org.omg.Components.CCMHome 
    getHome()
    throws CannotResolveHomeInterfaceException
    {
       CCMHome home=null;
       /*try to resolve with homeplacementref*/
       if(getHomeplacementDeployer()!=null)
           home= getHomeplacementDeployer().getHome();    
       else if(getFindbyDeployer()!=null)
           try{//try to resolve reference with registration services
               home=org.omg.Components.
                    CCMHomeHelper.narrow(getFindbyDeployer().resolveReference());
           }
           catch(Exception e){
               throw new CannotResolveHomeInterfaceException(this,e,"Home interface resolution not found");
           }
           getLifeCycleManager().stepEndedSuccessFully();
      return home;      
     }   
}
