/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2004 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Briclet Frdric.
Contributor(s): ______________________________________.

====================================================================*/
package org.objectweb.openccm.descriptor.componentassembly.ccm.deployer.installer;

// Local Interface Import Statements
import org.objectweb.apollon.framework.ExtensionManager;
import org.objectweb.openccm.descriptor.componentassembly.beans.ComponentinstantiationBean;
import org.objectweb.openccm.descriptor.componentassembly.beans.ComponentplacementBeanImpl;
import org.objectweb.openccm.descriptor.componentassembly.ccm.deployer.base.*;
/**
 * This handler is used to produce componentplacementdeployer from an
 * componentplacement bean . 
 *
 * @author <a href="mailto:briclet@lifl.fr">Briclet Frdric</a>
 *
 * @version 0.1
 */
public class ComponentplacementDeployerHandler 
       extends HandlerBase 
    {
    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================
    private ComponentplacementDeployer _deploy;
    // ==================================================================
    //
    // Constructors.
    //
    // ==================================================================
    // ==================================================================
    //
    // Internal methods.
    //
    // ==================================================================
    // ==================================================================
    //
    //  Public methods.
    //
    // ==================================================================
    /**
     * Produce the componentplacement deployer binded
     * to the givean @param comp.
     * 
     * @param comp The componentplacement bean 
     * @return the deployer produced in initialize state
     * @throws InitializationError thrown if a problem is detected
     */  
    public Object 
    getInstance(ComponentplacementBeanImpl comp)
    throws InitializationError 
    {
        if(_deploy==null){
            _deploy=new ComponentplacementDeployer();         
            _deploy.connectComponentplacement(comp);
            applyCommonConfig(_deploy);
            _deploy.connectExistinghomeDeployer((ExistinghomeDeployer)
                                                getDeployer(comp.getExistinghome())) ;          
            
            for(java.util.Iterator i=comp.getComponentinstantiationList().iterator();i.hasNext(); ){
               ComponentinstantiationDeployer current=(ComponentinstantiationDeployer)
                                           getDeployer((ComponentinstantiationBean)i.next());              
               _deploy.connectComponentinstantiationDeployer(current);              
           }
           _deploy.initialize();
        }
        
        return (_deploy);
    }

}
