/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2004 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Briclet Frdric.
Contributor(s): ______________________________________.

====================================================================*/
package org.objectweb.openccm.descriptor.componentassembly.ccm.deployer.installer;

// Local Interface Import Statements
import org.objectweb.apollon.framework.ExtensionManager;
import org.objectweb.openccm.descriptor.componentassembly.beans.ComponentplacementBean;
import org.objectweb.openccm.descriptor.componentassembly.beans.HomeplacementBean;
import org.objectweb.openccm.descriptor.componentassembly.beans.HostcollocationBean;
import org.objectweb.openccm.descriptor.componentassembly.beans.PartitioningBeanImpl;
import org.objectweb.openccm.descriptor.componentassembly.ccm.deployer.base.HandlerBase;
import org.objectweb.openccm.descriptor.componentassembly.ccm.deployer.base.InitializationError;

/**
 * This handler is used to produce partitioningployer from an
 * partitioning bean .
 *
 * @author <a href="mailto:briclet@lifl.fr">Briclet Frdric</a>
 *
 * @version 0.1
 */
public class PartitioningDeployerHandler 
       extends HandlerBase 
    {
    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================
    private ExtensionManager _extManager;
    private PartitioningDeployer _deploy;
    // ==================================================================
    //
    // Constructors.
    //
    // ==================================================================
    // ==================================================================
    //
    // Internal methods.
    //
    // ==================================================================
    // ==================================================================
    //
    //  Public methods.
    //
    // ==================================================================
    /**
     * Produce the partitioning deployer binded
     * to the givean @param parti.
     * 
     * @param parti The partitioning bean 
     * @return the deployer produced in initialize state
     * @throws InitializationError thrown if a problem is detected
     */ 
    public Object 
    getInstance(PartitioningBeanImpl parti)
    throws InitializationError 
    {
        if(_deploy==null){
            _deploy=new PartitioningDeployer();
            applyCommonConfig(_deploy);
            
            _deploy.connectPartitioning(parti);
            for(java.util.Iterator i=parti.getHomeplacementList().iterator();i.hasNext(); ){
                  HomeplacementDeployer current=(HomeplacementDeployer)
                                      getDeployer((HomeplacementBean)i.next());
                  current.initialize();    
                  _deploy.connectHomeplacementDeployer(current);
              }
    
            for(java.util.Iterator i=parti.getComponentplacementList().iterator();i.hasNext(); ){
                 ComponentplacementDeployer current=(ComponentplacementDeployer)
                                     getDeployer((ComponentplacementBean)i.next());
                 _deploy.connectComponentplacementDeployer(current);
             }      
 
            for(java.util.Iterator i=parti.getHostcollocationList().iterator();i.hasNext(); ){
               HostcollocationDeployer current=(HostcollocationDeployer)
                                   getDeployer((HostcollocationBean)i.next());                                  

               _deploy.connectHostcollocationDeployer(current);
           }/*
           System.err.println("Step4");
           for(java.util.Iterator i=parti.getProcesscollocationList().iterator();i.hasNext(); ){
              ProcesscollocationDeployer current=(ProcesscollocationDeployer)
                                  getDeployer((ProcesscollocationBean)i.next());
              //current.connectRootDeployerContext(_deploy.getRootDeployerContext());
              _deploy.connectProcesscollocationDeployer(current);
          }  */
          _deploy.initialize();          
        }
      
        return (_deploy);
    }

}
