/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2004 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Briclet Frdric.
Contributor(s): ______________________________________.

====================================================================*/
package org.objectweb.openccm.descriptor.componentassembly.ccm.deployer.util;

import java.net.ServerSocket;

import org.objectweb.openccm.descriptor.componentassembly.beans.FileinarchiveBean;
import org.objectweb.openccm.descriptor.componentassembly.ccm.deployer.base.*;

/**
 * The fileinarchive deployer context defines all the connection requires for
 * browse the current archive and retrieve a specific entry. There is also 
 * connection to start an HTTP server to upload file.
 *
 * @author <a href="mailto:briclet@lifl.fr">Briclet Frdric</a>
 *
 * @version 0.1
 */
public class FileinarchiveDeployerContext 
       extends ChildDeployerContext 
    {
    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================
    private FileinarchiveBean fileinarchive;
    //Reference on a possible linkDeployer child
    private LinkDeployer linkDeployer;
    // ==================================================================
    //
    // Constructors.
    //
    // ==================================================================
    // ==================================================================
    //
    // Internal methods.
    //
    // ==================================================================
    // ==================================================================
    //
    //  Public accessors methods.
    //
    // ==================================================================    
    /**
     * @return
     */
    public FileinarchiveBean 
    getFileinarchive() 
    {
        return fileinarchive;
    }

    /**
     * @param bean
     */
    public void 
    connectFileinarchive(FileinarchiveBean bean) 
    {
        fileinarchive = bean;
        connectDeployerDescription(fileinarchive);
    }

    public void
    connectLinkDeployer(LinkDeployer linkDeployer)
    {
        this.linkDeployer=linkDeployer;
    }

    public LinkDeployer
    getLinkDeployer()
    {
        return linkDeployer;
    }
    public ServerSocket 
    getServerSocket()
    {
        return getRootDeployerContext().getServerSocket();
    }    
    
    /**
     * This initialization method is used to check that all the services and 
     * information required to deploy are presents. If all is OK the deployer 
     * is put in inactive deployer state waiting for the deployment processing.
     * 
     * @exception InitializationError is thrown if a problem is detected 
     */
    public void 
    initialize() 
    throws InitializationError 
    {
        // TODO Auto-generated method stub
        if(getFileinarchive()==null)
            getErrorManager()
            .submitException(new InitializationError(this,"Connection on fileinarchive bean is required"+
                                                    "check the handler code it must specify this connection"));
        if(getZipEntryRetriever()==null)
            getErrorManager()
            .submitException(new InitializationError(this,"Connection on zipentryretriever is required"+
                                                     "check the handler code it must specify this connection"));
                                                    
        if((getFileinarchive().getName()==null||
            getFileinarchive().getName()=="")&&getLinkDeployer()==null)
              getErrorManager()
              .submitException(new InitializationError(this,"The name attribute of fileinarchive element msut be fullfilled"+
                                                       "check the fileinarchive element"+
                                                       "description\n."+getStringifiedDeployerDescription()));
                                                       
         getLifeCycleManager().stepEndedSuccessFully();       
    }


}
