/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2004 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Briclet Frdric.
Contributor(s): ______________________________________.

====================================================================*/
package org.objectweb.openccm.descriptor.softpkg.ccm;

import java.io.IOException;

import org.objectweb.openccm.descriptor.componentassembly.ccm.deployer.base.FatalDeploymentException;

/**
 * This interface describes all the information that thre deployment machine
 * want to extract from the descriptor element of csd file.
 *
 * @author <a href="mailto:briclet@lifl.fr">Briclet Frdric</a>
 *
 * @version 0.1
 */
public class DescriptorDeployer
    extends DescriptorDeployerContext
    implements DescriptorDeployerInterface {

    /* (non-Javadoc)
     * @see org.objectweb.openccm.descriptor.softpkg.ccm.DescriptorDeployerInterface#getComponentRepid()
     */
    public String getComponentRepid() throws FatalDeploymentException {
        // TODO Auto-generated method stub
        return getCorbaComponentDeployer().getComponentRepid();
    }

    /* (non-Javadoc)
     * @see org.objectweb.openccm.descriptor.softpkg.ccm.DescriptorDeployerInterface#getHomeRepid()
     */
    public String getHomeRepid() throws FatalDeploymentException {
        // TODO Auto-generated method stub
        return getCorbaComponentDeployer().getHomeRepid();
    }

    public void initializeCorbaComponentTree()
    throws CorbaComponentFileLoadingFailureException{
         
      try {
        connectCorbacomponent(
                               org.objectweb.openccm.descriptor
                                  .corbacomponent.beans.CorbacomponentBeanImpl
                                  .unmarshalBean(getFileinarchiveDeployer()
                                                 .getInputStreamReader(),true));
        } 
        catch (IOException e) {
           throw new CorbaComponentFileLoadingFailureException(this,e);
        }
    }
}
