/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2004 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Jerome Moroy.
Contributor(s):  ______________________________________.

====================================================================*/
package org.objectweb.openccm.explorer.DCI;

import java.net.URL;

import org.objectweb.openccm.OpenCCM_DCI.AssemblyFactoryManager;
import org.objectweb.util.explorer.api.TreeView;
import org.omg.Components.Deployment.AssemblyFactory;

/**
 * This <b>create</b> operation creates an Assembly object on the host
 * on which the AssemblyFactory is located. It takes a string denoting
 * the location of an assembly. The URL can be found on the local file
 * system or can be defined as a distant URL. This action has to be defined
 * for org.objectweb.openccm.OpenCCM_DCI.AssemblyFactoryManager object.
 * (section 6.9.3 of the CORBA Components Model specification)
 *
 * @author <a href="mailto:Jerome.Moroy@lifl.fr">Jerome Moroy</a>
 *
 * @version 0.1
 */
public class CreateAssembly
     extends org.objectweb.openccm.explorer.Deployment.CreateAssembly 
{

    //==================================================================
    //
    // No Internal state.
    //
    //==================================================================

    //==================================================================
    //
    // No constructor.
    //
    //==================================================================

    //==================================================================
    //
    // Internal method.
    //
    //==================================================================

    protected AssemblyFactory getAssemblyFactory(TreeView treeView){
        AssemblyFactoryManager assemblyFactoryManager = (AssemblyFactoryManager)treeView.getSelectedObject();
        return assemblyFactoryManager.provide_assembly_factory();
    }
     
}
