/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2004 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Jerome Moroy.
Contributor(s):  ______________________________________.

====================================================================*/
package org.objectweb.openccm.explorer.DCI;

import javax.swing.JOptionPane;

import org.objectweb.util.explorer.api.TreeView;
import org.omg.Components.Deployment.Assembly;

/**
 * The <b>tear_down</b> operation removes all connections between components and
 * destroys all components, homes, containers and component servers.
 * (section 6.9.4 of the CORBA Components Model specification)
 *
 * @author <a href="mailto:Jerome.Moroy@lifl.fr">Jerome Moroy</a>
 *
 * @version 0.1
 */
public class TearDown
     extends org.objectweb.openccm.explorer.Deployment.TearDown 
{

    protected Assembly getAssembly(TreeView e){
        AssemblyManagerWrapper assemblyManagerWrapper = (AssemblyManagerWrapper)e.getSelectedObject();
        return assemblyManagerWrapper.getAssemblyManager().provide_assembly();
    }

}