package ist.coach.coachEmfClientComponents.gui;


import javax.swing.JTable;
import javax.swing.table.AbstractTableModel;

import javax.swing.DefaultCellEditor;
import javax.swing.event.ListSelectionListener;
import javax.swing.ListSelectionModel;
import javax.swing.event.ListSelectionEvent;

import javax.swing.JScrollPane;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JSpinner;
import javax.swing.SpinnerNumberModel;
import javax.swing.SpinnerModel;
import javax.swing.SwingUtilities;
import javax.swing.JOptionPane;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JComboBox;
import javax.swing.JTextField;
import javax.swing.border.Border;
import javax.swing.border.EtchedBorder;
import javax.swing.border.Border;
import javax.swing.BorderFactory;
import java.awt.*;
import java.awt.event.*;

import ist.coach.coachEmfServices.EmfBasicLog.LogRecord;

public class LogArchiveFrame extends JFrame
implements ActionListener, Runnable {

	GuiMaster master;
	private LogTableModel logModel = null;
	private String[] logDaySelectionStrings = new String[31];
	private String[] logMonthSelectionStrings = {
			  "January",
			  "February",
			  "March",
			  "April",
			  "May",
			  "June",
			  "July",
			  "August",
			  "September",
			  "October",
			  "November",
			  "December"
	};
	JSpinner hoursSpinner, minSpinner, secSpinner, recordsSpinner;
	JComboBox logSelectionList, logYearSelectionList, logDaySelectionList, logMonthSelectionList;
	JTextField records_data;
	private int selectedRow, selectedCol;

	private String[] logYearSelectionStrings = {"2004", "2005", "2006"};

	public LogArchiveFrame(GuiMaster master,
		  int x_pos, int y_pos) {

		super(GuiMessages.log_archives_title);
		this.master = master;
		logModel = new LogTableModel();
					/** Setup the LOG Panel ****/
		JPanel logPanel = new JPanel();
		logPanel.setLayout(new BorderLayout());

		records_data = new JTextField(80);
		records_data.setEditable(false);
		records_data.setBackground(java.awt.Color.LIGHT_GRAY);
		java.awt.Font textDisplayFont = records_data.getFont();
		textDisplayFont = textDisplayFont.deriveFont((float) textDisplayFont.getSize()-1);
		records_data.setFont(textDisplayFont);

		JPanel logOptionsPanel = new JPanel(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT, 20, 0));

			  // set up box to hold log time options
		JPanel logDatePanel = new JPanel();
		logDatePanel.setBorder(BorderFactory.createEtchedBorder(EtchedBorder.LOWERED));
		JLabel logDayLabel =new JLabel("From Date: ");
		logDatePanel.add(logDayLabel);

		for(int i = 0; i < 31; i++)
		  logDaySelectionStrings[i] = String.valueOf(i+1);

		logDaySelectionList = new JComboBox(logDaySelectionStrings);
	    logDaySelectionList.setSelectedIndex(0);
	   // logDaySelectionList.addActionListener(this);
		logDatePanel.add(logDaySelectionList);

		logMonthSelectionList = new JComboBox(logMonthSelectionStrings);
		logMonthSelectionList.setSelectedIndex(0);
	    //logMonthSelectionList.addActionListener(this);
		logDatePanel.add(logMonthSelectionList);

		logYearSelectionList = new JComboBox(logYearSelectionStrings);
		logYearSelectionList.setSelectedIndex(0);
	    //logYearSelectionList.addActionListener(this);
		logDatePanel.add(logYearSelectionList);

		JLabel timeLabel =new JLabel("Time: ");
		JLabel timeLabel2 =new JLabel(":");

		logDatePanel.add(timeLabel);
		SpinnerModel hoursModel = new SpinnerNumberModel(00, //initial value
                                       00, //min
                                       23, //max
                                       1);
		hoursSpinner = new JSpinner(hoursModel); //getValue()
		hoursSpinner.setEditor(new javax.swing.JSpinner.NumberEditor(hoursSpinner, "00"));
        //timeLabel.setLabelFor(hoursSpinner);
		logDatePanel.add(hoursSpinner);
		logDatePanel.add(timeLabel2);

		SpinnerModel minModel = new SpinnerNumberModel(00, //initial value
                                       00, //min
                                       59, //max
                                       1);
		minSpinner = new JSpinner(minModel); //getValue()
		minSpinner.setEditor(new javax.swing.JSpinner.NumberEditor(minSpinner, "00"));
   		logDatePanel.add(minSpinner);
		JLabel timeLabel3 =new JLabel(":");
		logDatePanel.add(timeLabel3);

		SpinnerModel secModel = new SpinnerNumberModel(00, //initial value
                                       00, //min
                                       59, //max
                                       1);
		secSpinner = new JSpinner(secModel); //getValue()
		secSpinner.setEditor(new javax.swing.JSpinner.NumberEditor(secSpinner, "00"));
   		logDatePanel.add(secSpinner);

		//logOptionsPanel.add(logDatePanel);

						  // set up box to hold log name options
		JPanel logSelectionPanel = new JPanel();
		logSelectionPanel.setBorder(BorderFactory.createEtchedBorder(EtchedBorder.LOWERED));
		JLabel logSelectionLabel = new JLabel("Select Log Archive: ");
		logSelectionPanel.add(logSelectionLabel);

		String[] logSelectionStrings = master.get_all_logs();
		System.err.println("logSelectionStrings length = " + logSelectionStrings.length);
		logSelectionList = new JComboBox(logSelectionStrings);
	    //logSelectionList.setSelectedIndex(1);
	   // logSelectionList.addActionListener(this);
		logSelectionPanel.add(logSelectionList);

		logOptionsPanel.add(logSelectionPanel);

		JPanel logRecordsPanel = new JPanel();

						  // add how many records choice
		JLabel logHowManyLabel =new JLabel("Number of Records: ");
		logRecordsPanel.add(logHowManyLabel);
		SpinnerModel recordsModel = new SpinnerNumberModel(1, //initial value
                                       1, //min
                                       100, //max
                                       1);
		recordsSpinner = new JSpinner(recordsModel); //getValue()
        logHowManyLabel.setLabelFor(recordsSpinner);
		logRecordsPanel.add(recordsSpinner);

		logRecordsPanel.add(javax.swing.Box.createHorizontalGlue());
		JButton ok_button = new JButton(GuiMessages.browse_str);
        ok_button.addActionListener(this);
        ok_button.setToolTipText(GuiMessages.browse_tooltip_str);
		logRecordsPanel.add(ok_button);
		logOptionsPanel.add(logRecordsPanel);
						// Setup the log Table panel....
		JLogTable logTable = new JLogTable(logModel);

		logTable.setPreferredScrollableViewportSize(new Dimension(700, 200));
		logTable.setCellSelectionEnabled(false);
		//logTable.setAutoResizeMode(javax.swing.JTable.AUTO_RESIZE_OFF);

		logTable.getColumnModel().getSelectionModel().
			addListSelectionListener( new ListSelectionListener() {

  				public void valueChanged(ListSelectionEvent e) {

      				if(e.getValueIsAdjusting()) return;
				 	ListSelectionModel lsm = (ListSelectionModel)e.getSource();
					if (! lsm.isSelectionEmpty()) {
						selectedCol = lsm.getMinSelectionIndex();
						if (logModel.getValueAt(selectedRow, selectedCol) != null)
							records_data.setText((String) logModel.getValueAt(selectedRow, selectedCol)); 
					}
      			}
    	});
		logTable.getSelectionModel().addListSelectionListener(new ListSelectionListener() {

  			public void valueChanged(ListSelectionEvent e) {

      				if(e.getValueIsAdjusting()) return;
				 	ListSelectionModel lsm = (ListSelectionModel)e.getSource();
					if (! lsm.isSelectionEmpty()) {
						selectedRow = lsm.getMinSelectionIndex();
						if (logModel.getValueAt(selectedRow, selectedCol) != null)
							records_data.setText((String) logModel.getValueAt(selectedRow, selectedCol)); 
					}
			} 
			}
		);

		logTable.getColumnModel().getColumn(AlarmTableModel.TIME_C).setPreferredWidth(120);
		logTable.getColumnModel().getColumn(AlarmTableModel.EVENT_C).setPreferredWidth(100);
		logTable.getColumnModel().getColumn(AlarmTableModel.SOURCE_C).setPreferredWidth(200);
		logTable.getColumnModel().getColumn(AlarmTableModel.SOURCE_T_C).setPreferredWidth(100);
		logTable.getColumnModel().getColumn(AlarmTableModel.ID_C).setPreferredWidth(60);
		logTable.getColumnModel().getColumn(AlarmTableModel.DETAILS_C).setPreferredWidth(120);

        JScrollPane scrollPane = new JScrollPane(logTable);

        scrollPane.setPreferredSize(new Dimension(700, 350));
        scrollPane.setMinimumSize(new Dimension(10, 10));

		JPanel logParamPanel = new JPanel();
		logParamPanel.setLayout(new java.awt.GridLayout(2, 1, 0, 0));

		logParamPanel.add(logDatePanel);
		logParamPanel.add(logOptionsPanel);
		logPanel.add(logParamPanel, BorderLayout.NORTH);

		logPanel.add(scrollPane, BorderLayout.CENTER);
		logPanel.add(records_data, BorderLayout.SOUTH);
        logPanel.setBorder(BorderFactory.createTitledBorder(GuiMessages.gui_client_log));

	    getContentPane().add(logPanel, BorderLayout.CENTER);
			  /* add window control */
		setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
		/********
		addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
                this.dispose();
            }
        });
		********/
		setLocation(x_pos, y_pos);
        pack();
        setVisible(true);
	}

	public void run() {}

	public void actionPerformed(ActionEvent e) {

		JButton source = (JButton) (e.getSource());
		if (source.getText().equals(GuiMessages.browse_str)) {
/************************
            System.err.println("Browse button pressed");
			System.err.println("Day Selection = " + logDaySelectionList.getSelectedItem()
					  + "(" + logDaySelectionList.getSelectedIndex() + ")");
			System.err.println("Month Selection = " + logMonthSelectionList.getSelectedItem()
					  + "(" + logMonthSelectionList.getSelectedIndex() + ")");
			System.err.println("Year Selection = " + logYearSelectionList.getSelectedItem()
					  + "(" + logYearSelectionList.getSelectedIndex() + ")");
			System.err.println("Hour Selection = " + hoursSpinner.getValue());
			System.err.println("Secs Selection = " + minSpinner.getValue());
			System.err.println("Min Selection = " + secSpinner.getValue());
			System.err.println("Records Selection = " + recordsSpinner.getValue());
			System.err.println("Logs Selection = " + logSelectionList.getSelectedItem()
					  + "(" + logSelectionList.getSelectedIndex() + ")");
********/

			java.text.DecimalFormat df1 = new java.text.DecimalFormat("00");
			String requested_date = df1.format(
			    (int) logDaySelectionList.getSelectedIndex() + 1);

			requested_date += "/";

			requested_date +=df1.format(logMonthSelectionList.getSelectedIndex() + 1);

			requested_date += "/";
			requested_date +=logYearSelectionList.getSelectedItem() + " ";

			requested_date += hoursSpinner.getValue() + ":" +
							  minSpinner.getValue()	 + ":" +
							secSpinner.getValue();

			//System.err.println("Requested Date is " + requested_date);

			java.text.SimpleDateFormat formatter =
				    new java.text.SimpleDateFormat ("dd/MM/yyyy HH:mm:ss");
			//java.util.Date currentTime_1 = new java.util.Date();
			//String dateString = formatter.format(currentTime_1);

			// Parse the previous string back into a Date.
			java.text.ParsePosition pos = new java.text.ParsePosition(0);
			java.util.Date requestedDateObj =  formatter.parse(requested_date, pos);
			//System.err.println("requested date = " + requestedDateObj + "(" +
			//			requestedDateObj.getTime() +")");
							
			//java.sql.Timestamp logTimestamp = new java.sql.Timestamp(requestedDateObj.getTime());
			//String logTimestampStr = logTimestamp.toString();
			//System.err.println("my date = " + requestedDateObj + ", timestamp = " +
			//	 logTimestampStr );

			int num_of_records = ((Integer) recordsSpinner.getValue()).intValue();
			//System.err.println("num_of_records = " + num_of_records);
			LogRecord[] records = master.retrieve_logs(
					(String) logSelectionList.getSelectedItem(),
				    requestedDateObj.getTime(),
					num_of_records);
					//Integer.parseInt((String) recordsSpinner.getValue()));
			//System.err.println("LogArchiveFrame> LogRecords recieved = " + records.length);
			logModel.clear();
			logModel.updateLogArchives(records);
			records_data.setText(records.length + " records retrieved...");


        }

	}
}
