package ist.coach.coachEmfClientComponents.gui;

import javax.swing.ImageIcon;

import intt.itu.itut_x780.ManagedObjectValueType;
import ist.coach.coachEmsMib.IpAddressDataValueType;
import ist.coach.coachEmfClientComponents.InvokeSetData;

import ist.coach.coachEmfCommon.Utils;
public class VisualIpAddressData
extends MOTreeObject {

    static String[] subordinate_names = new String[0];

    static boolean canRefresh = false;
    static String object_type = "IpAddressData";
    static String emsClassName = "ist.coach.coachEmsMib.IpAddressData_F";

	static String DISPLAY_TYPE = "IP Address Data";

	//
    // create arguments
    //
    static String[] create_arg_name =  new String[0];
    static String[] create_arg_editor =  new String[0];
    static String[] create_arg_renderer =  new String[0];
    //
    // get/set arguments
    //

    static String[] attributes_name = {     //ManagedObject
                                        "Name",
                                        "Element Type",
                                        "Creation Source",
                                        "Delete Policy",
											//IpAddressData
										"IP Address",
										"Logical Interface Index",
										"Subnet Mask",
										"Least Significant Bit of Broadcast Address",
										"Max Re-assemble Size"
					};

	 static boolean[] attributes_readonly =  {
						  //ManagedObject
                    false,
                    false,
                    false,
                    false,
						  //IpAddressData
                    false,
					false,
					false,
					false,
					false
	};

	public VisualIpAddressData(String key) {
		super(key);
		leafIcon = new ImageIcon(VisualIpAddressData.class.getResource(
                "images/ipaddressdata_icon.gif"));
		nodeIcon = new ImageIcon(VisualIpAddressData.class.getResource(
                "images/ipaddressdata_icon.gif"));
		 toolTipText = new String(DISPLAY_TYPE);
	}

	public Object[] translate_values(ManagedObjectValueType original_value_type) {

		Object[] values = new Object[attributes_name.length];
        for (int i = 0; i < values.length; i++)
            values[i] = "unspecified";

        if (original_value_type == null)
            return values;

        Object[] mo_values = super.translate_values(original_value_type);
        int i = 0;
        for (i = 0; i < mo_values.length; i++)
            values[i] = mo_values[i];

		IpAddressDataValueType value_type;
        value_type = (IpAddressDataValueType) original_value_type;

		if (value_type.ipAdEntAddr != null && value_type.ipAdEntAddr.length > 0)
		  values[i] = new String(value_type.ipAdEntAddr);
		i++;

		values[i++] = String.valueOf(value_type.ipAdEntIfIndex);

		if (value_type.ipAdEntNetMask != null && value_type.ipAdEntNetMask.length > 0)
		  values[i] = new String(value_type.ipAdEntNetMask);
		i++;

		switch(value_type.ipAdEntBcastAddr) {
		case 1:
			values[i++] = new String("Internet standard all-ones");
			break;
		default:
			values[i++] = String.valueOf(value_type.ipAdEntBcastAddr);
			break;
		}
		if (value_type.ipAdEntReasmMaxSize > 0)
		  values[i++] = String.valueOf(value_type.ipAdEntReasmMaxSize);

		return values;
    }

    java.util.Vector translate_updates(java.util.Hashtable values) {

		return new java.util.Vector();
	}
}
