package ist.coach.coachEmfClientComponents.gui;

import javax.swing.ImageIcon;

import intt.itu.itut_x780.ManagedObjectValueType;
import intt.itu.itut_x780.AdministrativeStateType;
import intt.itu.itut_x780.OperationalStateType;
import intt.itu.itut_x780.UsageStateType;
import intt.itu.itut_m3120.ManagedElementValueType;
import ist.coach.coachEmfClientComponents.InvokeSetData;

import ist.coach.coachEmfCommon.Utils;
public class VisualManagedElement
extends MOTreeObject {

	static String[] subordinate_names = new String[0];
	//static String[] subordinate_names = { "ManagedObject", "ManagedElement", "IpNode"};
	//static String[] subordinate_vtype = { "MOTreeObject", "VisualManagedElement",
	//													"VisualIpNode"};
		// HACK
		// This must be the type declared in idl as objectClass!!!!!
	static String object_type = "ManagedElement";
	static String emsClassName = "intt.itu.itut_m3120.ManagedElement_F";

	static String DISPLAY_TYPE = "ManagedElement";
	//
	// create arguments
	//
	static String[] create_arg_name = {"Name",
									    "User Label",
										"Product Vendor",
										"Product Version",
										"Location"
										};
	static String[] create_arg_editor = { "", ""};
	static String[] create_arg_renderer = { "", ""};
	//
	// get/set arguments
	//

			//
			// settable arguments
			//
	static int ADMIN_POS = 4;
	static int LABEL_POS = 7;
	static int VENDOR_POS = 8;
	static int VERSION_POS = 9;
	static int LOCATION_POS = 10;

	static String[] attributes_name = {"Name",
										"Element Type",
                                        "Creation Source",
                                        "Delete Policy",
										"Administrative State",
										"Operational State",
										"Usage State",
										"User Label",
										"Product Vendor",
                                        "Product Version",
                                        "Location"
									};
	static boolean[] attributes_readonly = {false,
											false,
											false,
											false,
											true,
											false,
											false,
											true,
											true,
											true,
											true
											};

public VisualManagedElement(String key) {

	super(key);
	leafIcon = new ImageIcon(VisualManagedElement.class.getResource(
				"images/managedobject_icon.gif"));
	nodeIcon = new ImageIcon(VisualManagedElement.class.getResource(
					"images/managedobject_icon.gif"));
	toolTipText = new String(DISPLAY_TYPE);


}

	public Object[] translate_values(ManagedObjectValueType original_value_type) {

		Object[] values = new Object[attributes_name.length];
		for (int i = 0; i < values.length; i++)
			values[i] = "unspecified";

		if (original_value_type == null)
			return values;

		Object[] mo_values = super.translate_values(original_value_type);
		int i = 0;
		for (i = 0; i < mo_values.length; i++)
			values[i] = mo_values[i];

		ManagedElementValueType value_type;
		value_type = (ManagedElementValueType) original_value_type;

		switch(value_type.administrativeState.value()) {
			case AdministrativeStateType._locked :
				values[i++] = new String("Locked");
				break;
			case AdministrativeStateType._unlocked :
				values[i++] = new String("Unlocked");
				break;
			case AdministrativeStateType._shuttingDown :
				values[i++] = new String("Shutting Down");
				break;
			default:
				values[i++] = new String("Unknown");
		}

		switch(value_type.operationalState.value()) {
			case OperationalStateType._disabled :
				values[i++] = new String("Disabled");
				 break;
            case OperationalStateType._enabled :
				values[i++] = new String("Enabled");
				break;
			default:
                values[i++] = new String("Unknown");
        }

		switch(value_type.usageState.value()) {
            case UsageStateType._idle :
                values[i++] = new String("Disabled");
                 break;
            case UsageStateType._active :
                values[i++] = new String("Active");
                break;
            case UsageStateType._busy :
                values[i++] = new String("Busy");
                break;
            default:
                values[i++] = new String("Unknown");
        }

		String userLabel = value_type.userLabel;
		if (userLabel != null && userLabel.length() > 0)
			values[i] = new String(userLabel);
		i++;

		String vendorName = value_type.vendorName;
		if (vendorName != null && vendorName.length() > 0)
			values[i] = new String(vendorName);
		i++;

		String version = value_type.version;
		if (version != null && version.length() > 0)
			values[i] = new String(version);
		i++;

		String locationName = value_type.locationName;
		if (locationName != null && locationName.length() > 0)
			values[i] = new String(locationName);
		i++;

		return values;
	}

	java.util.Vector translate_updates(java.util.Hashtable values) {

		java.util.Vector updates = new java.util.Vector();
		org.omg.CosNaming.NameComponent[] objectName = Utils.string2name(key);

		if (values.containsKey(attributes_name[ADMIN_POS])) {

			intt.itu.itut_x780.AdministrativeStateType a_type;

			String attr_value = (String) values.get(attributes_name[ADMIN_POS]);

			if (attr_value.equalsIgnoreCase("shuttingdown")) {
				a_type = intt.itu.itut_x780.AdministrativeStateType.shuttingDown;
			}
			else
			if (attr_value.equalsIgnoreCase("unlocked")) {
				a_type = intt.itu.itut_x780.AdministrativeStateType.unlocked;
			}
			else
				a_type = intt.itu.itut_x780.AdministrativeStateType.locked;

			Object[] arg_val = {objectName, a_type};

			InvokeSetData data_set = new InvokeSetData(emsClassName,
							"administrativeStateSet",
							arg_val
						);

			updates.add(data_set);
		}

		if (values.containsKey(attributes_name[LABEL_POS])) {

		 	String attr_value = (String) values.get(attributes_name[LABEL_POS]);
			Object[] arg_val = {objectName, attr_value};
			InvokeSetData data_set = new InvokeSetData(emsClassName,
							"userLabelSet",
							arg_val
			);
			updates.add(data_set);
		}
		if (values.containsKey(attributes_name[VENDOR_POS])) {

            String attr_value = (String) values.get(attributes_name[VENDOR_POS]);
            Object[] arg_val = {objectName, attr_value};
            InvokeSetData data_set = new InvokeSetData(emsClassName,
							"vendorNameSet",
                            arg_val
            );
            updates.add(data_set);
        }

		if (values.containsKey(attributes_name[VERSION_POS])) {

            String attr_value = (String) values.get(attributes_name[VERSION_POS]);
            Object[] arg_val = {objectName, attr_value};
            InvokeSetData data_set = new InvokeSetData(emsClassName,
							"versionSet",
                            arg_val
            );
            updates.add(data_set);
        }
		if (values.containsKey(attributes_name[LOCATION_POS])) {

            String attr_value = (String) values.get(attributes_name[LOCATION_POS]);
            Object[] arg_val = {objectName, attr_value};
            InvokeSetData data_set = new InvokeSetData(emsClassName,
						"locationNameSet",
                            arg_val
            );
            updates.add(data_set);
        }

            return updates;
    }

}
