package ist.coach.coachEmfClientComponents.gui;

import javax.swing.ImageIcon;

import intt.itu.itut_x780.ManagedObjectValueType;
import ist.coach.coachEmsMib.IpProtocolMonitorValueType;
import ist.coach.coachEmfClientComponents.InvokeSetData;

import ist.coach.coachEmfCommon.Utils;
public class VisualIpProtocolMonitor
extends MOTreeObject {

    static String[] subordinate_names = new String[0];

    static boolean canRefresh = false;
    static String object_type = "IpProtocolMonitor";
    static String emsClassName = "ist.coach.coachEmsMib.IpProtocolMonitor_F";

	static String DISPLAY_TYPE = "IP Protocol Monitor";

	    //
    // create arguments
    //
    static String[] create_arg_name =  new String[0];
    static String[] create_arg_editor =  new String[0];
    static String[] create_arg_renderer =  new String[0];
    //
    // get/set arguments
    //

    static String[] attributes_name = {         //ManagedObject
                                        "Name",
                                        "Element Type",
                                        "Creation Source",
                                        "Delete Policy",
											//IpProtocolMonitor
										"IP Forwarding",
										"Outgoing Default TTL",
										"Incoming IP Datagrams Received",
										"Incoming IP datagrams Discarded due to IP Header Errors",
										"Incoming IP datagrams Discarded due to Address Errors",
										"Incoming IP datagrams Forwarded",
										"Incoming IP datagrams Discarded due to Unknown Protocols",
										"Incoming IP datagrams Discarded not due to Error",
										"Incoming IP datagrams Delivered",
										"Outgoing IP datagrams Received",
										"Outgoing IP datagrams Discarded not due to Error",
										"Outgoing IP datagrams Discarded due to Destination Routing Errors",
										"Maximum IP datagram Reassembly Time",
										"IP datagrams Needing Reassembly",
										"Successfully Reassembled IP datagrams",
										"IP Layer Reassembly Failures",
										"Successfully Fragmented IP datagrams",
										"Failed to Fragment IP datagrams",
										"IP Fragments",
										"IP datagrams Discarded due to Routing Errors"
					};

	 static boolean[] attributes_readonly =  {
                    false,
                    false,
                    false,
                    false,
                    false,
                    false,
                    false,
                    false,
                    false,
                    false,
                    false,
                    false,
                    false,
                    false,
                    false,
                    false,
                    false,
                    false,
                    false,
                    false,
                    false,
                    false,
                    false,
                    false
    };

	public VisualIpProtocolMonitor(String key) {
		super(key);
		leafIcon = new ImageIcon(VisualIpProtocolMonitor.class.getResource(
                "images/protocol_icon.gif"));
		nodeIcon = new ImageIcon(VisualIpProtocolMonitor.class.getResource(
                "images/protocol_icon.gif"));
		 toolTipText = new String(DISPLAY_TYPE);
	}

	public Object[] translate_values(ManagedObjectValueType original_value_type) {

		Object[] values = new Object[attributes_name.length];
        for (int i = 0; i < values.length; i++)
            values[i] = "unspecified";

        if (original_value_type == null)
            return values;

        Object[] mo_values = super.translate_values(original_value_type);
        int i = 0;
        for (i = 0; i < mo_values.length; i++)
            values[i] = mo_values[i];

		IpProtocolMonitorValueType value_type;
        value_type = (IpProtocolMonitorValueType) original_value_type;

		switch(value_type.ipForwarding) {
		case 2: 
			values[i++] = new String("Off");	
			break;
		case 1:
			values[i++] = new String("On");
			break;
		default:
			values[i++] = new String("Unknown");
			break;
		}

		if (value_type.ipDefaultTTL >= 0)
			values[i] = String.valueOf(value_type.ipDefaultTTL);
		i++;

		values[i++] = String.valueOf(value_type.ipInReceives);
		values[i++] = String.valueOf(value_type.ipInHdrErrors);
		values[i++] = String.valueOf(value_type.ipInAddrErrors);
		values[i++] = String.valueOf(value_type.ipForwDatagrams);
		values[i++] = String.valueOf(value_type.ipInUnknownProtos);
		values[i++] = String.valueOf(value_type.ipInDiscards);
		values[i++] = String.valueOf(value_type.ipInDelivers);
		values[i++] = String.valueOf(value_type.ipOutRequests);
		values[i++] = String.valueOf(value_type.ipOutDiscards);
		values[i++] = String.valueOf(value_type.ipNoRoutes);
		values[i++] = String.valueOf(value_type.ipReasmTimeout);
		values[i++] = String.valueOf(value_type.ipReasmReqds);
		values[i++] = String.valueOf(value_type.ipReasmOKs);
		values[i++] = String.valueOf(value_type.ipReasmFails);
		values[i++] = String.valueOf(value_type.ipFragsOKs);
		values[i++] = String.valueOf(value_type.ipFragFails);
		values[i++] = String.valueOf(value_type.ipFragCreates);
		values[i++] = String.valueOf(value_type.ipRoutingDiscards);

		return values;
    }

    java.util.Vector translate_updates(java.util.Hashtable values) {

		return new java.util.Vector();
	}
}
