package ist.coach.coachEmfCommon;

import org.omg.CosNaming.NameComponent;

public class Utils {

	private static org.omg.CORBA.ORB orb = org.objectweb.ccm.CORBA.TheORB.getORB();

	public static NameComponent[] string2name(String name_s) {

        java.util.StringTokenizer depth_st, kind_st;
        depth_st = new java.util.StringTokenizer(name_s, "/");

        java.util.Vector name_seq_v = new java.util.Vector();
        String token_str = null, token_name = null, token_kind = null;
        for(int pos = 0; depth_st.hasMoreTokens(); pos++) {

            token_str = depth_st.nextToken();
            kind_st = new java.util.StringTokenizer(token_str, ".");

            if (token_str.startsWith(".")) {
                token_name = new String();
                token_kind = kind_st.nextToken();
            }
            else {
                if (kind_st.hasMoreTokens())
                    token_name = kind_st.nextToken();
                else
                    token_name = new String();

                if (kind_st.hasMoreTokens())
                    token_kind = kind_st.nextToken();
                else
                    token_kind = new String();
            }

            name_seq_v.add(new NameComponent(token_name, token_kind));
            //name_seq[pos] = new NameComponent(token_name, token_kind);
        }

        NameComponent[] name_seq = new NameComponent[name_seq_v.size()];
        name_seq_v.copyInto(name_seq);
        return name_seq;
    }
    public static String name2string(NameComponent[] name) {

        String name_str = new String();
        for (int i = 0; i < name.length; i++) {
            name_str = name_str.concat(name[i].id + "." + name[i].kind);
            if (i < name.length -1 ) {
                name_str = name_str.concat("/");
            }
        }
        return name_str;
    }

	/* The kind represents the object type and is located in the name as
	 * the kind of the before last name component. Note that last contains
	 * facade id information.
	 */
	public static String name2kind(String name) {

		int delimEnd = name.lastIndexOf("/");
		if (delimEnd < 0) {
			//return new String();
			//This is assumed to be a local root object
			return new String("Organization");
		}

		int delimStart = name.substring(0, delimEnd).lastIndexOf(".");

		if (delimStart < 0)
			return new String();

		return name.substring(delimStart+1, delimEnd);
	}

	public static String name2id(String name) {

		int delimEnd = name.lastIndexOf("/");
		if (delimEnd < 0) {
            return new String();
		}
		delimEnd = name.substring(0, delimEnd).lastIndexOf(".");
		int delimStart =  name.substring(0, delimEnd).lastIndexOf("/");

		if (delimStart < 0)
            return new String();

        return name.substring(delimStart+1, delimEnd);

	}

	/* The name of each object ends with a context that identifies the facade.
		In detail, the last id should be "null" and the kind should contain
		the identifier of the Facade. Remember that facades register directly under
        the local root context, with id=FACADE and kind=the facade identifier
    */
	public static String name2facade(String name) {

		int delimEnd = name.lastIndexOf("/");
        if (delimEnd < 0) {
            return new String();
            //This is assumed to be a local root object
		}

		int delimStart = name.lastIndexOf(".");
		return name.substring(delimStart+1);
	}

	public static  boolean isChild(NameComponent[] child, NameComponent[] parent) {

		for (int i = 0; i < parent.length - 2; i++) {
			if (! (child[i].id.equals(parent[i].id)) ||
			  ! (child[i].kind.equals(parent[i].kind))) {

			  		  return false;
			}
		}

		return true;
    }

	public static boolean packageIsSupported(
        String packageName,
		String[] supportedPackages) {

		boolean isSupported = false;
		for (int i = 0; i < supportedPackages.length; i++) {
            if (supportedPackages[i].equals(packageName)) {
                isSupported = true;
                break;
            }
        }

        return isSupported;


	}

	public static synchronized void
	pretty_log(ist.coach.coachEmfServices.EmfBasicLog.BasicLog logger,
		  String source, String sourceClass, short severity, String info) {

		org.omg.CORBA.Any record = orb.create_any();
		record.insert_string(info);
		ist.coach.coachEmfServices.EmfBasicLog.NVPair[] log_data = new ist.coach.coachEmfServices.EmfBasicLog.NVPair[3];

		log_data[0] = new ist.coach.coachEmfServices.EmfBasicLog.NVPair();
		log_data[0].name = "Source";
		org.omg.CORBA.Any name_value = orb.create_any();
		name_value.insert_string(source);
		log_data[0].value = name_value;

		log_data[1] = new ist.coach.coachEmfServices.EmfBasicLog.NVPair();
		log_data[1].name = "EventType";
		org.omg.CORBA.Any type_value = orb.create_any();
		type_value.insert_short(severity);
		log_data[1].value = type_value;

		log_data[2] = new ist.coach.coachEmfServices.EmfBasicLog.NVPair();
		log_data[2].name = "SourceClass";
		org.omg.CORBA.Any class_value = orb.create_any();
		class_value.insert_string(sourceClass);
		log_data[2].value = class_value;

		try {
		  logger.write_record(record, log_data);
		//System.err.println("pretty_log is called!..Logger is invoked OK");
		}
		catch(ist.coach.coachEmfServices.EmfBasicLog.LogFull fullEx) {
		  System.err.println("EmfBasicLog.LogFull Exception caught");
		}
		catch(ist.coach.coachEmfServices.EmfBasicLog.LogOffDuty dutyEx) {
		  System.err.println("EmfBasicLog.LogOffDuty Exception caught");
		}
		catch(ist.coach.coachEmfServices.EmfBasicLog.LogLocked lockedEx) {
		  System.err.println("EmfBasicLog.LogLocked Exception caught");
		}
		catch(ist.coach.coachEmfServices.EmfBasicLog.LogDisabled disabledEx) {
		  System.err.println("EmfBasicLog.LogDisabled Exception caught");
		}


	}
}
