/*====================================================================

This file was produced by the OpenCCM CIF_JIMPL generator.

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2003 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Christophe Demarey.
Contributor(s): ______________________________________.

====================================================================*/

package ist.coach.coachEmsMibComponents.IpToMACAddressProviderComposition;

import intt.itu.itut_x780.UIDType;
import intt.itu.itut_x780.CreateError;
import intt.itu.itut_x780.ApplicationError;
import intt.itu.itut_x780.SourceIndicatorType;
import intt.itu.itut_x780.AttributeValueType;

import ist.coach.coachEmfCommon.Utils;

import ist.coach.coachEmfCommon.ObjectDeletionImpl;
import ist.coach.coachEmfCommon.ExceptionMessages;

import ist.coach.coachEmfCommon.ApplicationErrorInfoTypeImpl;
import ist.coach.coachEmfCommon.DataTypeImpl;
import ist.coach.coachEmfServices.SnmpAdapter.DataType;
import ist.coach.coachEmfServices.SnmpAdapter.SnmpApplicationError;

import ist.coach.coachEmsMib.IpToMACAddressValueType;
import ist.coach.coachEmsCommon.SnmpIdentifiers;
import ist.coach.coachEmsCommon.IpToMACAddressValueTypeImpl;
import ist.coach.coachEmfServices.EmfBasicLog.*;
import org.omg.CosNaming.NameComponent;
import org.omg.CORBA.TCKind;

import org.opennms.protocols.snmp.SnmpSMI;

import java.util.Hashtable;

/**
 *  This is the CIDL-based implementation of the
 *  OMG IDL3 IDL:coach.ist/coachEmsMibComponents/IpToMACAddressProvider:1.0 component type.
 *
 *  @author OpenCCM CIF_Jimpl Compiler.
 */
public class IpToMACAddressProviderImpl
     extends ist.coach.coachEmsMibComponents.IpToMACAddressProviderComposition.IpToMACAddressProvider_impl
{
	org.omg.CORBA.ORB orb = null;
    private String _facade_name;

    protected static  Hashtable elements;
	private static int notifId = 15000;
	private BasicLog logSupport;

    ist.coach.coachEmfServices.SnmpAdapter.SnmpConnector connector = null;

	private static final String READ_COMMUNITY = SnmpIdentifiers.READ_COMMUNITY;
	private static final String WRITE_COMMUNITY = SnmpIdentifiers.WRITE_COMMUNITY;
    // ==================================================================
    //
    // Internal states.
    //
    // ==================================================================

    // ==================================================================
    //
    // Constructors.
    //
    // ==================================================================

    public IpToMACAddressProviderImpl()
    {
	  elements = new Hashtable();
    }
    //
    //  IDL:omg.org/Components/EnterpriseComponent/configuration_complete:1.0
    //
    /**
     **  Completes the component configuration.
     **
     **  @throws org.omg.Components.InvalidConfiguration
     **          Thrown if the configuration is invalid.
     **/
    public void
    configuration_complete()
    throws org.omg.Components.InvalidConfiguration
    {
        //
        //  DONE : implement !!!
        //

		if ((connector = get_context().get_connection_connector()) == null)
            throw new org.omg.Components.InvalidConfiguration();
		if ((logSupport = get_context().get_connection_basic_log()) == null)
			throw new org.omg.Components.InvalidConfiguration();

		orb = org.objectweb.ccm.CORBA.TheORB.getORB();

        System.err.println("IpToMACAddressProvider configuration completed...");

    }
    // ==================================================================
    //
    // Methods.
    //
    // ==================================================================

    /**
     * Implementation of the ::itut_x780Components::CCM_NamedComponent_Executor::facade_name attribute as accessor operation.
     */
    public String
    facade_name()
    {
         //
        // DONE : Implement
        //
        return _facade_name;
    }

    /**
     * Implementation of the ::itut_x780Components::CCM_NamedComponent_Executor::facade_name attribute as mutator operation.
     */
    public void
    facade_name(String val)
    {
        //
        //  DONE : implement
        //
		if (val != null)
            _facade_name = new String(val);
    }

    /**
     * Implementation of the ::coachEmsMib::IpToMACAddress_F::ipNetToMediaIfIndexGet operation.
     */
    public int
    ipNetToMediaIfIndexGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        // DONE : Implement
        //

		String key = Utils.name2string(name);

		if (elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		IpToMACAddressDataStructure data =
			(IpToMACAddressDataStructure) elements.get(key);


		return data.getipNetToMediaIfIndex();
    }

    /**
     * Implementation of the ::coachEmsMib::IpToMACAddress_F::ipNetToMediaIfIndexSet operation.
     */
    public void
    ipNetToMediaIfIndexSet(org.omg.CosNaming.NameComponent[] name, int ipNetToMediaIfIndex)
    throws intt.itu.itut_x780.ApplicationError,

           ist.coach.coachEmsMib.NOipToMACAddressSetPackageException
    {
        //
        // TODO : Implement
        //
    }

    /**
     * Implementation of the ::coachEmsMib::IpToMACAddress_F::ipNetToMediaPhysAddressGet operation.
     */
    public byte[]
    ipNetToMediaPhysAddressGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
  	    String key = Utils.name2string(name);

		if (elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		IpToMACAddressDataStructure data =
			(IpToMACAddressDataStructure) elements.get(key);


		String mediaIfIndex = String.valueOf(data.getipNetToMediaIfIndex());
		String mediaNetAddress = new String(data.getipNetToMediaNetAddress());

		String attributeOID = SnmpIdentifiers.IP_NETTOMEDIAPHYSADDRESS_OID + "." +
							  mediaIfIndex + "." + mediaNetAddress;
		DataType attributeData = null;

		try {
			attributeData = connector.get(
				attributeOID,
				new String (data.getMgmtIpAddress()),
				data.getSnmpPort(),
				SnmpIdentifiers.READ_COMMUNITY);
		}
		catch (SnmpApplicationError e) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			if (e.reason.equals(ExceptionMessages.agent_response_error))
				error_code.details = ExceptionMessages.agent_response_error;
			else
				error_code.details = new String ("Could not retrieve attribute " +
					"for IpToMACAddress Object with name " + key + ":" +
					"\n Object with Snmp Object Identifier " + attributeOID +
								" does not exist.");

			Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
			  (short) LogSeverity._Error,
			  "SNMP Error getting ipNetToMediaPhysAddress: " + e.reason);
			throw new ApplicationError (error_code);
		}

		org.omg.CORBA.Any value = attributeData.value;


		if (value.type().kind().value() != org.omg.CORBA.OctetSeqHelper.type().kind().value()) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String ("IpToMACAddress> Could not retrieve attribute " +
				"for IpToMACAddress Object with name " + key + ":" +
				"\n Object with Snmp Object Identifier " + attributeOID +
				" is not of expected type.");

			throw new ApplicationError (error_code);

		}

		byte[] attribute_value = org.omg.CORBA.OctetSeqHelper.extract(value);
		return attribute_value;
    }

    /**
     * Implementation of the ::coachEmsMib::IpToMACAddress_F::ipNetToMediaPhysAddressSet operation.
     */
    public void
    ipNetToMediaPhysAddressSet(org.omg.CosNaming.NameComponent[] name, byte[] ipNetToMediaPhysAddress)
    throws intt.itu.itut_x780.ApplicationError,

           ist.coach.coachEmsMib.NOipToMACAddressSetPackageException
    {

    }

    /**
     * Implementation of the ::coachEmsMib::IpToMACAddress_F::ipNetToMediaNetAddressGet operation.
     */
    public byte[]
    ipNetToMediaNetAddressGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
       //
        // DONE : Implement
        //

		String key = Utils.name2string(name);

		if (elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		IpToMACAddressDataStructure data =
			(IpToMACAddressDataStructure) elements.get(key);


		return data.getipNetToMediaNetAddress();
    }

    /**
     * Implementation of the ::coachEmsMib::IpToMACAddress_F::ipNetToMediaNetAddressSet operation.
     */
    public void
    ipNetToMediaNetAddressSet(org.omg.CosNaming.NameComponent[] name, byte[] ipNetToMediaNetAddress)
    throws intt.itu.itut_x780.ApplicationError,

           ist.coach.coachEmsMib.NOipToMACAddressSetPackageException
    {
        //
        // TODO : Implement
        //
    }

    /**
     * Implementation of the ::coachEmsMib::IpToMACAddress_F::ipNetToMediaTypeGet operation.
     */
    public int
    ipNetToMediaTypeGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {

	    String key = Utils.name2string(name);

		if (elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		IpToMACAddressDataStructure data =
			(IpToMACAddressDataStructure) elements.get(key);


		String mediaIfIndex = String.valueOf(data.getipNetToMediaIfIndex());
		String mediaNetAddress = new String(data.getipNetToMediaNetAddress());

		String attributeOID = SnmpIdentifiers.IP_NETTOMEDIATYPE_OID + "." +
							  mediaIfIndex + "." + mediaNetAddress;
		DataType attributeData = null;

		try {
			attributeData = connector.get(

				attributeOID,
				new String (data.getMgmtIpAddress()),
				data.getSnmpPort(),
				SnmpIdentifiers.READ_COMMUNITY);
		}
		catch (SnmpApplicationError e) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			if (e.reason.equals(ExceptionMessages.agent_response_error))
				error_code.details = ExceptionMessages.agent_response_error;
			else
				error_code.details = new String ("Could not retrieve attribute " +
					"for IpToMACAddress Object with name " + key + ":" +
					"\n Object with Snmp Object Identifier " + attributeOID +
					" does not exist.");

			Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
			  (short) LogSeverity._Error,
			  "SNMP Error getting ipNetToMediaType: " + e.reason);
			throw new ApplicationError (error_code);
		}

		org.omg.CORBA.Any value = attributeData.value;


		if (value.type().kind().value() != TCKind._tk_long) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String ("IpToMACAddress> Could not retrieve attribute " +
				"for IpToMACAddress Object with name " + key + ":" +
				"\n Object with Snmp Object Identifier " + attributeOID +
				" is not of expected type.");
			/***if (value.type().kind().value() == TCKind._tk_string) {
				System.err.println("attribute = " +value.extract_string());
				return -1;
			}
			else
			******/
			throw new ApplicationError (error_code);

		}

		int attribute_value = value.extract_long();
		return attribute_value;
    }

    /**
     * Implementation of the ::coachEmsMib::IpToMACAddress_F::ipNetToMediaTypeSet operation.
     */
    public void
    ipNetToMediaTypeSet(org.omg.CosNaming.NameComponent[] name, int ipNetToMediaType)
    throws intt.itu.itut_x780.ApplicationError,

           ist.coach.coachEmsMib.NOipToMACAddressSetPackageException
    {
        //
        // TODO : Implement
        //
    }

    /**
     * Implementation of the ::itut_x780::ManagedObject_F::nameGet operation.
     */
    public org.omg.CosNaming.NameComponent[]
    nameGet()
    {
        return Utils.string2name(_facade_name);
    }

    /**
     * Implementation of the ::itut_x780::ManagedObject_F::objectClassGet operation.
     */
    public String
    objectClassGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
         //
        //  DONE : implement
        //
		String key = Utils.name2string(name);

		if (elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		IpToMACAddressDataStructure data =
			(IpToMACAddressDataStructure) elements.get(key);

		return data.getObjectClass();
    }

    /**
     * Implementation of the ::itut_x780::ManagedObject_F::attributesGet operation.
     */
    public intt.itu.itut_x780.ManagedObjectValueType
    attributesGet(org.omg.CosNaming.NameComponent[] name, intt.itu.itut_x780.StringSetTypeHolder attributeNames)
    throws intt.itu.itut_x780.ApplicationError
    {
      //
        //  DONE : implement
        //
		String key = Utils.name2string(name);

		if (elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}
		IpToMACAddressDataStructure data =
			(IpToMACAddressDataStructure) elements.get(key);

			IpToMACAddressValueTypeImpl ipToMACAddressValueType = new IpToMACAddressValueTypeImpl(
				ipNetToMediaIfIndexGet(name),
				ipNetToMediaPhysAddressGet(name),
				ipNetToMediaNetAddressGet(name),
				ipNetToMediaTypeGet(name),
				data.getName(),
				data.getObjectClass(),
				data.getPackages(),
				data.getSourceIndicator(),
				data.getDeletePolicy()
			);

	  Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
			(short) LogSeverity._Info,
		    "attributesGet finished successfully");
	  return ipToMACAddressValueType;
	}

    /**
     * Implementation of the ::itut_x780::ManagedObject_F::packagesGet operation.
     */
    public String[]
    packagesGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
		String key = Utils.name2string(name);

		if (elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		IpToMACAddressDataStructure data =
			(IpToMACAddressDataStructure) elements.get(key);

        return data.getPackages();
    }

    /**
     * Implementation of the ::itut_x780::ManagedObject_F::creationSourceGet operation.
     */
    public intt.itu.itut_x780.SourceIndicatorType
    creationSourceGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
 	  String key = Utils.name2string(name);

		if (elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		IpToMACAddressDataStructure data =
			(IpToMACAddressDataStructure) elements.get(key);

		return data.sourceIndicator;
    }

    /**
     * Implementation of the ::itut_x780::ManagedObject_F::deletePolicyGet operation.
     */
    public short
    deletePolicyGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
   		String key = Utils.name2string(name);

		if (elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		IpToMACAddressDataStructure data =
			(IpToMACAddressDataStructure) elements.get(key);

        return data.deletePolicy;
    }

    /**
     * Implementation of the ::itut_x780::ManagedObject_F::destroy operation.
     */
    public void
    destroy(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError,

           intt.itu.itut_x780.DeleteError
    {
	    if (!elements.containsKey(Utils.name2string(name))) {

            ApplicationErrorInfoTypeImpl error_code =
            new ApplicationErrorInfoTypeImpl();

            error_code.error = new UIDType(
            intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
            intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

            error_code.details = new String ("object with name " +
            Utils.name2string(name) + " does not exist.");
            throw new ApplicationError(error_code);

	  }

	  IpToMACAddressDataStructure ipToMACAddress = null;
	  synchronized(elements) {
	    ipToMACAddress =
	 		(IpToMACAddressDataStructure) elements.remove(
				Utils.name2string(name));
		}
	  org.omg.TimeBase.UtcT eventTime = new org.omg.TimeBase.UtcT(System.currentTimeMillis(),
		  0, (short) 0, (short) 0);
	  get_context().push_objectDeletion(new ObjectDeletionImpl(eventTime,
						name,
						ipToMACAddress.getObjectClass(),
						getUniqueNotificationIdentifier(),
						ipToMACAddress.sourceIndicator,
						new AttributeValueType[0]));

	  Utils.pretty_log(logSupport,  Utils.name2string(name), 
				ipToMACAddress.objectclass, //objectClassGet(name),
		  (short) LogSeverity._Info,
		  "successfully removed from management system");
    }


	public static int getUniqueNotificationIdentifier() {

        notifId++;

        return (notifId);
   }

}
