/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Areski Flissi.
Contributor(s): 

====================================================================*/

package org.objectweb.ccm.filetransfer.cif;

/**
 * @author <a href="mailto:Areski.Flissi@lifl.fr">Areski Flissi</A>
 */

import java.io.*;
import java.awt.*;
import java.lang.*;

public class FileTransfertPDA_impl {

    //private TextArea textAr_ = null;
    private Canvas screen_ = null;
    private Button channel_ = null;
    private Button welcome_ = null;
    
    private Image img = null;

    //
    // The FileTransfert_impl object constructor to initialize the Receiver's GUI
    //

    FileTransfertPDA_impl(Canvas screen, Button channel, Button welcome) {

        //textAr_ = textarea;
        screen_ = screen;
        channel_ = channel;
        welcome_ = welcome;
        
        //screen_.setBackground(Color.white);

    }

    //
    // A method to store received files for each channel
    //

    public void storeLastSend(byte[] last_send, String filename) {

        FileOutputStream file = null;

        java.io.File currentdir = new java.io.File(System.getProperty("user.dir"));
        
        
        currentdir = new java.io.File(currentdir.getParent());

        try {
            file =
                new FileOutputStream(currentdir.getParent() + "/IMAGE/Receive/" + filename);
            file.write(last_send);
            file.close();

        } catch (java.io.IOException ex) {
            System.err.println("Can't write to " + ": " + ex.getMessage());
            System.exit(1);
        }

        
    }
    
    public void display_image(byte[] last_send, String filename) {
        
        
        channel_.setLabel("<" + filename + ">");

        // Display the received image
        
        
        // Load lastImage[]
        img = Toolkit.getDefaultToolkit().createImage(last_send);
        
        // delete previous image
        screen_.getGraphics().dispose();
        screen_.update(screen_.getGraphics());
        // get Graphics and draw image
        screen_.getGraphics().drawImage(img,0,0,welcome_);
        
        // Store the received file
        //this.storeLastSend(last_send, filename);

        
    }

}
