/*====================================================================

Objectweb Explorer Framework
Copyright (C) 2000-2004 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Jerome Moroy, Philippe Merle.
Contributor(s): ______________________________________.

====================================================================*/

package org.objectweb.util.explorer.plugin.java;

import org.objectweb.util.explorer.api.Entry;
import org.objectweb.util.explorer.api.MenuItem;
import org.objectweb.util.explorer.api.MenuItemTreeView;
import org.objectweb.util.explorer.api.TreeView;
import org.objectweb.util.explorer.core.common.api.ContextContainer;


public class RemoveFromContextAction 
  implements MenuItem 
{

    public void actionPerformed(MenuItemTreeView treeView) {
        if (treeView != null) {
            Entry entry = treeView.getSelectedEntry();
            String value = entry.getName().toString();
            ContextContainer context = (ContextContainer) treeView.getParentObject();
            context.removeEntry(value);
        }
    }
    
    public int getStatus(TreeView treeView) {
        return MenuItem.ENABLED_STATUS;
    }
    
}
