/*====================================================================

Objectweb Explorer Framework
Copyright (C) 2000-2004 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Jerome Moroy, Philippe Merle.
Contributor(s): ______________________________________.

====================================================================*/

package org.objectweb.util.explorer.plugin.java.swing;

import java.util.Properties;

import javax.swing.Icon;

import org.objectweb.util.explorer.api.IconProvider;
import org.objectweb.util.explorer.swing.icon.NumberIcon;


/**
 * Provides an icon to represent <code>java.util.Properties</code> object.
 *
 * @author <a href="mailto:Jerome.Moroy@lifl.fr">Jerome Moroy</a>
 * 
 * @version 0.1
 */
public class PropertiesIconProvider 
  implements IconProvider 
{

    //==================================================================
    //
    // No internal state.
    //
    //==================================================================

    /** The icon to use */
    protected Icon icon;    
    
    //==================================================================
    //
    // No constructor.
    // 
    //==================================================================

    //==================================================================
    //
    // No internal method.
    //
    //==================================================================

    //==================================================================
    //
    // Public method for IconProvider.
    //
    //==================================================================

	/* (non-Javadoc)
	 * @see org.objectweb.util.explorer.api.IconProvider#newIcon(java.lang.Object)
	 */
	public Object newIcon(Object object) {
	    Properties properties = (Properties)object;
        return new NumberIcon(properties.size());
	}

}