/*====================================================================

Objectweb Explorer Framework
Copyright (C) 2000-2005 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Philippe Merle, Jerome Moroy.
Contributor(s): ______________________________________.

====================================================================
$Id: MapSwingConsole.java,v 1.2 2005/07/05 09:23:38 moroy Exp $
====================================================================*/

package swing;

import org.objectweb.util.explorer.api.Tree;
import org.objectweb.util.explorer.parser.api.ParserConfiguration;
import org.objectweb.util.explorer.swing.lib.SwingExplorer;
import org.objectweb.util.trace.TraceSystem;

/**
 * This class builds a example console built on top of the Explorer Framework.
 * This console allows us to manage <code>java.util.Map</code> Object.
 *
 * @author <a href="mailto:Philippe.Merle@lifl.fr">Philippe Merle</a>,
 *         <a href="mailto:Jerome.Moroy@lifl.fr">Jrme Moroy</a>
 * 
 * @version 0.1
 */
public class MapSwingConsole 
{

    public static void main(String[] args)
    {
        TraceSystem.setLevel("debug");
        SwingExplorer explorer = new SwingExplorer("Map Explorer");
            
        // Loads the configuration file.
        ParserConfiguration parser = explorer.getParserConfigurationItf();
        parser.addPropertyFile(args[0]);
        parser.parse();

        // Populates the tree.
        Tree treeItf = explorer.getTreeItf();
        treeItf.addEntry("Object 1", new Object());
        treeItf.addEntry("Object 2", new Object());
        treeItf.addEntry("Map", new java.util.HashMap());
            
        explorer.setVisible(true);
    }

}
