/*====================================================================

Objectweb Explorer Framework
Copyright (C) 2000-2004 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Jerome Moroy, Philippe Merle.
Contributor(s): ______________________________________.

====================================================================*/
package org.objectweb.util.explorer.api;

/**
 * Allows to specify the contents of a table.<br>
 * In order to define a table element, you can have a look to the corresponding
 * <a href="explorer-dtd.html#table">DTD element</a> or to 
 * an <a href="package-summary.html#xml">XML example.</a>
 *
 * @author <a href="mailto:Jerome.Moroy@lifl.fr">Jrme Moroy</a>,
 *         <a href="mailto:Philippe.Merle@lifl.fr">Philippe Merle</a>.  
 * 
 * @version 0.1
 */
public interface Table 
         extends View 
{

    /**
     * Returns the table headers.
     * @param treeView A view on the tree.
     * @return The titles of the columns 
     */
    public String[] getHeaders(TreeView treeView);

    /**
     * Returns the rows of the table. 
     * If a cell is an <code>Entry</code> object, the <code>Entry.getName()</code> is displayed. 
     * @param treeView A view on the tree.
     * @return The rows to display.
     */
    public Object[][] getRows(TreeView treeView);

}
