/*====================================================================

Objectweb Explorer Framework
Copyright (C) 2000-2004 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Jerome Moroy, Philippe Merle.
Contributor(s): ______________________________________.

====================================================================*/
package org.objectweb.util.explorer.core.root.lib;

import java.util.Arrays;
import java.util.Iterator;
import java.util.List;
import java.util.Vector;

import org.objectweb.util.explorer.api.Entry;
import org.objectweb.util.explorer.api.RootContext;
import org.objectweb.util.explorer.api.RootEntry;

/**
 * 
 *
 * @author <a href="mailto:Jerome.Moroy@lifl.fr">Jrme Moroy</a>,
 *         <a href="mailto:Philippe.Merle@lifl.fr">Philippe Merle</a>.  
 * 
 * @version 0.1
 */
public class DefaultRootContext 
  implements RootContext
{

    //==================================================================
    //
    // Internal States.
    //
    // ==================================================================

    protected List elements_ = null;
    
    // ==================================================================
    //
    // Constructors.
    //
    // ==================================================================

    public DefaultRootContext(){
        elements_ = new Vector();
    }
    
    // ==================================================================
    //
    // Internal methods.
    //
    // ==================================================================

    protected void addEntry(List l, Entry[] entries){
        
    }
    
    // ==================================================================
    //
    // Public methods for Context interface. 
    //
    // ==================================================================    
    
    /* (non-Javadoc)
     * @see org.objectweb.util.explorer.api.Context#getEntries(java.lang.Object)
     */
    public RootEntry[] getEntries() {
        Vector entries = new Vector();
        Iterator it = elements_.iterator();
        while (it.hasNext()) {
            RootContext element = (RootContext) it.next();
            entries.addAll(Arrays.asList(element.getEntries()));
        }
        return (RootEntry[])entries.toArray(new RootEntry[entries.size()]);
    }

    // ==================================================================
    //
    // Public methods. 
    //
    // ==================================================================    
    
    public void addRootContext(RootContext rootContext){
        if(rootContext != null){
            elements_.add(rootContext);
        }
    }
    
}


