/*====================================================================

Objectweb Explorer Framework
Copyright (C) 2000-2005 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Jerome Moroy, Philippe Merle.
Contributor(s): ______________________________________.

====================================================================
$Id: ParserConfiguration.java,v 1.2 2005/07/06 15:36:00 moroy Exp $
====================================================================*/

package org.objectweb.util.explorer.parser.api;

/**
 * Configures an Explorer Parser. 
 *
 * @author <a href="mailto:Jerome.Moroy@lifl.fr">Jrme Moroy</a>,
 *         <a href="mailto:Philippe.Merle@lifl.fr">Philippe Merle</a>.  
 * 
 * @version 0.1
 */
public interface ParserConfiguration {

    /** Reference to the ParserConfiguration server interface name.*/
    public static String PARSER_CONFIGURATION = "parser-configuration";
    
    /**
     * Adds a file (or directory) which contains the properties. 
     * @param urlFile The URL of the XML file (or directory) containing the configuration you want to parse.
     */
    public void addPropertyFile(String urlFile);

    /**
     * Parses the XML files. 
     */
    // TODO: Use of arguments in the Fractal ADL file.
    // It would be better if the configuration of the parser is made by
    // an AttributeController interface and the call to the "parse" method
    // during the start of the component.
    public void parse();
    
}
