/*====================================================================

Objectweb Explorer Framework
Copyright (C) 2000-2005 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Jerome Moroy, Philippe Merle.
Contributor(s): ______________________________________.

====================================================================
$Id: PropertyFeeder.java,v 1.2 2005/07/06 15:36:00 moroy Exp $
====================================================================*/

package org.objectweb.util.explorer.property.api;

import org.objectweb.util.explorer.core.common.api.Description;

/**
 * 
 *
 * @author <a href="mailto:Jerome.Moroy@lifl.fr">Jrme Moroy</a>,
 *         <a href="mailto:Philippe.Merle@lifl.fr">Philippe Merle</a>.  
 * 
 * @version 0.1
 */
public interface PropertyFeeder 
{

    /** The name of the fractal interface reference. */
    public static String PROPERTY_FEEDER = "property-feeder";
        
    /**
     * Feeds the Explorer properties data structure.
     * The key parameter is an Object resulting from the <code>KeyProvider</code>
     * component, excepted for the <code>RootProperty</code> component which is a
     * String representing te ID of the role. 
     * @param propertyType The type of property. The available types are:
     * <ul>
     *   <li>ExplorerConstants.ICON_PROPERTY for defining icon.</li>
     *   <li>ExplorerConstants.MENU_PROPERTY for defining menu.</li>
     *   <li>ExplorerConstants.INFO_PROPERTY for defining info.</li>
     * </ul>
     * @param key The storage key
     * @param value The value to store
     */
    public void feed(String propertyType, Object key, Description value);

}


