/*====================================================================

Objectweb Explorer Framework
Copyright (C) 2000-2004 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Jerome Moroy, Philippe Merle.
Contributor(s): ______________________________________.

====================================================================*/
package org.objectweb.util.explorer.property.api;

import org.objectweb.util.explorer.core.common.api.Description;

/**
 * 
 *
 * @author <a href="mailto:Jerome.Moroy@lifl.fr">Jrme Moroy</a>,
 *         <a href="mailto:Philippe.Merle@lifl.fr">Philippe Merle</a>.  
 * 
 * @version 0.1
 */
public interface PropertyProvider {

    /** The name of the fractal interface reference. */
    public static String PROPERTY_PROVIDER = "property-provider";
    
    /**
     * Provides the description of the property 
     * for the given type of properties and the given key.
     * @param propertyType The type of property. The available types are:
     * <ul>
     *   <li>ExplorerConstants.ICON_PROPERTY for defining icon.</li>
     *   <li>ExplorerConstants.MENU_PROPERTY for defining menu.</li>
     *   <li>ExplorerConstants.INFO_PROPERTY for defining info.</li>
     * </ul>
     * @param key The storage key.
     * The key parameter is an Object resulting from the <code>KeyProvider</code>
     * component, excepted for the <code>RootProperty</code> component which is a
     * String representing te ID of the role. 
     * @return The associated property (or null if no property is found for the given parameters)
     */
    public Description getPropertyDescription(String propertyType, Object key);
    
}
