/*====================================================================

Objectweb Explorer Framework
Copyright (C) 2000-2005 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Jerome Moroy.
Contributor(s): ______________________________________.

====================================================================
$Id: SwingExplorer.java,v 1.1 2005/07/05 09:16:30 moroy Exp $
====================================================================*/
package org.objectweb.util.explorer.swing.api;

import org.objectweb.util.explorer.api.Tree;
import org.objectweb.util.explorer.parser.api.ParserConfiguration;

/**
 * This interface defines accessors for the SwingExplorer Fractal component.
 * 
 * @author <a href="mailto:Jerome.Moroy@lifl.fr">Jrme Moroy</a>,
 *         <a href="mailto:Philippe.Merle@lifl.fr">Philippe Merle</a>.  
 * 
 * @version 0.1
 */

public interface SwingExplorer {

	/**
	 * Provides the ParserConfiguration.PARSER_CONFIGURATION interface.
	 */
	public ParserConfiguration getParserConfigurationItf();

	/**
	 * Provides the Tree.TREE interface.
	 */
	public Tree getTreeItf();

	/**
	 * Provides the Explorer.EXPLORER interface.
	 */
	public Explorer getExplorerItf();

	/**
	 * Provides the ViewPanel.VIEW_PANEL interface.
	 */
	public ViewPanel getViewPanelItf();

	/**
	 * Provides the StatusBar.STATUS_BAR interface.
	 */
	public StatusBar getStatusBarItf();
    
}
