/*====================================================================

 Objectweb Explorer Framework
 Copyright (C) 2000-2004 INRIA - USTL - LIFL - GOAL
 Contact: openccm@objectweb.org

 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or any later version.

 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public
 License along with this library; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 USA

 Initial developer(s): Latitia Lafeuille.
 Contributor(s): ______________________________________.

 ====================================================================*/
package org.objectweb.util.explorer.swing.graph;

import org.jgraph.graph.DefaultPort;

/**
 * 
 * @version 0.2
 */
public class MyPort extends DefaultPort {
    
    /** The interface relative to the port*/
    private Object itf;

    /** The name of the port*/
    private String name;

    /** The type of the port : client/server/controller*/
    private String type;

    /** The creation number of the port on his parent vertex. It's used for locate the port graphics*/
    private int number;
    
    /** Boolean that indicates if the port is generated or not*/
    private boolean isGenerated;

    public MyPort(Object itf, String name, String type, int number, boolean isGenerated) {
        super();
        this.name = name;
        this.type = type;
        this.number = number;
        this.isGenerated = isGenerated;
        this.itf = itf;
    }

    public String getName() {
        return name;
    }
    
    public boolean isGenerated(){
        return isGenerated;
    }

    public String toString() {
        return name;
    }

    public String getType() {
        return type;
    }

    public int getNumber() {
        return number;
    }

}