/*====================================================================

 Objectweb Explorer Framework
 Copyright (C) 2000-2004 INRIA - USTL - LIFL - GOAL
 Contact: openccm@objectweb.org

 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or any later version.

 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public
 License along with this library; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 USA

 Initial developer(s): Latitia Lafeuille.
 Contributor(s): ______________________________________.

 ====================================================================*/
package org.objectweb.util.explorer.swing.graph;

import java.awt.Dimension;
import java.awt.Graphics;

/**
 * 
 * @version 0.2
 */
public interface PortGraphicsInterface {
    
    /** The width of a letter of a port label*/
    public final int PORT_NAME_WIDTH = 6;

    /** The lenght of a letter of a port label*/
    public final int PORT_NAME_LENGHT = 14;

    /** The y position of the first port (sever/client) into a vertex*/
    public final int FIRST_PORT_Y = 25;

    /** The y position of the controller port into a vertex*/
    public final int CONTROLLER_PORT_Y = 15;

    /** The width that separate two controller ports*/
    public final int CONTROLLER_PORT_WIDTH = 30;

    /** The width that separate two controller ports into the open composite (super composite)*/
    public final int COMPOSITE_CONTROLLER_PORT_WIDTH = 40;

    /** Method that returns the size of the specific port*/
    Dimension getPortSize(String portType, boolean isInternal);

    /** Method that serves to paint a specific port*/
    void drawPort(Graphics g, String portName, String portType, boolean isInternal);

}