/*====================================================================

Objectweb Explorer Framework
Copyright (C) 2000-2004 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Jerome Moroy, Philippe Merle.
Contributor(s): ______________________________________.

====================================================================*/

package org.objectweb.util.explorer.swing.gui.api;

/**
 * A ValidateReport is composed of two attribute:
 * <ul>
 *   <li>A result: TRUE or FALSE to know if the result is OK or not.</li>
 *   <li>A message: To explain why the result is not OK.</li>
 * </ul>
 *
 * @author <a href="mailto:Jerome.Moroy@lifl.fr">Jerome Moroy</a>
 * 
 * @version 0.1
 */
public interface ValidateReport {
    
    /**
     * Fixes the result value.
     * <ul>
     *   <li>TRUE if the result is OK</li>
     *   <li>FALSE if the result is not OK</li>
     * </ul>
     * @param result
     */
    public void setResult(boolean result);
    
    /**
     * Gets the result value.
     * @return The result value
     */
    public boolean getResult();
    
    /**
     * Fixes the message to explain why the result is not OK.
     * @param message An explanation message
     */
    public void setMessage(String message);
    
    /**
     * Gets the explanation message
     * @return The explanation message
     */
    public String getMessage();
    
}