/*====================================================================

Objectweb Explorer Framework
Copyright (C) 2000-2004 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Jerome Moroy, Philippe Merle.
Contributor(s): ______________________________________.

====================================================================*/
package org.objectweb.util.explorer.swing.icon;

import java.awt.Component;
import java.awt.Graphics;

/**
 * 
 *
 * @author <a href="mailto:Jerome.Moroy@lifl.fr">Jrme Moroy</a>,
 *         <a href="mailto:Philippe.Merle@lifl.fr">Philippe Merle</a>.  
 * 
 * @version 0.1
 */
public class StringIcon 
     extends javax.swing.plaf.metal.MetalIconFactory.FileIcon16
{

    //==================================================================
    //
    // Internal States.
    //
    // ==================================================================

    /** The value to display */
    protected String value_;    
    
    // ==================================================================
    //
    // Constructors.
    //
    // ==================================================================

    /**
     * Default constructor.
     * @param value The value to display
     */
    public StringIcon(String value){
        value_ = value;    
    }    
    
    // ==================================================================
    //
    // Internal methods.
    //
    // ==================================================================

    /**
     * Draws the point in the default object icon
     */
    private void myPaint(Component c, Graphics g) {
        java.awt.Font oldFont = g.getFont();
        g.setFont(oldFont.deriveFont(java.awt.Font.BOLD));
        g.drawString(value_,2,12);
        g.setFont(oldFont);
        //g.drawRect(0,0,19,15);
    }    
    
    // ==================================================================
    //
    // Public methods. 
    //
    // ==================================================================    
        
    public void paintIcon(Component c, Graphics g, int x, int y) {
        myPaint(c,g);   
    }
    
}


