/*====================================================================

Objectweb Explorer Framework
Copyright (C) 2000-2004 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Jerome Moroy, Philippe Merle.
Contributor(s): ______________________________________.

====================================================================*/
package org.objectweb.util.explorer.swing.panel;

import java.awt.BorderLayout;
import java.awt.Color;

import javax.swing.BoxLayout;
import javax.swing.JLabel;
import javax.swing.JPanel;

import org.objectweb.util.explorer.api.Panel;
import org.objectweb.util.explorer.api.TreeView;

/**
 * This class represents an empty panel
 *
 * @author <a href="mailto:Jerome.Moroy@lifl.fr">Jerome Moroy</a>
 * @version 0.1
 */
public class WhitePanel
    implements Panel {

    JPanel panel_;

    /**
     * Default Constructor
     */
    public WhitePanel() {
        this("");
    }

    /**
     * Constructor with text
     * Customizes the JPanel and adds the message in it.
     */
    public WhitePanel(String message) {
        panel_ = new JPanel();
        panel_.setBackground(Color.white);
        panel_.setLayout(new BoxLayout(panel_, BoxLayout.Y_AXIS));
        panel_.add(new JLabel(message), BorderLayout.CENTER);
    }

    /**
     * Invokes just after instanciation
     */
    public void selected(TreeView treeView) {
        Object o = treeView.getSelectedObject();
        if (o != null)
            panel_.add(new JLabel(o.toString()), BorderLayout.CENTER);
    }

    /**
     * Provides the panel to display
     * @return The panel to display
     */
    public Object getPanel(){
        return panel_;
    }

    /**
     * Invokes just before removing
     */
    public void unselected(TreeView treeView) {
    }

}
