/*====================================================================

Objectweb Explorer Framework
Copyright (C) 2000-2004 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Jerome Moroy, Philippe Merle.
Contributor(s): ______________________________________.

====================================================================*/
package org.objectweb.util.explorer;


import junit.framework.Assert;
import junit.framework.TestCase;

/**
 * 
 *
 * @author <a href="mailto:Jerome.Moroy@lifl.fr">Jrme Moroy</a>,
 *         <a href="mailto:Philippe.Merle@lifl.fr">Philippe Merle</a>.  
 * 
 * @version 0.1
 */
public class ExplorerUtilsTest 
     extends TestCase 
{

    //==================================================================
    //
    // Internal States.
    //
    // ==================================================================

    // ==================================================================
    //
    // Constructors.
    //
    // ==================================================================

    // ==================================================================
    //
    // Internal method.
    //
    // ==================================================================

    // ==================================================================
    //
    // Public methods. 
    //
    // ==================================================================    

    public void testCompareObjectsMethod(){
        Object o1=null, o2=null;
        Assert.assertTrue(ExplorerUtils.compareObjects(o1,o2));
        o1 = new String();
        Assert.assertFalse(ExplorerUtils.compareObjects(o1,o2));
        o1 = null;
        o2 = new String("test");
        Assert.assertFalse(ExplorerUtils.compareObjects(o1,o2));
        o1 = new String("test");
        Assert.assertTrue(ExplorerUtils.compareObjects(o1,o2));
    }
    
    public void testIsEmptyString(){
        String s = null;
        Assert.assertTrue(ExplorerUtils.isEmpty(s));
        s = "";
        Assert.assertTrue(ExplorerUtils.isEmpty(s));
        s = "not empty";
        Assert.assertFalse(ExplorerUtils.isEmpty(s));
    }
    
}


