/*====================================================================

Objectweb Explorer Framework
Copyright (C) 2000-2004 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Jerome Moroy, Philippe Merle.
Contributor(s): ______________________________________.

====================================================================*/
package org.objectweb.util.explorer.core.icon;

import org.objectweb.util.explorer.core.code.api.CodeDescription;
import org.objectweb.util.explorer.core.code.lib.BasicCodeDescription;
import org.objectweb.util.explorer.core.icon.api.IconCodeDescription;
import org.objectweb.util.explorer.core.icon.lib.BasicIconCodeDescription;

import junit.framework.Assert;
import junit.framework.TestCase;

/**
 * 
 *
 * @author <a href="mailto:Jerome.Moroy@lifl.fr">Jrme Moroy</a>,
 *         <a href="mailto:Philippe.Merle@lifl.fr">Philippe Merle</a>.  
 * 
 * @version 0.1
 */
public class IconDescriptionTest 
     extends TestCase 
{

    //==================================================================
    //
    // Internal States.
    //
    // ==================================================================
    
    // ==================================================================
    //
    // Constructors.
    //
    // ==================================================================

    // ==================================================================
    //
    // Internal method.
    //
    // ==================================================================

    // ==================================================================
    //
    // Public methods. 
    //
    // ==================================================================    
    
    public void testIconCodeEqualsMethod(){
        CodeDescription c1 = new BasicCodeDescription();
        c1.setLanguage("Java");
        c1.setCode("java.lang.Object");
        CodeDescription c2 = new BasicCodeDescription();
        c2.setLanguage("Java");
        c2.setCode("java.lang.Object");
        CodeDescription nullCodeDesc = null;
        
        IconCodeDescription iconCodeDesc = new BasicIconCodeDescription();
        IconCodeDescription expected = new BasicIconCodeDescription();
        Assert.assertEquals(expected, iconCodeDesc);
        iconCodeDesc.setCode(nullCodeDesc);
        Assert.assertEquals(expected, iconCodeDesc);
        iconCodeDesc.setCode(c1);
        Assert.assertEquals(iconCodeDesc, iconCodeDesc);
        expected.setCode(c1);
        Assert.assertEquals(expected, iconCodeDesc);
        expected.setCode(c2);
        Assert.assertEquals(expected, iconCodeDesc);
    }

}

