#! /bin/sh -f
# ==================================================================== 
#                                                                      
# ObjectWeb Util Package                                               
# Copyright (C) 2000-2005 INRIA - USTL - LIFL - GOAL                   
# Contact: openccm@objectweb.org                                       
#                                                                      
# This library is free software; you can redistribute it and/or        
# modify it under the terms of the GNU Lesser General Public           
# License as published by the Free Software Foundation; either         
# version 2.1 of the License, or any later version.
#                                                                      
# This library is distributed in the hope that it will be useful,      
# but WITHOUT ANY WARRANTY; without even the implied warranty of       
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU     
# Lesser General Public License for more details.                      
#                                                                      
# You should have received a copy of the GNU Lesser General Public     
# License along with this library; if not, write to the Free Software  
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 
# USA                                                                  
#                                                                      
# Initial developer(s): Romain Rouvoy                                  
# Contributor(s): Christophe Demarey
#                 Christophe Contreras
#                 Philippe Merle
#
# ====================================================================
# $Id: launcher.sh,v 1.12 2005/07/04 15:49:52 merle Exp $
# ====================================================================
#  Start a Java Application from an xml configuration file.
#
#  If $1 = "exec", simply run the application.
#  If $1 = "fork", run the application as a server.
#
#  Parameters :
#  - $2 represents jvm parameters.
#  - $3 represents application parameters.
#  - $4 is the file where standard output is redirected. (ex: cmd.output, cmd.ior)
#  - $5 is a file containing the Processus ID.
#
# ====================================================================

# The XBOOTCLASSPATH shell variable :
#    it should be setup before calling this script
#    it is not mandatory, but for this purpose, it MUST end with a ":"
CLASSPATH=${XBOOTCLASSPATH}@LAUNCHER_CLASSPATH@

#
# With CYGWIN
#
if test "$OSTYPE" = "cygwin"
then
  # Update CLASSPATH to contain Windows paths.
  CLASSPATH=`cygpath --path --windows "$CLASSPATH"`
fi

PROPERTIES="-DOW_HOMEDIR=${OW_HOMEDIR} -DOW_CONFIGDIR=${OW_CONFIGDIR}"

COMMAND="java $2 ${PROPERTIES} -classpath ${CLASSPATH} @OW_LAUNCHER_CLASSNAME@ $3"

if [ "$1" = "exec" ]
then
    ${COMMAND}
elif [ "$1" = "fork" ]
then
    ow_fork.sh "${COMMAND}" $4 $5
else
    echo "Syntax: launcher.sh exec|fork [JVM] arguments"
fi
