#!/bin/sh
#
# usage:  idl3_to_corba.sh -Iidl_include_dir1 -Iidl_include_dir2 ... component_type component_home_type [gen_desc_file.txt] idl3_file
#
# NB: The file called "gen_desc_file.txt" contains interfaces and methods 
# (that is to say "integration point") where the interceptor has to be installed. 
# This parameter is optional, however, when it is present, its extension must be ".txt" 
# and the content shall follow the defined syntax.
#
# The selected IFR3.0 and generator are defined in $microCCM_DIR/etc/codegen_config.txt and is taken into account, if there are three last arguments.
#

IFR=`cat $microCCM_DIR/etc/codegen_config.txt | grep "USED_IFR" | awk ' { print $3 } ' `
GEN=`cat $microCCM_DIR/etc/codegen_config.txt | grep "USED_GENERATOR" | awk ' { print $3 }' `

OPTIONS=$@

## three last arguments == component_type component_home_type idl3_file

INCLUDE_OPTIONS=""
GEN_DESC_FILE=""
IDL3_FILE=""
COMPONENT_TYPE=""
COMPONENT_HOME_TYPE=""
is_it_include=""

nbargs=$#

let idl3_file_index=$nbargs
let gen_desc_file_index=$nbargs-1

elem=`echo $OPTIONS | cut -f $gen_desc_file_index -d " "`
extension=`echo $elem | cut -f 2 -d .`

    if [ $extension = "txt" ]
    then 
	let idl3_comp_home_type_index=$nbargs-2
	let idl3_comp_type_index=$nbargs-3
    else 
	let gen_desc_file_index=0
	let idl3_comp_home_type_index=$nbargs-1
	let idl3_comp_type_index=$nbargs-2
    fi


loop_counter=0

loop_counter_aux=""

for OPT in $OPTIONS
do
  let loop_counter=loop_counter+1
#  echo "loop_counter == $loop_counter"

  is_it_include=`echo $OPT | cut --characters=-2`
#  echo "is_it_include == $is_it_include"

  if [ $is_it_include = "-I" ]
   then INCLUDE_OPTIONS=" $OPT $INCLUDE_OPTIONS"
#   echo "include_option == $INCLUDE_OPTIONS"
  fi

   loop_counter_aux=`echo $gen_desc_file_index`
    
  if [ $loop_counter_aux = $loop_counter ]
   then GEN_DESC_FILE=$OPT
#   echo "set_gen_desc_file"
  fi

   loop_counter_aux=`echo $idl3_file_index`

 if [ $loop_counter_aux = $loop_counter ]
    then IDL3_FILE=$OPT
#   echo "set_idl3_file"
   fi

    loop_counter_aux=`echo $idl3_comp_type_index`

  if [ $loop_counter_aux = $loop_counter ]
    then COMPONENT_TYPE=$OPT
#    echo "set_comp_type"
   fi
    
    loop_counter_aux=`echo $idl3_comp_home_type_index`

  if [ $loop_counter_aux = $loop_counter ]
    then COMPONENT_HOME_TYPE=$OPT
#    echo "set_home_type"
   fi

done

echo component: $COMPONENT_TYPE
echo ifr: $IFR
echo target orb: $GEN



TAO_IFR="tao_ifr"
OPENCCM_IFR="openccm_ifr"

TAO_GEN="tao_generator"
OB_GEN="ob_generator"

if [ -z "$IFR" ] || [ -z "$GEN" ]; then
echo One of the variables is empty
exit
fi



if [ "$IFR" = "$TAO_IFR" ] && [ "$GEN" = "$TAO_GEN" ]; then
export IFR_IOR_DIR=$microCCM_DIR/etc
export IFR_IOR_FILE="IFR_ior.txt"
tao_ir3_start
tao_ir3_feed $INCLUDE_OPTIONS $IDL3_FILE
idl3_to_corba.exe $COMPONENT_TYPE $COMPONENT_HOME_TYPE $GEN_DESC_FILE
tao_ir3_stop
elif [ "$IFR" = "$OPENCCM_IFR" ] && [ "$GEN" = "$TAO_GEN" ]; then
export IFR_IOR_DIR=$OpenCCM_CONFIG_DIR
export IFR_IOR_FILE="IR3.IOR"
mccm_ir3_start
ir3_feed $INCLUDE_OPTIONS $IDL3_FILE
idl3_to_corba.exe $COMPONENT_TYPE $COMPONENT_HOME_TYPE $GEN_DESC_FILE #2> /dev/null
ir3_stop
else
echo Bad parameter
fi

