#include <MCCM_Service_Integration.h>

// --------
#include <iostream>
using namespace std;

void 
MCCM_Service_Integration_Points::set_in_place_of_interceptor( const char* facet_name,
							      const char* method_name,
							      MCCM_Interceptor* the_intercept )
{
  thsi_[ facet_name ]->set_in_place_of_interceptor( method_name, 
						    the_intercept );
}

void MCCM_Service_Integration_Points::register_has_set_interceptor( MCCM_has_set_interceptor* hsi,
								    const char* facet_name )
{
  thsi_[ facet_name ] = hsi;
}

void MCCM_Service_Integration_Points::register_ext_session_context( Components::SessionContext_ptr sctx )
{
  cerr << __PRETTY_FUNCTION__ << ":" << __LINE__ << endl;
  the_session_context_ = sctx;
}

void MCCM_Service_Integration_Points::register_internal_interface( microCCM::Object* the_obj,
								   long the_id )
{
  if(!the_session_context_)
    {
      cerr << __PRETTY_FUNCTION__ << ":" << __LINE__ << " ..." << "extsessioncontext doesn't exixts" << endl;
      exit( 1 );
    }
  

  Components::ExtSessionContext* the_ext_session_context
    = dynamic_cast< Components::ExtSessionContext* >( the_session_context_ );

  cout << "* **** id: " << the_id << "the_ext_ctx: " <<the_ext_session_context << endl;
  cout << __PRETTY_FUNCTION__ << ":" << __LINE__ << endl;

  the_ext_session_context->the_internal_interfaces_[ the_id ] = the_obj;
  cout << __PRETTY_FUNCTION__ << ":" << __LINE__ << endl;
}

// ---------

MCCM_Service_Integration*
MCCM_Service_Integration_Factories::create(  const char* name,
					     const CORBA::Any& cfg )
{
  if( !the_factories_[ name ] ) 
    {
      cerr << __PRETTY_FUNCTION__ << ":" << __LINE__ << " ..." << name << endl;
      exit( 1 );
    }

  MCCM_Service_Integration* msi = the_factories_[ name ]->create();
  msi->accept_configuration( cfg );
  return msi;
}

void MCCM_Service_Integration_Factories::register_service_integration_factory( MCCM_Service_Integration_Factory* sif )
{
  the_factories_[ sif->name() ] = sif;
}

Correspondance_table< MCCM_Service_Integration_Factory* > MCCM_Service_Integration_Factories::the_factories_;

// -----------

