#include <Cpp_method.h>
#include <sstream>

#include <string>
#include <list>
#include <iostream>

using namespace std;

Cpp_method::Cpp_method() : virtual_decl_ ( none ),
			   is_static_( false )
{
}

// ---

list< string::size_type> obtain_all_commas_and_add_at_end( string the_string )
{
  list< string::size_type > where_are_commas;
  where_are_commas.push_back( 0 );

  {
    string::size_type where_is_comma = the_string.find( "," );

    while( where_is_comma != string::npos ) 
      {
	where_are_commas.push_back( where_is_comma );
	where_is_comma = the_string.find( ",", where_is_comma + 1 );
      }
    where_are_commas.push_back( the_string.size() );
  }

  return where_are_commas;
}

// --- 

ostream& operator<<( ostream& os, Cpp_method& meth )
{
  if( meth.is_static_ ) os << "static ";

  if( ( meth.virtual_decl_ == is_virtual ) || ( meth.virtual_decl_ == is_pure_virtual ) )
    {
      os << "virtual ";
    }

  os << meth.name_of_return_type_ << " " << meth.get_name_of_method() << "(";

  for( int ct = 0; ct < meth.parameters.size(); ct++ )
    {
      os << meth.parameters[ ct ].first << " " << meth.parameters[ ct ].second;
      if( ct != meth.parameters.size() - 1 ) os << ",";
    }

  os << ") ";

  if( meth.exceptions_thrown.size() > 0 )
    {
      os << "throw( ";

      for( int ct = 0; ct < meth.exceptions_thrown.size(); ct++ )
	{
	  os << meth.exceptions_thrown[ ct ];
	  if( ct != meth.exceptions_thrown.size() - 1 ) os << ",";
	}
      os << " )";
    }

  os << ";";

  return os;
}


void Cpp_method::set_prototype( string prototype )
{
  string::size_type pos_open_parenthesis = prototype.find( "(" );

  if( pos_open_parenthesis == string::npos )
    {
      cerr << "Cpp_method: don't manage to find a '(' for the parameters" << endl
	   << "for method " << prototype << endl;
      exit( 1 );
    }

  istringstream proto_istr( prototype.substr( 0, pos_open_parenthesis ) );

  proto_istr >> name_of_return_type_;
  proto_istr >> name_of_method_;

  string::size_type pos_closed_parenthesis = prototype.find( ")" );

  if( pos_closed_parenthesis == string::npos )
    {
      cerr << "Cpp_method: don't manage to find a ')' for the parameters" << endl
	   << "for method " << prototype << endl;
    }

  string arguments = prototype.substr( pos_open_parenthesis + 1, 
				       pos_closed_parenthesis - pos_open_parenthesis - 1 );

  cerr << " arguments ==|" << arguments << "|" << endl;

  // and then, we begin to read the types of arguments, etc ...
  // we suppose that there is always a name of the argument in the method prototype ...


    list< string::size_type > where_are_commas 
      = obtain_all_commas_and_add_at_end( arguments );

    bool arguments_is_empty = true;

    for( int ct = 0; ct < arguments.size(); ct++ )
      {
	if( arguments[ ct ] != ' ' ) 
	  {
	    arguments_is_empty = false;
	    break;
	  }
      }

    if( !arguments_is_empty )
      {
	for( list< string::size_type >::iterator iter = where_are_commas.begin();
	     iter != where_are_commas.end();
	     iter++ )
	  {
	list< string::size_type >::iterator next_one = iter;
	next_one++; if( next_one == where_are_commas.end() ) break;

	string::size_type arg_start_pos;
	( *iter == 0 ) ? arg_start_pos = 0 : arg_start_pos = *iter + 1;

	string current_arg = arguments.substr( arg_start_pos, ( *next_one ) - arg_start_pos );

	// remove spaces at the end of current_arg
	int where_is_space;

	for( where_is_space = current_arg.size() - 1; current_arg[ where_is_space ] == ' ' ; where_is_space-- )
	  {
	  }

	current_arg = current_arg.substr( 0, where_is_space + 1 );
	if( current_arg.size() == 0 ) break;

	istringstream current_arg_istr( current_arg );

	string type_of_arg;
	string name_of_arg;

	string currently_read;
	current_arg_istr >> currently_read;
	
	while( 1 )
	  {
	    if( !current_arg_istr.good() )
	      {
		name_of_arg = currently_read;
		break;
	      }
	    else
	      {
		if( type_of_arg.size() > 0 ) type_of_arg += " ";
		type_of_arg += currently_read;
	      }
	    
	    current_arg_istr >> currently_read;
	  }
	
	cerr << __PRETTY_FUNCTION__ << "type_of_arg ==|" << type_of_arg <<"|" << endl;

	add_parameter( type_of_arg, name_of_arg );
      }
  }

  // --- and now exceptions ---

  string::size_type where_is_throw = prototype.find( "throw" );
  if( where_is_throw == string::npos ) return;

  string throw_decl = prototype.substr( where_is_throw );
  int where_is_open_par = throw_decl.find( "(" );
  int where_is_close_par = throw_decl.find( ")" );

  string all_exceptions_raised = throw_decl.substr( where_is_open_par + 1, 
						    where_is_close_par - where_is_open_par - 1 );

  cerr << "all_exceptions_raised == " << all_exceptions_raised << endl;

  list< string::size_type > comma_positions = obtain_all_commas_and_add_at_end( all_exceptions_raised );

  for( list< string::size_type >::iterator iter = comma_positions.begin();
       iter != comma_positions.end();
       iter++ )
    {
      list< string::size_type >::iterator the_iter = iter; the_iter++;
      if( the_iter == comma_positions.end() ) break;

      add_exception_thrown( all_exceptions_raised.substr( *iter, ( *the_iter ) - ( *iter ) ) );
    }

}

void Cpp_method::set_virtual_decl( virtual_decl v )
{
  virtual_decl_ = v ;
}

void Cpp_method::set_return_type( string name_of_return_type ) 
{
  name_of_return_type_ = name_of_return_type; 
}

void Cpp_method::set_name_of_method( string name_of_method ) 
{
  name_of_method_ = name_of_method; 
}

void Cpp_method::change_name( string name_of_method )
{
  set_name_of_method( name_of_method );
}

string Cpp_method::get_name_of_method() 
{
  return name_of_method_; 
}

string Cpp_method::get_return_type() 
{
  return name_of_return_type_; 
}

void Cpp_method::add_parameter( string type, string name ) 
{
  parameters.push_back( pair<string,string>( type, name ) ); 
}

int Cpp_method::get_nb_parameters() 
{
  return parameters.size(); 
}

pair<string,string> Cpp_method::get_parameter_nb( int i ) 
{
  return parameters[i];
}

void Cpp_method::add_exception_thrown( string name_of_except )
{
  exceptions_thrown.push_back( name_of_except );
  return;
}

string Cpp_method::get_in_class_declaration() 
{
  string to_be_returned;

  if ( ( virtual_decl_ == is_pure_virtual ) || ( virtual_decl_ == is_virtual ) )  to_be_returned += "virtual ";

  if( is_static_ ) to_be_returned += "static ";

  if ( name_of_return_type_ != "none" ) to_be_returned += name_of_return_type_ + " ";

  to_be_returned += name_of_method_ + "(";
  for(int ct=0; ct < parameters.size(); ct++)
    {
      to_be_returned += parameters[ct].first + " " + parameters[ct].second;
      if (ct != parameters.size() -1) to_be_returned += ",";
    }
  to_be_returned += ")";

  to_be_returned += emits_throw_declaration();

  if ( virtual_decl_ == is_pure_virtual ) to_be_returned += " =0 ";

  to_be_returned += ";";
  
  return to_be_returned;
} 

string Cpp_method::emits_throw_declaration()
{
  string to_be_returned;
  
  for(int ct=0; ct < exceptions_thrown.size(); ct++)
    {
      if (ct == 0) 
	to_be_returned += string(" throw(") + exceptions_thrown[ct];
      else
	to_be_returned += string(",") + exceptions_thrown[ct];

      if (ct == exceptions_thrown.size() -1) to_be_returned += string(")");
    }

  return to_be_returned;
}

string Cpp_method::get_outof_class_header( string name_of_class )
{
  string to_be_returned;
  if (name_of_return_type_ != "none") to_be_returned = name_of_return_type_ + " ";

  to_be_returned += name_of_class + "::" + name_of_method_ + "(";
  for(int ct=0; ct < parameters.size(); ct++)
    {
      to_be_returned += parameters[ct].first + " " + parameters[ct].second;
      if (ct != parameters.size() -1) to_be_returned += ",";
    }
  to_be_returned += ")";

  to_be_returned += emits_throw_declaration();

  return to_be_returned;
}

string Cpp_method::get_call()
{
  string to_be_returned;
  to_be_returned += get_name_of_method() + "(";
  int nb_params_for_method = get_nb_parameters();
  
  for(int ct_param = 0; ct_param < nb_params_for_method; ct_param++)
    {
      to_be_returned += get_parameter_nb( ct_param ).second;
      if (ct_param != nb_params_for_method -1) to_be_returned += ",";
    }
  
  to_be_returned +=")";
  return to_be_returned;
}

bool Cpp_method::has_an_implementation( )
{
  if ( virtual_decl_ == is_pure_virtual ) return false;
  else
    return true;
}

bool Cpp_method::equals( const Cpp_method& cm )
{
  return ( (name_of_return_type_ == cm.name_of_return_type_ )
	   &&
	   ( name_of_method_ == cm.name_of_method_ )
	   &&
	   ( parameters == cm.parameters )
	   &&
	   ( exceptions_thrown == cm.exceptions_thrown) );
}

string Cpp_method::get_typedef_for_method_type( string in_this_class, string alias_name )
{
  string to_be_returned;

  to_be_returned += string("") +
    "typedef " + get_return_type() + "(" + in_this_class + "::*" + alias_name + ")(";
  
  for(int ct=0; ct < parameters.size(); ct++)
    {
      to_be_returned += parameters[ct].first;
      if (ct < parameters.size()-1) to_be_returned += ",";
    }

  to_be_returned += ");";

  return to_be_returned;
}


void Cpp_method::is_static()
{
  is_static_ = true;
}

