#include <read_configuration_file.h>

#include <iostream>

Configuration_file_reader::Configuration_file_reader( string name_of_file )
  : name_of_file_( name_of_file ) 
{
  the_file_.open( name_of_file.c_str(), ios::in );
}

// ---

string Configuration_file_reader::extract_configuration( string name_of_conf )
  throw( Configuration_file_reader::NotFound )
{
  cerr << "Configuration_file reader : searching for " << name_of_conf << endl;

  string read;

  while( ( read != name_of_conf ) && ( ! the_file_.eof() ) )
    {
      the_file_ >> read;
    }

  the_file_ >> read;

  if( ( read != "=" ) || the_file_.eof() ) 
    {
      cerr << "read == " << read << " : bad configuration file" << endl;
      exit( 1 );
    }

  the_file_ >> read;

  return read; 
}

void Configuration_file_reader::stop()
{
  the_file_.close();
}

