// ---------------------------------------

template< typename T >
tree< T >::tree() 
{
  head_.depth = 0;
  head_.upper_node = 0;
}

template< typename T >
typename tree< T >::tree_iterator tree< T >::get_head()
{
  return tree_iterator( &head_ );
}

template< typename T >
tree< T >::~tree()
{
  if( ! no_cleaning_ )
    {
      head_.remove_all_subnodes();
    }
}

// -------------------------------------------

template< typename T >
tree<  T >::tree_iterator::tree_iterator( tree< T >::tree_storage* s )
  : current_node_( s )
{
}

template< typename T >
void tree< T >::tree_iterator::up()
     throw( tree< T >::tree_iterator::cannot_go_up )
{
  if( current_node_->upper_node == 0 )
    {
      throw cannot_go_up();
    }
  else
    {
      current_node_ = current_node_->upper_node;
    }
}

template< typename T >
void tree< T >::tree_iterator::down( int index )
     throw( tree< T >::tree_iterator::cannot_go_down )
{

  if( current_node_->sub_nodes.size() == 0 )
    {
      throw cannot_go_down();
    }
  else
    {
      current_node_ = ( current_node_->sub_nodes )[ index ];
    }
}

template< typename T >
int tree< T >::tree_iterator::create_sub_node()
{

  tree_storage* new_node = new tree_storage;
  new_node->depth = current_node_->depth + 1;
  new_node->upper_node = current_node_;

  current_node_->sub_nodes.push_back( new_node );


  return current_node_->sub_nodes.size() - 1;
}

template< typename T >
int tree< T >::tree_iterator::nb_sub_nodes( ) const
{
  return current_node_->sub_nodes.size();
}

template< typename T >
int tree< T >::tree_iterator::depth() const
{
  return current_node_->depth;
}

template< typename T >
T& tree< T >::tree_iterator::get( )
{
  return current_node_->data;
}

template< typename T >
void tree< T >::tree_iterator::set( const T& t )
{
  current_node_->data = t;
}

template< typename T >
void tree< T >::tree_storage::remove_all_subnodes()
{
  for( int ct = 0; ct < sub_nodes.size(); ct++ )
    {
      delete sub_nodes[ ct ];
    }

  sub_nodes.resize( 0 );
  return;
}
