#ifndef obtain_ref_home_finder_h
#define obtain_ref_home_finder_h

#include <HomeFinderC.h>

#include <iostream>
#include <fstream>
#include <string>

using std::cerr; 
using std::endl;
using std::string;
using std::fstream;

inline Components::HomeFinder_ptr obtain_ref_for_home_finder( CORBA::ORB_ptr the_orb )
{
  char* microccm_location = getenv( "microCCM_DIR" );


  if( !microccm_location ) 
    {
      cerr << "The microCCM_DIR env variable is not set" << endl;
      exit( 1 );
    }
  string location_ior( microccm_location ); location_ior += "/etc/ior_home_finder.txt";

  fstream infile( location_ior.c_str(), ios::in );
  
  if( !infile )
    {
      cerr << "The Home Finder is not running" << endl;
      exit( 1 );
    }

  string the_ior;
  infile >> the_ior;
  CORBA::Object_var ref_obj = the_orb->string_to_object( the_ior.c_str() );  
  
  Components::HomeFinder_ptr to_return 
    = Components::HomeFinder::_narrow( ref_obj.in() );

  return to_return;
}


#endif // obtain_ref_home_finder_h
