
#include <iostream>
#include <cstdlib>
#include <fstream>
#include <string>

#include <obtain_ref_home_finder.h>
#include <Lw_ComponentsC.h>
#include <microccm_my_interface_1C.h>
#include <microccm_my_interface_3C.h>



using namespace std;

int main( int argc, char* argv[] )
{
  CORBA::ORB_var the_orb
    = CORBA::ORB_init( argc, argv );

  Components::HomeFinder_var the_home_finder 
    = obtain_ref_for_home_finder( the_orb.in() );


  //
  // Creation of component1
  //
  Components::CCMObject_var comp1_ref;
  {
    Components::CCMHome_var home
      = the_home_finder->find_home_by_home_type( "IDL:component1_home/1.0" );
  
    
    Components::KeylessCCMHome_var kch
      = Components::KeylessCCMHome::_narrow( home.in() );
    
    comp1_ref = kch->create_component();
  }


  //
  // Creation of component2
  //
  Components::CCMObject_var comp2_ref;
  {
    Components::CCMHome_var home
      = the_home_finder->find_home_by_home_type( "IDL:component2_home/1.0" );
  
    
    Components::KeylessCCMHome_var kch
      = Components::KeylessCCMHome::_narrow( home.in() );
    
    comp2_ref = kch->create_component();
  }
  
  
  // 
  // Component2 is connecting to component1 via my_interface_1.
  //

  // Obtain my_interface_1 facet from component1

  CORBA::Object_var  ref_facet = comp1_ref->provide_facet( "the_intf1" );
  my_interface_1_var ref_facet_typed = my_interface_1::_narrow( ref_facet );

  // Connect component2 receptacle (C2Receptacle_my_interface_1) to component1
  comp2_ref->connect("component2Receptacle_my_interface_1", ref_facet_typed);
  cerr << "Component1 and component2 are connected." << endl;
  
  // Obtain my_interface_3 from component2
  CORBA::Object_var facet_my_interface_3_ref = comp2_ref->provide_facet( "the_intf3" );
  my_interface_3_var facet_my_interface_3_typed = my_interface_3::_narrow( facet_my_interface_3_ref );
  
  if(CORBA::is_nil(facet_my_interface_3_typed))
    {
      cerr << "interface3 doesn't exist." << endl;
    }
  cerr << "Call to component2: method do_something3 of interface3's facet." << endl;
  
  // Call to my_interface_3 from my_interface_3, which in turn call my_interface_1 from compoent1.
  facet_my_interface_3_typed->do_something3();
  
  the_orb->destroy();

  return 0;
}
