
#include <obtain_ref_home_finder.h>
#include <Lw_ComponentsC.h>
#include <microccm_I1C.h>
#include <microccm_I2C.h>

#include <iostream>
#include <cstdlib>
#include <fstream>
#include <string>
#include <signal.h>

using namespace std;



  
int main( int argc, char* argv[] )
{
  // int argc = 2;
  //   char** argv = new char*[2];
  //   argv[0] = strdup("test_example.exe");
  //   argv[1] = strdup("-ORBInitRef NameService=corbaloc:iiop:localhost:9876/NameService");

  CORBA::ORB_ptr  the_orb = CORBA::ORB_init( argc, argv );

  Components::HomeFinder_var the_home_finder
    = obtain_ref_for_home_finder( the_orb );

  
  //
  // Creation of component1
  //
  if(!the_home_finder)
    cerr << "home finder not defined !" << endl;

  cerr << __PRETTY_FUNCTION__ << ":" << __LINE__ << endl;
  Components::CCMObject_var component1_ref;
  {
    Components::CCMHome_var home
      = the_home_finder->find_home_by_home_type( "IDL:component1_home/1.0" );
  
    cerr << __PRETTY_FUNCTION__ << ":" << __LINE__ << endl;
    Components::KeylessCCMHome_var kch
      = Components::KeylessCCMHome::_narrow( home.in() );
    cerr << __PRETTY_FUNCTION__ << ":" << __LINE__ << endl;
    component1_ref = kch->create_component();
  }

  cerr << __PRETTY_FUNCTION__ << ":" << __LINE__ << endl;
  //
  // Creation of component2
  //
  Components::CCMObject_var component2_ref;
  {
    Components::CCMHome_var home
      = the_home_finder->find_home_by_home_type( "IDL:component2_home/1.0" );
  
    
    Components::KeylessCCMHome_var kch
      = Components::KeylessCCMHome::_narrow( home.in() );
    
    component2_ref = kch->create_component();
  }
  
  cerr << __PRETTY_FUNCTION__ << ":" << __LINE__ << endl;
  // 
  // Component2 is connecting to component1 via my_interface_1.
  //
  
  // Obtain my_interface_1 facet from component1
  
  CORBA::Object_var  the_intf1_facet_obj = component1_ref->provide_facet( "my_interface_1" );
  I1_var the_intf1_facet_ref = I1::_narrow( the_intf1_facet_obj );

  try
    {
      // 1 supp to 1 consumer OK
      // 1 supp to n consumers OK
      // supp1, supp2  to n consumers_supp1 OK
      // supp1_T1, supp2_T1, supp3_T2 to n consumers_T1
      cerr << __PRETTY_FUNCTION__ << ":" << __LINE__ << endl;
      Components::EventConsumerBase_ptr my_event1_subscriber_ref = component2_ref->get_consumer("MyEvent1_sink");
      Components::EventConsumerBase_ptr my_event1_subscriber2_ref = component2_ref->get_consumer("MyEvent2_sink");
      cerr << __PRETTY_FUNCTION__ << ":" << __LINE__ << endl;
      Components::Cookie* ck_sink1 = component1_ref->subscribe("MyEvent1_source1", my_event1_subscriber_ref );
      Components::Cookie* ck_sink2 = component1_ref->subscribe("MyEvent1_source2", my_event1_subscriber2_ref );
      
      the_intf1_facet_ref->send_event();
      cerr << __PRETTY_FUNCTION__ << ":" << __LINE__ << endl;
      component1_ref->unsubscribe("MyEvent1_source1", *ck_sink1);
      component1_ref->unsubscribe("MyEvent1_source2", *ck_sink2);

    }
  catch(Components::InvalidName &e)
    {
      cerr << "Exception: " << e << endl;
    }
  catch(Components::AlreadyConnected &e)
    {
      cerr << "Exception: " << e << endl;
    }
  catch(CORBA::SystemException &e)
    {
      cerr << "SystemException: " << e << endl;
    }
  catch(...)
    {
      cerr << "Unknown exception catched..." << endl;
    }

  the_orb->destroy();

  return 0;
}

