
#include <I1C.h>
#include <Lw_ComponentsC.h>
#include <HomeFinderC.h>
#include <obtain_ref_home_finder.h>

#include <iostream>
#include <cstdlib>
#include <fstream>
#include <string>

using namespace std;

int main( int argc, char** argv )
{
  cerr << "Start of executable." << endl;

  // --
  CORBA::ORB_var the_orb = CORBA::ORB_init( argc, argv );
   
  cerr << "nb arg client: " << argc << endl;
  for( int i=0; i < argc; ++i)
    {
      cerr << "arg : " << i << argv[i] << endl;
    }

  
  // --
  Components::HomeFinder_var ref_for_home_finder
    = obtain_ref_for_home_finder( the_orb.in() );

  // --
  Components::CCMHome_var home_c1_
    = ref_for_home_finder->find_home_by_home_type( "IDL:comp1_home/1.0" );
  Components::KeylessCCMHome_var home_c1
    = Components::KeylessCCMHome::_narrow( home_c1_.in() );


  // --
  Components::CCMHome_var home_c2_
    = ref_for_home_finder->find_home_by_home_type( "IDL:comp2_home/1.0" );
  Components::KeylessCCMHome_var home_c2
    = Components::KeylessCCMHome::_narrow( home_c2_.in() );


  // --
  Components::CCMObject_ptr c1_instance = home_c1->create_component();
  Components::CCMObject_ptr c2_instance = home_c2->create_component();


  try
    {
      cerr << "All components are ready. Tests are starting." << endl;
      CORBA::Object_var  the_intf1_facet_obj = c1_instance->provide_facet( "my_interface_1" );
      I1_var the_intf1_facet_ref = I1::_narrow( the_intf1_facet_obj );
      
      the_intf1_facet_ref->set_ushort(1);
      the_intf1_facet_ref->set_ulong(2);

      cerr << "End of tests. All components are removed." << endl;
      home_c1_->remove_component(c1_instance);
      home_c2_->remove_component(c2_instance);
   }

  catch(Components::InvalidName &e)
    {
      cerr << "Exception: " << e << endl;
    }
  catch(Components::AlreadyConnected &e)
    {
      cerr << "Exception: " << e << endl;
    }
  catch(CORBA::SystemException &e)
    {
      cerr << "SystemException: " << e << endl;
    }
  catch(...)
    {
      cerr << "Unknown exception catched..." << endl;
    }
  
  cerr << "End of executable." << endl;
  the_orb->destroy();

  return 0;
}
