#include "tinyxml.h"
#include <iostream.h>

using namespace std;

//
// This file demonstrates some basic functionality of TinyXml.
// Note that the example is very contrived. It presumes you know
// what is in the XML file. But it does test the basic operations,
// and show how to add and remove nodes.
//
TiXmlNode* getChild(TiXmlNode* father, string child);
string getValue(TiXmlNode* node, string attribute);
string getTextValue(TiXmlElement elem, string name);
string getAttributeValue(TiXmlElement elem, string name);
int main()
{
  cout << "Lecture de assembly.cad.xml..." << endl;
  TiXmlDocument assemblyDoc( "../../CF/AMS/test/assembly.cad.xml" );
  assemblyDoc.LoadFile();
  assemblyDoc.Print( stdout );
  ////////////////////////////////////////
  // componentassembly element treatment
  ////////////////////////////////////////
  TiXmlNode *node = assemblyDoc.FirstChild( "componentassembly" );
 
  //assert( node );
  //TiXmlElement* assemblyElement = node->ToElement();

  // assembly ID
  //const string *assemblyIdValue = assemblyElement->Attribute("id");
  cout << "assemblyId=" << getValue(node, "id") << endl; //*assemblyIdValue << endl;

  // assembly description
  node = getChild(node, "description");//assemblyElement->FirstChild("description");
  //assert(node);
  //TiXmlElement* assemblyDescr = node->ToElement();
  //node = assemblyDescr->FirstChild();
  //TiXmlText* assemblyDescrText = node->ToText();
  //string assemblyDescrValue = assemblyDescrText->Value();
  cout << "   assemblyDescr=" << getValue(node, "") << endl;; //assemblyDescrValue << endl;

  /*  //////////////////////////////////////
  // componentfiles element
  //////////////////////////////////////
  node = assemblyElement->FirstChild("componentfiles");
  TiXmlElement* componentfiles = node->ToElement();
  
  node = componentfiles->FirstChild("componentfile");
  TiXmlElement* componentFile = node->ToElement();
  while ( node != NULL) {
    node = componentFile->NextSibling("componentfile");
    // component file ID
    const string *cmpFileIdValue = componentFile->Attribute("id");
    cout << "   componentId=" << *cmpFileIdValue << endl;

    // file name
    TiXmlNode* node2 = componentFile->FirstChild("fileinarchive");
    const string *fileNameValue = node2->ToElement()->Attribute("name");
    cout << "      file name=" << *fileNameValue << endl;
    
    if (node != NULL) 
      componentFile = node->ToElement();
  }
  //////////////////////////////////////
  // end of componentfiles element
  //////////////////////////////////////
  
  //////////////////////////////////////
  // partitioning element
  //////////////////////////////////////
  node = assemblyElement->FirstChild("partitioning");
  TiXmlElement* partitioning = node->ToElement();

  
  // Home placement case
  node = partitioning->FirstChild("homeplacement");
  TiXmlElement* homeplacement = node->ToElement();
  while ( node != NULL) {
    node = homeplacement->NextSibling("homeplacement");
    // home placement ID
    const string *homePlctIdValue = homeplacement->Attribute("id");
    cout << "      homePlacementId=" << *homePlctIdValue << endl;

    TiXmlNode* node2 = homeplacement->FirstChild("componentfileref");
    TiXmlElement* componentFileRef = node2->ToElement();
    const string *cmpFileRefIdValue = componentFileRef->Attribute("idref");
    cout << "         idref=" << *cmpFileRefIdValue << endl;

    node2 = homeplacement->FirstChild("componentinstantiation");
    TiXmlElement* componentInstantiation = node2->ToElement();
    const string *cmpInstIdValue = componentInstantiation->Attribute("id");
    cout << "         id=" << *cmpInstIdValue << endl;
    
    node2 = homeplacement->FirstChild("registerwithnaming");
    TiXmlElement* componentNaming = node2->ToElement();
    const string *namingValue = componentNaming->Attribute("name");
    cout << "         name=" << *namingValue << endl;
    
    node2 = homeplacement->FirstChild("destination");
    TiXmlElement* destination = node2->ToElement();
    node2 = destination->FirstChild();
    TiXmlText* destinationText = node2->ToText();
    string destinationValue = destinationText->Value();
    cout << "         destination=" << destinationValue << endl;
    
    if (node != NULL) 
      homeplacement = node->ToElement();
  }
  //////////////////////////////////////
  // end of partitioning element
  //////////////////////////////////////
  
  //////////////////////////////////////
  // connection element
  //////////////////////////////////////
  node = assemblyElement->FirstChild("connections");
  TiXmlElement* connections = node->ToElement();
  
  node = connections->FirstChild("connectinterface");
  TiXmlElement* connectinterface = node->ToElement();
  while ( node != NULL) {
    // connect interface
    node = connectinterface->NextSibling("connectinterface");
    // connection ID
    const string *cnxInterfaceIdValue = connectinterface->Attribute("id");
    cout << "   cnxInterfaceId=" << *cnxInterfaceIdValue << endl;
    cout << "      uses port" << endl;
    // uses port
    TiXmlNode* node2 = connectinterface->FirstChild("usesport");
    TiXmlElement* usesPort = node2->ToElement();
    node2 = usesPort->FirstChild("usesidentifier");
    TiXmlElement* usesidentifier = node2->ToElement();
    node2 = usesidentifier->FirstChild();
    TiXmlText* usesIdText = node2->ToText();
    string usesIdValue = usesIdText->Value();
    cout << "         usesId=" << usesIdValue << endl;
 
    node2 = usesPort->FirstChild("componentinstantiationref");
    TiXmlElement* componentIdRef = node2->ToElement();
    const string *cmpIdRefValue = componentIdRef->Attribute("idref");
    cout << "         componentIdRef=" << *cmpIdRefValue << endl;
  
    cout << "      provides port" << endl;
    // provides port
    node2 = connectinterface->FirstChild("providesport");
    TiXmlElement* providesPort = node2->ToElement();
    node2 = providesPort->FirstChild("providesidentifier");
    TiXmlElement* providesidentifier = node2->ToElement();
    node2 = providesidentifier->FirstChild();
    TiXmlText* providesIdText = node2->ToText();
    string providesIdValue = providesIdText->Value();
    cout << "         providesId=" << providesIdValue << endl;
 
    node2 = providesPort->FirstChild("componentinstantiationref");
    componentIdRef = node2->ToElement();
    cmpIdRefValue = componentIdRef->Attribute("idref");
    cout << "         componentIdRef=" << *cmpIdRefValue << endl;

    if (node != NULL) 
      connectinterface = node->ToElement();
  }

  // connect event
  node = connections->FirstChild("connectevent");
  TiXmlElement* connectevent = node->ToElement();
  while ( node != NULL) {
    // connect event
    node = connectevent->NextSibling("connectevent");
    // connection ID
    const string *cnxEventIdValue = connectevent->Attribute("id");
    cout << "   cnxEventId=" << *cnxEventIdValue << endl;
    cout << "      consumes port" << endl;
    // uses port
    TiXmlNode* node2 = connectevent->FirstChild("consumesport");
    TiXmlElement* consumesPort = node2->ToElement();
    node2 = consumesPort->FirstChild("consumesidentifier");
    TiXmlElement* consumesidentifier = node2->ToElement();
    node2 = consumesidentifier->FirstChild();
    TiXmlText* consumesIdText = node2->ToText();
    string consumesIdValue = consumesIdText->Value();
    cout << "         consumesId=" << consumesIdValue << endl;
 
    node2 = consumesPort->FirstChild("componentinstantiationref");
    TiXmlElement* componentIdRef = node2->ToElement();
    const string *cmpIdRefValue = componentIdRef->Attribute("idref");
    cout << "         componentIdRef=" << *cmpIdRefValue << endl;
  
    cout << "      emits port" << endl;
    // provides port
    node2 = connectevent->FirstChild("emitsport");
    TiXmlElement* emitsPort = node2->ToElement();
    node2 = emitsPort->FirstChild("emitsidentifier");
    TiXmlElement* emitsidentifier = node2->ToElement();
    node2 = emitsidentifier->FirstChild();
    TiXmlText* emitsIdText = node2->ToText();
    string emitsIdValue = emitsIdText->Value();
    cout << "         emitsId=" << emitsIdValue << endl;
 
    node2 = emitsPort->FirstChild("componentinstantiationref");
    componentIdRef = node2->ToElement();
    cmpIdRefValue = componentIdRef->Attribute("idref");
    cout << "         componentIdRef=" << *cmpIdRefValue << endl;

    if (node != NULL) 
      connectinterface = node->ToElement();
  }
  //////////////////////////////////////
  // end of connection element
  //////////////////////////////////////
  ////////////////////////////////////////
  // end of componentassembly element treatment
  ////////////////////////////////////////

  cout << "Lecture de ca.csd.xml..." << endl;
  TiXmlDocument componentDoc( "../../CF/AMS/test/ca.csd" );
  componentDoc.LoadFile();
  componentDoc.Print(stdout);

  ////////////////////////////////////////
  // softpkg element treatment
  ////////////////////////////////////////
  node = componentDoc.FirstChild( "softpkg" );
  assert( node );
  TiXmlElement* softpkgElement = node->ToElement();

  // softpkg name
  const string *softpkgNameValue = softpkgElement->Attribute("name");
  cout << "name=" << *softpkgNameValue << endl;

  // softpkg version
  const string *softpkgVersionValue = softpkgElement->Attribute("version");
  cout << "version=" << *softpkgVersionValue << endl;

  /////////////////////////
  // softpkg implementation
  /////////////////////////
  node = softpkgElement->FirstChild("implementation");
  TiXmlElement* implemElement = node->ToElement();
  // implementation id
  const string *implIdValue = implemElement->Attribute("id");
  cout << "implID=" << *implIdValue << endl;
  // descriptor file name
  node = implemElement->FirstChild("descriptor");
  TiXmlElement* descrElement = node->ToElement();
  node = descrElement->FirstChild("fileinarchive");
  TiXmlElement* fileElement = node->ToElement();
  const string *descrFileValue = fileElement->Attribute("name");
  cout << "descr file=" << *descrFileValue << endl;
  // code file
  cout << "code" << endl;
  node = implemElement->FirstChild("code");
  TiXmlElement* codeElement = node->ToElement();
  // type of code
  const string *typeValue = codeElement->Attribute("type");
  cout << "   Type code=" << *typeValue << endl;
  // file name
  node = codeElement->FirstChild("fileinarchive");
  fileElement = node->ToElement();
  const string *fileNameValue = fileElement->Attribute("name");
  cout << "   file=" << *fileNameValue << endl;
  // entry point
  node = codeElement->FirstChild("entrypoint");
  TiXmlElement *entryElement = node->ToElement();
  node = entryElement->FirstChild();
  TiXmlText* entryText = node->ToText();
  string entryValue = entryText->Value();
  cout << "   entrypoint=" << entryValue << endl;
  
  
  cout << "Lecture de Component1.ccd.xml..." << endl;
  TiXmlDocument CCDoc( "../../CF/AMS/test/Component1.ccd" );
  CCDoc.LoadFile();
  CCDoc.Print(stdout);

  ////////////////////////////////////////
  // softpkg element treatment
  ////////////////////////////////////////
  node = CCDoc.FirstChild( "corbacomponent" );
  assert( node );
  TiXmlElement* corbacmpElement = node->ToElement();
  // Component repository ID
  node = corbacmpElement->FirstChild("componentrepid");
  TiXmlElement* compRepIDElement = node->ToElement();
  const string *repIdValue = compRepIDElement->Attribute("repid");
  cout << "component repid=" << *repIdValue << endl;
  
  // Home repository ID
  node = corbacmpElement->FirstChild("homerepid");
  TiXmlElement* homeRepIDElement = node->ToElement();
  repIdValue = homeRepIDElement->Attribute("repid");
  cout << "home repid=" << *repIdValue << endl;

  // Home features
  node = corbacmpElement->FirstChild("homefeatures");
  cout << "homefeatures" << endl;
  TiXmlElement* homeFeatElement = node->ToElement();
  const string* nameValue = homeFeatElement->Attribute("name");
  cout << "   name=" << *nameValue << endl;
  repIdValue = homeFeatElement->Attribute("repid");
  cout << "   repid=" << *repIdValue << endl;

  // Component features
  TiXmlNode *cmpFeatNode = corbacmpElement->FirstChild("componentfeatures");
  if (cmpFeatNode != NULL) {
    TiXmlElement* compFeatElement = cmpFeatNode->ToElement();
    while ( cmpFeatNode != NULL) {
      cmpFeatNode = compFeatElement->NextSibling("componentfeatures");
      cout << "componentfeatures" << endl;
      nameValue = compFeatElement->Attribute("name");
      cout << "   name=" << *nameValue << endl;
      repIdValue = compFeatElement->Attribute("repid");
      cout << "   repid=" << *repIdValue << endl;

      node = compFeatElement->FirstChild("inheritscomponent");
      if (node != NULL) {
	TiXmlElement* inherCompElement = node->ToElement();
	repIdValue = inherCompElement->Attribute("repid");
	cout << "      inher comp repid=" << *repIdValue << endl;
      }

      node = compFeatElement->FirstChild("supportsinterface");
      if (node != NULL) {
	TiXmlElement* supIntElement = node->ToElement();
	repIdValue = supIntElement->Attribute("repid");
	cout << "      support interface repid=" << *repIdValue << endl;
      }

      node = compFeatElement->FirstChild("ports");
      if (node != NULL) {
	TiXmlElement* portsElement = node->ToElement();
	cout << "      ports" << endl;
	node = portsElement->FirstChild("provides");
	if (node != NULL) {
	  TiXmlElement* providesElement = node->ToElement();
	  cout << "         provides" << endl;
	  while ( node != NULL) {
	    node = providesElement->NextSibling("provides");
	    nameValue = providesElement->Attribute("providesname");
	    cout << "            providesname=" << *nameValue << endl;
	    repIdValue = providesElement->Attribute("repid");
	    cout << "            repid=" << *repIdValue << endl;
	    const string *facettagValue = providesElement->Attribute("facettag");
	    cout << "            facettag=" << *facettagValue << endl;
	    if (node != NULL) 
	      providesElement = node->ToElement();
	  }
	}
	
	node = portsElement->FirstChild("uses");
	if (node != NULL) {
	  TiXmlElement* usesElement = node->ToElement();
	  cout << "         uses" << endl;
	  while ( node != NULL) {
	    node = usesElement->NextSibling("uses");
	    nameValue = usesElement->Attribute("usesname");
	    cout << "            usesname=" << *nameValue << endl;
	    repIdValue = usesElement->Attribute("repid");
	    cout << "            repid=" << *repIdValue << endl;
	    if (node != NULL) 
	      usesElement = node->ToElement();
	  }
	}
	
	node = portsElement->FirstChild("emits");
	if (node != NULL) {
	  TiXmlElement* emitsElement = node->ToElement();
	  cout << "         emits" << endl;
	  while ( node != NULL) {
	    node = emitsElement->NextSibling("emits");
	    nameValue = emitsElement->Attribute("emitsname");
	    cout << "            emitsname=" << *nameValue << endl;
	    repIdValue = emitsElement->Attribute("eventtype");
	    cout << "            repid=" << *repIdValue << endl;
	    if (node != NULL) 
	      emitsElement = node->ToElement();
	  }
	}
	
	node = portsElement->FirstChild("publishes");
	if (node != NULL) {
	  TiXmlElement* publishesElement = node->ToElement();
	    cout << "         publishes" << endl;
	    while ( node != NULL) {
	      node = publishesElement->NextSibling("publishes");
	      nameValue = publishesElement->Attribute("publishesname");
	      cout << "            publishesname=" << *nameValue << endl;
	      repIdValue = publishesElement->Attribute("eventtype");
	      cout << "            repid=" << *repIdValue << endl;
	      if (node != NULL) 
		publishesElement = node->ToElement();
	    }
	}
      }
      if (cmpFeatNode != NULL) 
	compFeatElement = cmpFeatNode->ToElement();
    }
  }

  // interface element
  TiXmlNode *interfaceNode = corbacmpElement->FirstChild("interface");
  if (interfaceNode != NULL) {
    TiXmlElement* interfaceElement = interfaceNode->ToElement();
    while ( interfaceNode != NULL) {
      cout << "interface" << endl;
      interfaceNode = interfaceElement->NextSibling("interface");
      nameValue = interfaceElement->Attribute("name");
      cout << "   name=" << *nameValue << endl;
      repIdValue = interfaceElement->Attribute("repid");
      cout << "   repid=" << *repIdValue << endl;
      if (interfaceNode != NULL) 
	interfaceElement = interfaceNode->ToElement();
    }
  }
  */      
  return 0;
}

TiXmlNode* getChild(TiXmlNode* father, string child) {
  if (father != NULL) {
    TiXmlElement* element = father->ToElement();
    TiXmlNode* node = element->FirstChild(child);
    return node;
  }
  return NULL;
}

string getValue(TiXmlNode *node, string attribute) {
  if (node != NULL && attribute != "") {
    TiXmlElement* element = node->ToElement();
    const string *p_value = element->Attribute(attribute);
    return *p_value;
  }

  if (node != NULL && attribute == "") {
    TiXmlElement* element = node->ToElement();
    TiXmlNode *node2 = element->FirstChild();
    TiXmlText* text = node2->ToText();
    string value = text->Value();
    return value;
  }
  return 0;
}

string getTextValue(TiXmlElement *elem, string name) {
}

string getAttributeValue(TiXmlElement *elem, string name) {
}
