#ifndef _TFTP_H
#define _TFTP_H

#include "stdio.h"

#define K_DONE					-1
#define K_ERROR_UNDEFINED       0     /*    Not defined, see error message (if any). */
#define K_ERROR_FILENOTFOUND    1     /*    File not found.                          */
#define K_ERROR_ACCESSVIOLATION 2     /*    Access violation.                        */
#define K_ERROR_DISKFULL        3     /*    Disk full or allocation exceeded.        */
#define K_ERROR_ILLEGALOP       4     /*    Illegal TFTP operation.                  */
#define K_ERROR_UNKNOWNTRDID    5     /*    Unknown transfer ID.                     */
#define K_ERROR_FILEEXIST       6     /*    File already exists.                     */
#define K_ERROR_NOSUCHUSER      7     /*    No such user.                            */
#define K_ERROR_INCTRAME	    8     /*    incoherent TFTP Frame                    */
#define K_ERROR_MAXRETRY	    9     /*    Nombre de repetition atteinte            */
#define K_ERROR_NORESOURCE	    10    /*    Plus de ressource TFTP		             */

#define K_MODE_READ				1
#define K_MODE_WRITE			2

#define K_ARRET					1
#define K_BOUCLE				0

#define K_TFTP_SERVEUR			1
#define K_TFTP_CLIENT			2
#define K_TFTP_SERVEUR_CLIENT	3

#define K_CST_SERVEUR_CLIENT	"SERVEUR_CLIENT"
#define K_CST_CLIENT			"CLIENT"

typedef size_t (*t_readFile)  (void *ptr, size_t size, size_t nmemb, FILE *stream);
typedef FILE   *(*t_fopenFile)  (const char *filename, const char *mode);
typedef size_t (*t_fwriteFile) (const void *ptr, size_t size, size_t nmemb, FILE *stream);
typedef int    (*t_fcloseFile) (FILE *stream);

typedef struct
{
	t_fopenFile  fopen;
	t_fcloseFile fclose;
	t_readFile   fread;
	t_fwriteFile fwrite;
} t_access_file;

typedef struct
{
	int base_timeout;
	int max_timeout;
	int nb_max_retry;
	int size_bl_data;
} t_conf_tftp;

typedef void (*t_fct_callBack) (int, void *);

#ifdef __cplusplus
#warning "coucou coucou coucou"
extern "C" {
#endif
int tftp_request (int mode, char *local_file_name, char *remote_file,
					unsigned long ip_server, unsigned short port_server,
					t_fct_callBack fct, void *args, t_access_file *f);

extern int init_tftp (int comportement, t_access_file *,
						unsigned short port_server, t_conf_tftp *);
extern void init_tftp_psos (t_conf_tftp *);
extern int run_tftp (int parametre_arret);
extern void fct_callback (int error, void *args);
#ifdef __cplusplus
}
#endif

#endif /* _TFTP_H */
/* left blank for compiler compatibility */
