/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2004 INRIA & USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Christophe Demarey.
Contributor(s): ________________________________________.

====================================================================*/

package org.objectweb.corba.generator.cif.api;


import org.objectweb.openccm.ast.api.Scope;
import org.objectweb.openccm.generator.common.lib.GenerationException;


/**
 * This is the interface for CIF implementation generator.
 *
 * @author <a href="mailto:Christophe.Demarey@lifl.fr">Christophe Demarey</A>
 */

public interface CIF_JavaGenerator
         extends org.objectweb.openccm.generator.common.api.GeneratorBase
{
    /**
     * Generate java files for the CIF.
     *
     * @param base_dir - The base directory where files will be generated.
     * @param scope - The scope to map.
     **/
    public void
    cif_to_java(String base_dir, Scope scope)
    throws GenerationException;
}
