/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2004 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Mathieu Vadet, Philippe Merle.
Contributor(s): ______________________________________.

====================================================================*/

package org.objectweb.openccm.Components;

/**
 * This class implements the Components::SubscriberDescription valuetype.
 *
 * @author <a href="mailto:Philippe.Merle@lifl.fr">Philippe Merle</a>
 *         <a href="mailto:Mathieu.Vadet@lifl.fr">Mathieu Vadet</a>
 *
 * @version 0.4
 */

public class SubscriberDescriptionImpl
     extends org.omg.Components.SubscriberDescription
  implements EventConsumerBaseHolder
{
    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================

    /** Initial reference of the event consumer. */
    protected org.omg.Components.EventConsumerBase initial_consumer_;

    // ==================================================================
    //
    // Constructor.
    //
    // ==================================================================

    /**
     **  The default constructor.
     **/
    public
    SubscriberDescriptionImpl()
    {
    }

    /**
     **  The constructor.
     **
     **  @param ck The cookie associated to the connection.
     **  @param objref The connection reference.
     **/
    public
    SubscriberDescriptionImpl(org.omg.Components.Cookie ck,
                              org.omg.Components.EventConsumerBase consumer)
    {
        // Inits internal state.
        this.ck = ck;
        this.consumer = consumer;
        this.initial_consumer_ = consumer;
    }

    // ==================================================================
    //
    // Internal methods.
    //
    // ==================================================================

    // ==================================================================
    // 
    //  Public methods for EventConsumerBaseHolder.
    // 
    // ==================================================================

    /**
     * Gets the reference of the event consumer.
     */
    public org.omg.Components.EventConsumerBase
    getEventConsumerBase()
    {
        return initial_consumer_;
    }

    /**
     * Sets the reference of the event consumer.
     */
    public void
    setEventConsumerBase(org.omg.Components.EventConsumerBase ecb)
    {
        consumer = ecb;
    }

    // ==================================================================
    // 
    //  Public methods.
    // 
    // ==================================================================
}
