
/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2003 INRIA & USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Hameau Fabien.
Contributor(s): ______________________________________.

====================================================================*/

package org.objectweb.openccm.Containers.MetaInformation;

/**
 * Instance MI for attribute conceopt of CCM
 * An attribute can be bound to a comoponent, 
 * a home or an interface MI object.
 *
 * @author <a href="mailto:hameau@lifl.fr">Hameau</a>
 *
 * @version 0.1
 */

public class AttributeInstanceImpl
extends InstanceImpl
implements AttributeInstance
{
  
  // ==================================================================
  //
  // Internal states.
  //
  // ==================================================================

  /** Instance MI for component getter attribute*/  
  private GetterAttributeInstance _getter_attribute_instance;
  /** Instance MI for component setter attribute*/
  private SetterAttributeInstance _setter_attribute_instance;

  // ==================================================================
  //
  // Internal methods.
  //
  // ==================================================================
  
  // NONE
  
  //

  // ==================================================================
  //
  //  Public methods for ccm.Containers.MetaInformation::AttributeInstance.
  //
  // ==================================================================
  
  
  public GetterAttributeInstance getter_attribute_instance()
  {
    return _getter_attribute_instance;
  }

  /* (non-Javadoc)
   * @see org.objectweb.openccm.Containers.MetaInformation.AttributeInstanceOperations#getter_attribute_instance(org.objectweb.openccm.Containers.MetaInformation.GetterAttributeInstance)
   */
   
  public void getter_attribute_instance(GetterAttributeInstance value)
  {
    _getter_attribute_instance = value;
  }

  /* (non-Javadoc)
   * @see org.objectweb.openccm.Containers.MetaInformation.AttributeInstanceOperations#setter_attribute_instance()
   */
  public SetterAttributeInstance setter_attribute_instance()
  {
    return _setter_attribute_instance;
  }

  /* (non-Javadoc)
   * @see org.objectweb.openccm.Containers.MetaInformation.AttributeInstanceOperations#setter_attribute_instance(org.objectweb.openccm.Containers.MetaInformation.SetterAttributeInstance)
   */
  public void setter_attribute_instance(SetterAttributeInstance value)
  {
    _setter_attribute_instance = value;
  }
}
