/*====================================================================

created on 20 mars 2003

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2001-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Hameau Fabien.
Contributor(s): ______________________________________.

*/

package org.objectweb.openccm.Containers.MetaInformation;

/**
 * @author hameau
 */
public class InterfaceInstanceImpl 
extends InstanceImpl
implements InterfaceInstance{

  protected InterfaceType         _interface_type;
  protected OperationInstanceList _operation_instance_list;
  
  public InterfaceInstanceImpl()
  {
    _operation_instance_list = new OperationInstanceListImpl();
  }
  
  /* (non-Javadoc)
   * @see org.objectweb.openccm.Containers.InterfaceInstanceOperations#interface_type()
   */
  public InterfaceType interface_type() {
  	
  	return _interface_type;
  }
  
  /* (non-Javadoc)
   * @see org.objectweb.openccm.Containers.InterfaceInstanceOperations#interface_type(org.objectweb.openccm.Containers.InterfaceType)
   */
  public void interface_type(InterfaceType value) {
  	
  	_interface_type = value;
  }

  /* (non-Javadoc)
   * @see org.objectweb.openccm.Containers.MetaInformation.InterfaceInstanceOperations#operation_instance_list()
   */
  public OperationInstanceList operation_instance_list()
  {
    return _operation_instance_list;
  }

  /* (non-Javadoc)
   * @see org.objectweb.openccm.Containers.MetaInformation.InterfaceInstanceOperations#operation_instance_list(org.objectweb.openccm.Containers.MetaInformation.OperationInstanceList)
   */
  public void operation_instance_list(OperationInstanceList value)
  {
    _operation_instance_list = value;
  }

}
