#! /bin/sh -f
# ====================================================================
#
# OpenCCM: The Open CORBA Component Model Platform
# Copyright (C) 2000-2003 INRIA - USTL - LIFL - GOAL
# Contact: openccm-team@objectweb.org
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
# USA
#
# Initial developer(s): Philippe Merle.
# Contributor(s):
#
# ====================================================================

# Ant compilation if needed.
#
if [ ! -f generated/idl/simple.idl -o ! -f archives/simple.jar ]
then
    ./build.sh
fi

# ====================================================================
# Install the OpenCCM Platform.
# ====================================================================

ccm_install

# ====================================================================
# Start the Name Service.
# ====================================================================

ns_start

# Obtain the IOR of the started Name Service.
#
ior_NS=`ns_ior`

# ====================================================================
# Start a Java Component Server named ComponentServer.
# ====================================================================

jcs_start ComponentServer

# ====================================================================
#  Install the demonstration.
# ====================================================================

echo "Starting various home deployment"

jvm_args="-Dior_ns=$ior_NS"

launcher.sh exec "$jvm_args" "simple.xml"

# ====================================================================
# Stop the Java Component Server named ComponentServer.
# ====================================================================

jcs_stop ComponentServer

# ====================================================================
# Deinstall the OpenCCM Platform.
# ====================================================================

ccm_deinstall




