/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2004 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Christophe Contreras
Contributor(s): ___________________________________________________.

====================================================================*/

package org.objectweb.openccm.packaging;

/**
 * This is the action class for opening a CPF from a software package descriptor
 *
 */
public class PropertyfileEditActionListener
  implements org.objectweb.util.browser.api.MenuItem
{
    /**
     *  Status of the menu item
     *
     * @param treeView to obtain the activated node
     */
    public int
    getStatus(org.objectweb.util.browser.api.TreeView treeView)
    {
        return org.objectweb.util.browser.api.MenuItem.ENABLED_STATUS;
    }

    public void
    actionPerformed (org.objectweb.util.browser.api.MenuItemTreeView the_event)
    {
        // gets the calling tree
        org.objectweb.util.browser.core.common.DynamicTree calling_tree
         = (org.objectweb.util.browser.core.common.DynamicTree)
           the_event.getTree();

        //gets the frame
        org.objectweb.apollon.gui.ApollonFrame calling_frame
         = (org.objectweb.apollon.gui.ApollonFrame)
            calling_tree.getRootPane().getParent();

        // gets the calling XML element
        org.objectweb.openccm.descriptor.softpkg.beans.PropertyfileBean zeus_instance
         = (org.objectweb.openccm.descriptor.softpkg.beans.PropertyfileBean)
           the_event.getSelectedObject();

        FileOperations.open_file(
            new java.io.File(zeus_instance.getFileinarchive().getName())
            , calling_frame
            );
    }
}
