/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2004 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Christophe Contreras
Contributor(s): ___________________________________________________.

====================================================================*/

package org.objectweb.openccm.packaging.widgets;

/**
 * This is a widget allowing to choose a programming language type
 * in a Node Properties Descriptor
 *
 * @author <a href="mailto:Christophe.Contreras@lifl.fr">Christophe Contreras</a>
 *
 */
public class ProgramminglanguageType
     extends org.objectweb.apollon.gui.bricks.AbstractBrick
{
    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================

    /** the swing scroll list */
    private javax.swing.JComboBox scrolling_list;

    // ==================================================================
    //
    // Constructors.
    //
    // ==================================================================

    /**
     *  The default constructor.
     */
    public
    ProgramminglanguageType ()
    {
        this ("Type");
    }

    /**
     *  The constructor with a label
     */
    public
    ProgramminglanguageType (String label)
    {
        super (label);

        // the possible values
        String[] values
         = {
            "compiler"
            ,"interpreter"
            };

        // inits the scroll list
        scrolling_list = new javax.swing.JComboBox(values);

        // sets a default value in the list
        set("compiler");
        scrolling_list.validate();

        this.add(this.scrolling_list);
    }

    // ==================================================================
    //
    // Public methods.
    //
    // ==================================================================

    /**
     * The getter method
     */
    public String
    get()
    {
        return (String)this.scrolling_list.getSelectedItem();
    }

    /**
     * The setter method
     */
    public void
    set (String resource_type)
    {
        this.scrolling_list.setSelectedItem(resource_type);
    }
}
