/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2004 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Christophe Contreras
Contributor(s): ___________________________________________________.

====================================================================*/

package org.objectweb.openccm.packaging.widgets;

/**
 * This is a widget allowing to set a component package version
 *
 *
 * @author <a href="mailto:Christophe.Contreras@lifl.fr">Christophe Contreras</a>
 *
 */
public class SoftpkgVersion
     extends org.objectweb.apollon.gui.bricks.AbstractBrick
{
    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================

    /**
     * JDK 1.3 does not support JSpinner
     * so this is commented out to avoid compilation problems
     */
    /** the spinners for setting version */
/*
    private javax.swing.JSpinner[] version_numbers
     = {
        new javax.swing.JSpinner(),
        new javax.swing.JSpinner(),
        new javax.swing.JSpinner(),
        new javax.swing.JSpinner(),
        };
*/

    private javax.swing.JTextField[] version_numbers
     = {
        new javax.swing.JTextField(),
        new javax.swing.JTextField(),
        new javax.swing.JTextField(),
        new javax.swing.JTextField(),
        };

    // ==================================================================
    //
    // Constructors.
    //
    // ==================================================================

    /**
     *  The default constructor.
     */
    public
    SoftpkgVersion ()
    {
        this ("Version");
    }

    /**
     *  The constructor with a label.
     */
    public
    SoftpkgVersion (String label)
    {
        super (label);
/*        // inits the spinners
        version_numbers[0] = new javax.swing.JSpinner();
        version_numbers[1] = new javax.swing.JSpinner();
        version_numbers[2] = new javax.swing.JSpinner();
        version_numbers[3] = new javax.swing.JSpinner();
*/
        javax.swing.JPanel content = new javax.swing.JPanel();

        // building of the content panel with commas
        content.add(this.version_numbers[0]);
        content.add(new javax.swing.JLabel(","));
        content.add(this.version_numbers[1]);
        content.add(new javax.swing.JLabel(","));
        content.add(this.version_numbers[2]);
        content.add(new javax.swing.JLabel(","));
        content.add(this.version_numbers[3]);

        // adding the content to the panel
        this.add(content);
    }

    // ==================================================================
    //
    // Public methods.
    //
    // ==================================================================

    /**
     * The getter method
     */
    public String
    get()
    {

        // buidling of the version string
        String version
         =  version_numbers[0].getText()
            +","
            + version_numbers[1].getText()
            +","
            + version_numbers[2].getText()
            +","
            + version_numbers[3].getText()
            ;
        /**
         * JDK 1.3 does not support JSpinner
         * so this is commented out to avoid compilation problems
         */
/*
         =  version_numbers[0].getValue().toString()
            +","
            + version_numbers[1].getValue().toString()
            +","
            + version_numbers[2].getValue().toString()
            +","
            + version_numbers[3].getValue().toString()
            ;
*/

        return version;
    }

    /**
     * The setter method
     */
    public void
    set(String formated_version)
    {

        /**
         * JDK 1.3 does not support split method
         * so this is commented out to avoid compilation problems
         */
        // parse the version string to extract major/minor version numbers
/*        String [] version_array
         = formated_version
            .split(",");

        // sets the spinners with found values
        for (int i = 0 ; i < version_array.length ; i++)
        {
//            version_numbers[i].setValue(Integer.decode(version_array[i]));
            version_numbers[i].setText(version_array[i]);
        }
*/
        java.util.StringTokenizer version_array;
        if (formated_version != null)
        {
            version_array
             = new java.util.StringTokenizer (formated_version,",");
        }
        else
        {
            version_array
             = new java.util.StringTokenizer("",",");
        }
        for (int i = 0 ; i < 4 ; i++)
        {
            if (version_array.hasMoreTokens())
            {
                version_numbers[i].setText(version_array.nextToken());
            }
            else
            {
                version_numbers[i].setText("0");
            }
        }
    }

}
