#!/bin/sh -f
# ====================================================================
#
# OpenCCM: The Open CORBA Component Model Platform
# Copyright (C) 2000-2004 USTL - LIFL - GOAL
# Contact: openccm@objectweb.org
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
# USA
#
# Initial developer(s): Areski Flissi
# Contributor(s): 
#
# ====================================================================
#
# Starting an OpenCCM AssemblyFactory Manager.
#
# Usage: factory_start.sh <FactoryName>
#
# ====================================================================

# Checks the command line.

if [ $# != 1 ]
then
    echo "======================================================="
    echo "Usage: factory_start.sh <FactoryName>"
    echo "======================================================="
    exit 1
fi

mkdir @OpenCCM_CONFIG_DIR@/AssemblyFactoryManagers/$1/

af_path=@OpenCCM_CONFIG_DIR@/AssemblyFactoryManagers/$1
work_dir=@OpenCCM_CONFIG_DIR@/AssemblyFactoryManagers

# Get the IOR of the started NS
ns_ior=`cat @OpenCCM_CONFIG_DIR@/NameService.IOR`

# Get the IOR of the started DCI Manager
dci_ior=`cat @OpenCCM_CONFIG_DIR@/DCI.IOR`



echo "Starting the Assembly Factory"
@JVM@ -Dior_ns=$ns_ior -Dior_dci=$dci_ior -Dwork_dir=$work_dir org.objectweb.util.launcher.Launcher --runid factory_start NSREGISTER=OpenCCM/AssemblyFactoryManagers/$1 FACTORYNAME=$1 @OpenCCM_DIR@/xml/launcher/factory_server.xml
echo "The Assembly Factory $1 is started"