/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2004 INRIA & USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Philippe Merle.
Contributor(s): Mathieu Vadet, Christophe Demarey.

====================================================================*/

package org.objectweb.openccm.ir3;

/** 
 * Implementation of the CORBA::ComponentDef reference.
 *
 * @author <a href="mailto:Philippe.Merle@lifl.fr">Philippe Merle</a>
 *         <a href="mailto:Mathieu.Vadet@lifl.fr">Mathieu Vadet</a>
 *
 * @version 0.4
 */

public class ComponentDef_ref
     extends IDLType_ref
{
    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================

    // ==================================================================
    //
    // Constructors.
    //
    // ==================================================================

    /** 
     * TODO.
     */
    public
    ComponentDef_ref(IRObject_impl owner)
    {
        // Calls the IDLType_ref constructor.
        super(owner);
    }

    /** 
     * TODO.
     */
    public
    ComponentDef_ref(IRObject_impl owner,
                     ComponentDef_impl object)
    {
        super(owner, object);
    }

    // ==================================================================
    //
    // Public methods.
    //
    // ==================================================================

    /** 
     * Obtains its implementation.
     */
    public ComponentDef_impl
    getImpl()
    {
        return (ComponentDef_impl)(super.getBaseImpl());
    }

    /** 
     * Obtains its CORBA::ComponentDef reference.
     */
    public org.omg.CORBA.ComponentIR.ComponentDef
    asComponentDef()
    {
        if (getTarget() == null) return null;
        return getImpl().asComponentDef();
    }

    /** 
     * Obtain its repository ID.
     */
    public String
    getId()
    {
        if (getTarget() == null) return "";
        return getImpl().id();
    }
}
