/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2004 INRIA & USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Philippe Merle.
Contributor(s): Mathieu Vadet, Christophe Demarey.

====================================================================*/

package org.objectweb.openccm.ir3;

// Package dependencies
import org.omg.CORBA.TypeCode;
import org.omg.CORBA.IDLType;

/** 
 * Implementation of the CORBA::IDLType reference.
 *
 * @author <a href="mailto:Philippe.Merle@lifl.fr">Philippe Merle</a>
 *         <a href="mailto:Mathieu.Vadet@lifl.fr">Mathieu Vadet</a>
 *
 * @version 0.4
 */

public class IDLType_ref
     extends IRObject_ref
{
    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================

    // ==================================================================
    //
    // Constructors.
    //
    // ==================================================================

    /** 
     * TODO.
     */
    public
    IDLType_ref(IRObject_impl owner)
    {
        // Calls the IRObject_ref constructor.
        super(owner);
    }

    /** 
     * TODO.
     */
    public
    IDLType_ref(IRObject_impl owner,
                IRObject_impl object)
    {
        // Calls the IRObject_ref constructor.
        super(owner, object);
    }

    // ==================================================================
    //
    // Public methods.
    //
    // ==================================================================

    /** 
     *  Obtain its CORBA::TypeCode.
     *  TODO : remove -> replaced by next one for recursive typecodes management
     */
/**
    public TypeCode
    getTypeCode()
    {
        if (impl_ == null) return null;
        return impl_.type();
    }
 */

    /** 
     * Obtains its CORBA::TypeCode.
     */
    public TypeCode
    recursiveType(java.util.List idSeq)
    {
        if (getTarget() == null) return null;
        return getBaseImpl().recursiveType(idSeq);
    }

    /** 
     * Obtains its CORBA::TypeCode.
     */
    public TypeCode
    recursiveType()
    {
        if (getTarget() == null) return null;
        return getBaseImpl().type();
    }

    /** 
     * Obtains its CORBA::IDLType reference.
     */
    public IDLType
    asIDLType()
    {
        if (getTarget() == null) return null;
        return getBaseImpl().asIDLType();
    }
}
