/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2004 INRIA & USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Christophe Demarey.
Contributor(s): ______________________________________.

====================================================================*/

package org.objectweb.openccm.pss.runtime.common.api;


/**
 * Catalog is a base interface for Catalogs.
 *
 * @author <a href="mailto:Christophe.Demarey@lifl.fr">Christophe Demarey</a>
 *
 * @version 0.1
 */

public interface CatalogBase
         extends org.omg.CosPersistentState.CatalogBase
{
    /**
     * Set the reference to the connector.
     *
     * @param connector - The connector to set.
     */
    public void
    set_connector(org.objectweb.openccm.pss.runtime.common.api.Connector connector);

    /**
     * Get the reference to the connector.
     *
     * @return The associated connector.
     */
    public org.objectweb.openccm.pss.runtime.common.api.Connector
    get_connector();

    /**
     * Get the catalog ID.
     *
     * @return The associated ID.
     */
    public int
    get_id();
    
    /**
     * Register a storage home.
     *
     * @param storage_home_id - The storage home id.
     * @param storage_home - The binding class.
     */
    public void
    register_storage_home_incarnation(String storage_home_id,
                                      org.omg.CosPersistentState.StorageHomeBase storage_home);

    /**
     * Create a new storage_object incarnation.
     *
     * @param storage_type_id - The storage type id.
     *
     * @return A new storage object instance.
     */
    public org.objectweb.openccm.pss.runtime.common.api.StorageObject
    create_storage_object(String storage_type_id)
    throws org.omg.CosPersistentState.NotFound;
}
