/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2004 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Pierre Carpentier.
Contributor(s): Philippe Merle.

---------------------------------------------------------------------
$Id: CCMASTModelContext.java,v 1.1 2004/05/26 11:25:35 carpentier Exp $
====================================================================*/

package org.objectweb.openccm.uml.transformation.ast;

import ispuml.mdaTransformation.model.SimpleConceptNamesTranslator;
import ispuml.mdaTransformation.model.SimpleModelContext;

import org.objectweb.openccm.ast.api.Scope;

/**
 * A translator context suitable to any model.
 * This context handle OpenCCM AST related methods.
 * This class implements repository methods dedicated to CCM AST.
 */
public class CCMASTModelContext extends SimpleModelContext
{

   /**
    * Constructor.
    * This constructor use the default implementations of the NameTranslator,
    * the CCMPropertyUtil, and the CCMASTModelUtil.
    * @param scope The scope of the model.
    */
   public CCMASTModelContext(Scope scope)
   {
       setNameTranslator( new SimpleConceptNamesTranslator() );
       setProperty( new CCMPropertyUtil() );
       setModelUtil( new CCMASTModelUtil(getProperty(), scope) );
   }
   
}
