/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2004 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Pierre Carpentier.
Contributor(s): Philippe Merle.

---------------------------------------------------------------------
$Id: TypePrefixFormat.java,v 1.2 2004/06/07 09:09:37 carpentier Exp $
====================================================================*/

package org.objectweb.openccm.uml.transformation.ast;

import ispuml.mdaTransformation.RuleContext;
import ispuml.mdaTransformation.TransformationException;
import ispuml.mdaTransformation.ActionBase;
import ispuml.mdaTransformation.rules.xml.CompositeXmlAction;

/**
 * This action transforms the type prefix tag in order to reverse it.
 * 
 * @author Pierre Carpentier
 */
public class TypePrefixFormat extends CompositeXmlAction {

    /**
     * Constructor.
     */
    public TypePrefixFormat() {
        // The src property is not required. If it is not set, use the bean
        // provided
        // as parameter.
        isSrcPropertyRequired = false;
        isDstPropertyRequired = false;
        action = new TransformAction();
    }

    /**
     * Inner class
     */
    class TransformAction extends ActionBase {

        /**
         * Transform the prefix return it.
         * 
         * @param bean The prefix.
         * @param request The context. 
         * @return Object The reverse prefix.
         */
         public Object execute(Object bean, RuleContext request) throws TransformationException {
             if (bean != null) {
                 String prefix = (String)bean;

                 java.util.StringTokenizer token = new java.util.StringTokenizer(prefix, ".");
                 StringBuffer reversePrefix = new StringBuffer();
                 while (token.hasMoreTokens()) {
                     if (reversePrefix.length() > 0)
                         reversePrefix.insert(0, ".");
                     reversePrefix.insert(0, token.nextToken());   
                 }
                 return reversePrefix.toString();
             }
             return bean;
        }
    } // end class
}