/*====================================================================

ObjectWeb Util Package.
Copyright (C) 2000-2004 INRIA & USTL - LIFL - GOAL
Contact: architecture@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Philippe Merle.
Contributor(s): ______________________________________.

--------------------------------------------------------------------
$Id: ExceptionHolder.java,v 1.1 2004/02/13 17:46:08 rouvoy Exp $
====================================================================*/

package org.objectweb.util.misc.api;

/**
 * This interface represents an holder for Java Exception objects.
 *
 * @author <a href="mailto:Philippe.Merle@lifl.fr">Philippe Merle</a>
 * @version 0.1
 */
public interface ExceptionHolder {
    /**
     * Obtains the wrapped Java Exception object.
     *
     * @return The wrapped Java Exception object.
     */
    public Exception
    getException();

    /**
     * Sets the wrapped Java Exception object.
     *
     * @param exception The wrapped Java Exception object.
     */
    public void
    setException(Exception exception);
}
