package org.objectweb.util.release;

/**
 * 
 * @author <a href="mailto:Romain.Rouvoy@lifl.fr">Romain Rouvoy</a>
 * @version 0.1
 */
public interface ReleaseInfo {
    /**
     * Provides the long version of the name.
     * @return The nameLong to set.
     */
    public String getNameLong();

    /**
     * Provides the short version of the name.
     * @return The nameShort to set.
     */
    public String getNameShort();
    
    public short[] getVersionNumber();
    public String getVersion();
    
    /**
     * Provides the Specification Version Number.
     * @return The specVersionNumber to set.
     */
    public short[] getSpecVersionNumber();

    /**
     * Provides the Implementation Version Number.
     * @return The versionNumber to set.
     */
    public String getSpecVersion();
    
    public String getRelease();
    public String getReleaseTag();
}
