#include <CORBA_cpp_gene_main_servant_check_type.h>
#include <debug_utils.h>

CORBA_cpp_gene_main_servant_check_type::CORBA_cpp_gene_main_servant_check_type( CORBA::ComponentIR::ComponentDescription* d, CORBA::ComponentIR::Repository_ptr the_ref_repo )
  : desc_( d ), ref_repo_( the_ref_repo )
{
}

string CORBA_cpp_gene_main_servant_check_type::generate_code_in_place_of()
{
  string to_be_returned;

  CORBA::ComponentIR::UsesDescriptionSeq& used_interfaces
    = desc_->used_interfaces;

  for( int ct = 0; ct < used_interfaces.length(); ct++ )
    {
      string name_of_receptacle( used_interfaces[ ct ].name );
      
      CORBA::Contained_ptr intfdef_ref 
	= ref_repo_->lookup_id( used_interfaces[ ct ].interface_type );

      string type_of_receptacle( intfdef_ref->name() );

      to_be_returned += string( "" ) +
	get_mccm_debug_trace_warning("COMPONENT_IMPLEM_FACETS_RECPS")
	+ get_mccm_assert("name")
	+ get_mccm_assert("ref") +
	"if( strcmp( name, \"" + name_of_receptacle + "\" ) == 0 )\n"
	"{\n"
	"   CORBA::Object_var bidule = " + type_of_receptacle + "::_narrow( ref );\n"
	"\n"
	"   if( CORBA::is_nil( bidule.in() ) ) return false;\n"
	"else return true;\n"
	"}\n";
    }

  to_be_returned += "return false;\n";
  
  return to_be_returned;
}
