#include <CORBA_cpp_gene_main_servant_delete_deact.h>
#include <Correspondance_table.h>
#include <debug_utils.h>

CORBA_cpp_gene_main_servant_delete_deact::CORBA_cpp_gene_main_servant_delete_deact( CORBA::ComponentIR::ComponentDescription* desc,
										    CORBA::ComponentIR::Repository_ptr ref_repo )
  : desc_( desc ),
    ref_repo_( ref_repo )
{
}

string CORBA_cpp_gene_main_servant_delete_deact::generate_code_in_place_of()
{
  string to_be_returned;

  CORBA::ComponentIR::ProvidesDescriptionSeq& provided_interfaces
    = desc_->provided_interfaces;

  for( int ct = 0; ct < provided_interfaces.length(); ct++ )
    {
      string name_of_port( provided_interfaces[ ct ].name );

      to_be_returned += string( "" ) +
	get_mccm_debug_trace_warning("COMPONENT_IMPLEM") +
	"  the_poa_->deactivate_object( objid_" + name_of_port + "_.in() );\n"
	"  delete obj_impl_" + name_of_port + "_;\n"
	"\n";
    }

  CORBA::ComponentIR::EventPortDescriptionSeq& consumes_events
    = desc_->consumes_events;

  Correspondance_table<bool> type_of_event_encountered;
  
  for(int ct_consumer = 0; ct_consumer < consumes_events.length(); ct_consumer++)
    {
      CORBA::ComponentIR::EventDef_var evt_def 
	= CORBA::ComponentIR::EventDef::_narrow(ref_repo_->lookup_id(consumes_events[ct_consumer].event));
      
      string name_of_event = string(evt_def->name());
      string type_of_event_pushconsumer = string(desc_->name) + "__" + name_of_event + string("PushConsumer");
      string name_of_eventmap_pushconsumer = name_of_event + string("PushConsumers_");
      string name_of_sink = string(consumes_events[ct_consumer].name);

      to_be_returned += string( "" ) +
	"  the_poa_->deactivate_object( (PortableServer::ObjectId_var)the_poa_->reference_to_id(" + name_of_sink + "_) );\n";
    }

  for(int ct_consumer = 0; ct_consumer < consumes_events.length(); ct_consumer++)
    {
      CORBA::ComponentIR::EventDef_var evt_def 
	= CORBA::ComponentIR::EventDef::_narrow(ref_repo_->lookup_id(consumes_events[ct_consumer].event));

      string name_of_event = string(evt_def->name());
      string type_of_event_pushconsumer = string(desc_->name) + "__" + name_of_event + string("PushConsumer");
      string name_of_eventmap_pushconsumer = name_of_event + string("PushConsumers_");
      string name_of_sink = string(consumes_events[ct_consumer].name);

      if(!type_of_event_encountered.exists(name_of_event.c_str()))
	{
	  type_of_event_encountered[name_of_event.c_str()] = true;
	  to_be_returned += "  for( Correspondance_table<" + type_of_event_pushconsumer + "* >::iterator iter = " + name_of_eventmap_pushconsumer + ".begin();\n"
	    "  iter != " + name_of_eventmap_pushconsumer + ".end();\n"
	    "  iter++ )\n"
	    "  {\n"
	    "   delete iter->value->myeventconsumer_impl_;\n"
	    "   delete iter->value;\n"
	    "  }\n";
	}
    }

  to_be_returned += "delete the_service_integration_points_;\n";

  return to_be_returned;
}

