/*====================================================================
Tnis file was produced by the OpenCCM ir3_jimpl generator.
OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org
This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.
This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.
You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA
Initial developer(s): Philippe Merle, Mathieu Vadet.
Contributor(s): Sylvain Leblanc_______________________.
====================================================================*/
package ist.coach.itut_q816Components;

import intt.itu.itut_q816.ChannelInfoType;
import org.omg.CosNaming.NameComponent;
import java.util.Hashtable;

/**
 **  Implementation skeleton class for the ::itut_q816Components::ChannelFinderProvider component.
 **/
public class ChannelFinderProviderMonolithicImpl
       extends org.omg.CORBA.LocalObject
       implements CCM_ChannelFinderProvider,
                  intt.itu.itut_q816.CCM_ChannelFinder,
                  intt.itu.itut_q816.CCM_ChannelFinderComponent,
                  org.omg.Components.SessionComponent
{
    // ==================================================================
    //
    // Internal State.
    //
    // ===================================================================
    /**
     **  Context reference.
     **/
    private CCM_ChannelFinderProvider_Context the_context_;
	/** Business logic **/
	Hashtable channels = null;
    // ==================================================================
    //
    // Constructor.
    //
    // ===================================================================
    /**
     **  The default constructor.
     **/
    public
    ChannelFinderProviderMonolithicImpl()
    {
        the_context_ = null;
		channels = new Hashtable();
    }
    // ==================================================================
    //
    // Internal methods.
    //
    // ===================================================================
    // ==================================================================
    //
    // Public methods.
    //
    // ===================================================================
    /**
     **  To obtain the context.
     **
     **  @return The context that has been previously set by
     **          the set_session_context operation.
     **/
    public CCM_ChannelFinderProvider_Context
    getContext()
    {
        return the_context_;
    }
    // ==================================================================
    //
    // Methods for the OMG IDL Components::EnterpriseComponent local interface.
    //
    // ==================================================================
    //
    //  IDL:omg.org/Components/EnterpriseComponent/configuration_complete:1.0
    //
    /**
     **  Completes the component configuration.
     **
     **  @throws org.omg.Components.InvalidConfiguration
     **          Thrown if the configuration is invalid.
     **/
    public void
    configuration_complete()
    throws org.omg.Components.InvalidConfiguration
    {
        //
        //  DONE : implement !!!
        //
        System.err.println("ChannelFinderProvider configuration completed...");

    }
    // ==================================================================
    //
    // Methods for the OMG IDL Components::SessionComponent local interface.
    //
    // ==================================================================
    //
    //  IDL:omg.org/Components/SessionComponent/set_session_context:1.0
    //
    /**
     *  Called by the container when the component session context will be fixed.
     *
     *  @param context The session context.
     *
     *  @throws org.omg.Components.CCMException
     *          Thrown if a system level error occured.
     */
    public void
    set_session_context(org.omg.Components.SessionContext context)
    throws org.omg.Components.CCMException
    {
        the_context_ = (CCM_ChannelFinderProvider_Context)context;
    }
    //
    //  IDL:omg.org/Components/SessionComponent/ccm_activate:1.0
    //
    /**
     *
     * Called by the container when the component will be activated.
     *
     *  @throws org.omg.Components.CCMException
     *          Thrown if a system level error occured.
     */
    public void
    ccm_activate()
    throws org.omg.Components.CCMException
    {
        //
        // Unused by actual OpenCCM containers
        //
    }
    //
    //  IDL:omg.org/Components/SessionComponent/ccm_passivate:1.0
    //
    /**
     *
     * Called by the container when the component will be passivated.
     *
     *  @throws org.omg.Components.CCMException
     *          Thrown if a system level error occured.
     */
    public void
    ccm_passivate()
    throws org.omg.Components.CCMException
    {
        //
        // Unused by actual OpenCCM containers
        //
    }
    //
    //  IDL:omg.org/Components/SessionComponent/ccm_remove:1.0
    //
    /**
     *
     * Called by the container when the component will be removed.
     *
     *  @throws org.omg.Components.CCMException
     *          Thrown if a system level error occured.
     */
    public void
    ccm_remove()
    throws org.omg.Components.CCMException
    {
        //
        // TO DO: implement !!!
        //
    }
    // ==================================================================
    //
    // Public methods for the CCM_ChannelFinderProvider local interface.
    //
    // ==================================================================
    //
    //  IDL:coach.ist/itut_q816Components/CCM_ChannelFinderProvider/get_query:1.0
    //
    /**
     **  Implementation of the ::itut_q816Components::CCM_ChannelFinderProvider::get_query operation.
     **/
    public intt.itu.itut_q816.CCM_ChannelFinder
    get_query()
    {
        return this;
    }
    //
    //  IDL:coach.ist/itut_q816Components/CCM_ChannelFinderProvider/get_admin:1.0
    //
    /**
     **  Implementation of the ::itut_q816Components::CCM_ChannelFinderProvider::get_admin operation.
     **/
    public intt.itu.itut_q816.CCM_ChannelFinderComponent
    get_admin()
    {
        return this;
    }
    // ==================================================================
    //
    // Public methods for the ::itut_q816::CCM_ChannelFinder local interface.
    //
    // ==================================================================
    //
    //  IDL:itu.intt/itut_q816/ChannelFinder/list:1.0
    //
    /**
     **  Implementation of the ::itut_q816::ChannelFinder::list operation.
     **/
    public intt.itu.itut_q816.ChannelInfoType[]
    list()
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
		intt.itu.itut_q816.ChannelInfoType[] channelsInfo = new intt.itu.itut_q816.ChannelInfoType[0];

		int c_size = channels.size();

		if (c_size > 0) {
			channelsInfo = new intt.itu.itut_q816.ChannelInfoType[c_size];
			channelsInfo =
					(ChannelInfoType[]) channels.values().toArray(channelsInfo);
		}

        return channelsInfo;
    }
    // ==================================================================
    //
    // Public methods for the ::itut_q816::CCM_ChannelFinderComponent local interface.
    //
    // ==================================================================
    //
    //  IDL:itu.intt/itut_q816/ChannelFinderComponent/register:1.0
    //
    /**
     **  Implementation of the ::itut_q816::ChannelFinderComponent::register operation.
     **/
    public void
    register(java.lang.String channelID,
			java.lang.String channelClass,
			java.lang.String[] eventTypes,
			java.lang.String[] excludedEventTypes,
			java.lang.String[] sourceClasses,
			java.lang.String[] excludedSourceClasses,
			org.omg.CORBA.Object channel)
    throws intt.itu.itut_q816.ChannelAlreadyRegistered, intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //

		System.err.println("ChannelFinder> register is called for " +
				channelID + " of type " + channelClass);

		if (channels.containsKey(channelID)) {
			System.err.println("ChannelFinder> register found channel already registered..");
			throw new intt.itu.itut_q816.ChannelAlreadyRegistered();
		}

		intt.itu.itut_q816.ChannelInfoType channelInfo = new ChannelInfoType(channelID,
																channelClass,
																eventTypes,
																excludedEventTypes,
																sourceClasses,
																excludedSourceClasses,
																channel);

		channels.put(channelID, channelInfo);
    }
    //
    //  IDL:itu.intt/itut_q816/ChannelFinderComponent/unregister:1.0
    //
    /**
     **  Implementation of the ::itut_q816::ChannelFinderComponent::unregister operation.
     **/
    public void
    unregister(java.lang.String channelID)
    throws intt.itu.itut_q816.ChannelNotFound, intt.itu.itut_x780.ApplicationError
    {
        //
        //  TODO : implement
        //

			if (channels.containsKey(channelID))
				channels.remove(channelID);
			else
				throw new intt.itu.itut_q816.ChannelNotFound();
    }
}
