#ifndef Cpp_class_gene_h
#define Cpp_class_gene_h

#include <map>
#include <list>
using namespace std;

#include <Cpp_method.h>

#include <Pre_post_invocation.h>
#include <In_place_of_invocation.h>

class Cpp_class_gene
{
public:

  Cpp_class_gene( string name_of_class );

  string get_name_of_class();

  void add_inherited_class( string name_of_class, string visibility, bool virtual_or_not = false );
  void change_inherited_class( string name_of_orig_class, string new_name,  
			       string visibility, bool virtual_or_not );

  void add_method( Cpp_method the_cpp_method);
  void add_friend_class(string class_name);
  void add_member( string type_of_member, string name );

  void add_pre_post( string name_of_method, Pre_post_invocation* ppic );

  void add_implem( string name_of_method, In_place_of_invocation* ioi );
  void add_implem( Cpp_method the_method, In_place_of_invocation* ioi );

  void add_required_include( string name_of_include );

  // ---

  int get_nb_methods();
  string get_name_of_method_nb( int nb );
  Cpp_method& get_method( int index );
  // ---

  pair<string,string> generate_code( );

private:

  string name_of_proxy_;

  struct Inheritance_spec
  {
    string get_cpp_decl( string name_of_inherited_class );

    string visibility;
    bool virtual_or_not;
  };

  map<string, Inheritance_spec> inherited_classes_;

  map<string,string> members_; // correspondance name -> type.

  vector< Cpp_method > methods_;
  //  vector< pair<string, Cpp_method> > methods_; // new one.
  //  map<string, Cpp_method> methods_; // name of method -> complete description of method

  map<string, list<Pre_post_invocation*> > pre_post_interceptors_; // pre_post_interceptors
  //  map<string, In_place_of_invocation*> in_place_of_interceptors_; // in_place_of_interceptors
  vector< pair< Cpp_method, In_place_of_invocation* > > in_place_of_interceptors_;

  vector<string> required_includes_;
  vector<string> friend_classes_;
};

#endif // Cpp_class_gene_h
