/*====================================================================
Tnis file was produced by the OpenCCM ir3_jimpl generator.
OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org
This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.
This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.
You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA
Initial developer(s): Philippe Merle, Mathieu Vadet.
Contributor(s): Sylvain Leblanc_______________________.
====================================================================*/
package ist.coach.itut_x780Components;

import ist.coach.coachEmfCommon.Utils;
import ist.coach.coachEmfCommon.ExceptionMessages;
import intt.itu.itut_x780.UIDType;
import intt.itu.itut_x780.CreateError;
import intt.itu.itut_x780.ApplicationError;
import intt.itu.itut_x780.AttributeValueType;

import ist.coach.coachEmfCommon.CreateErrorInfoTypeImpl;
import ist.coach.coachEmfCommon.ApplicationErrorInfoTypeImpl;
import ist.coach.coachEmfCommon.ManagedObjectValueTypeImpl;
import ist.coach.coachEmfCommon.ObjectCreationImpl;
import ist.coach.coachEmfCommon.ObjectDeletionImpl;

import intt.itu.itut_x780.ManagedObjectValueType;
import org.omg.CosNaming.NameComponent;

import ist.coach.itut_x780Components.CCM_ManagedObjectProvider_Context;
/**
 **  Implementation skeleton class for the ::itut_x780Components::ManagedObjectProvider component.
 **/
public class ManagedObjectProviderMonolithicImpl
       extends org.omg.CORBA.LocalObject
       implements CCM_ManagedObjectProvider,
                  ist.coach.itut_x780Components.CCM_ManagedObjectMgmt,
                  org.omg.Components.SessionComponent
{
    // ==================================================================
    //
    // Internal State.
    //
    // ===================================================================
	private String _facade_name;

	java.util.Hashtable elements;
	private int notifId = 100;
    /**
     **  Context reference.
     **/
    private CCM_ManagedObjectProvider_Context the_context_;
    // ==================================================================
    //
    // Constructor.
    //
    // ===================================================================
    /**
     **  The default constructor.
     **/
    public
    ManagedObjectProviderMonolithicImpl()
    {
        the_context_ = null;
    }
    // ==================================================================
    //
    // Internal methods.
    //
    // ===================================================================
    // ==================================================================
    //
    // Public methods.
    //
    // ===================================================================
    /**
     **  To obtain the context.
     **
     **  @return The context that has been previously set by
     **          the set_session_context operation.
     **/
    public CCM_ManagedObjectProvider_Context
    getContext()
    {
        return the_context_;
    }
    // ==================================================================
    //
    // Methods for the OMG IDL Components::EnterpriseComponent local interface.
    //
    // ==================================================================
    //
    //  IDL:omg.org/Components/EnterpriseComponent/configuration_complete:1.0
    //
    /**
     **  Completes the component configuration.
     **
     **  @throws org.omg.Components.InvalidConfiguration
     **          Thrown if the configuration is invalid.
     **/
    public void
    configuration_complete()
    throws org.omg.Components.InvalidConfiguration
    {
        //
        //  DONE : implement !!!
        //

		elements = new java.util.Hashtable();
		System.err.println(facade_name() + " configuration completed...");
    }
    // ==================================================================
    //
    // Methods for the OMG IDL Components::SessionComponent local interface.
    //
    // ==================================================================
    //
    //  IDL:omg.org/Components/SessionComponent/set_session_context:1.0
    //
    /**
     *  Called by the container when the component session context will be fixed.
     *
     *  @param context The session context.
     *
     *  @throws org.omg.Components.CCMException
     *          Thrown if a system level error occured.
     */
    public void
    set_session_context(org.omg.Components.SessionContext context)
    throws org.omg.Components.CCMException
    {
        the_context_ = (CCM_ManagedObjectProvider_Context)context;
    }
    //
    //  IDL:omg.org/Components/SessionComponent/ccm_activate:1.0
    //
    /**
     *
     * Called by the container when the component will be activated.
     *
     *  @throws org.omg.Components.CCMException
     *          Thrown if a system level error occured.
     */
    public void
    ccm_activate()
    throws org.omg.Components.CCMException
    {
        //
        // Unused by actual OpenCCM containers
        //
    }
    //
    //  IDL:omg.org/Components/SessionComponent/ccm_passivate:1.0
    //
    /**
     *
     * Called by the container when the component will be passivated.
     *
     *  @throws org.omg.Components.CCMException
     *          Thrown if a system level error occured.
     */
    public void
    ccm_passivate()
    throws org.omg.Components.CCMException
    {
        //
        // Unused by actual OpenCCM containers
        //
    }
    //
    //  IDL:omg.org/Components/SessionComponent/ccm_remove:1.0
    //
    /**
     *
     * Called by the container when the component will be removed.
     *
     *  @throws org.omg.Components.CCMException
     *          Thrown if a system level error occured.
     */
    public void
    ccm_remove()
    throws org.omg.Components.CCMException
    {
        //
        // TO DO: implement !!!
        //
    }
    // ==================================================================
    //
    // Public methods for the CCM_ManagedObjectProvider local interface.
    //
    // ==================================================================
    //
    //  IDL:coach.ist/itut_x780Components/CCM_ManagedObjectProvider/get_mgmt:1.0
    //
    /**
     **  Implementation of the ::itut_x780Components::CCM_ManagedObjectProvider::get_mgmt operation.
     **/
    public ist.coach.itut_x780Components.CCM_ManagedObjectMgmt
    get_mgmt()
    {
        return this;
    }
    //
    //  IDL:coach.ist/itut_x780Components/CCM_NamedComponent_Executor/facade_name:1.0
    //
    /**
     **  Implementation of the ::itut_x780Components::CCM_NamedComponent_Executor::facade_name attribute as accessor operation.
     **/
    public java.lang.String
    facade_name()
    {
        //
        //  DONE : implement
        //
        return _facade_name;
    }

    /**
     **  Implementation of the ::itut_x780Components::CCM_NamedComponent_Executor::facade_name attribute as mutator operation.
     **/
    public void
    facade_name(java.lang.String val)
    {
        //
        //  DONE : implement
        //
		if (val != null)
			_facade_name = new String(val);
    }
    //
    //  IDL:/nameGet:1.0
    //
    /**
     **  Implementation of the ManagedObject_F::nameGet operation.
     **/
    public NameComponent[] nameGet() {
		return Utils.string2name(_facade_name);
	}
    //
    //  IDL:itu.intt/itut_x780/ManagedObject_F/objectClassGet:1.0
    //
    /**
     **  Implementation of the ::itut_x780::ManagedObject_F::objectClassGet operation.
     **/
    public java.lang.String
    objectClassGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
		if ( ! elements.containsKey(Utils.name2string(name))) {
			ApplicationErrorInfoTypeImpl error_code =
                    new ApplicationErrorInfoTypeImpl();
            error_code.error = new UIDType(
                intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
                intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);
            error_code.details = ExceptionMessages.not_exists_error;

            throw new ApplicationError(error_code);
		}
		ManagedObjectValueType mo_value =
			(ManagedObjectValueType) elements.get(Utils.name2string(name));
		return mo_value.objectClass;
    }
    //
    //  IDL:itu.intt/itut_x780/ManagedObject_F/attributesGet:1.0
    //
    /**
     **  Implementation of the ::itut_x780::ManagedObject_F::attributesGet operation.
     **/
    public intt.itu.itut_x780.ManagedObjectValueType
    attributesGet(org.omg.CosNaming.NameComponent[] name,
				intt.itu.itut_x780.StringSetTypeHolder attributeNames)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
		if ( ! elements.containsKey(Utils.name2string(name))) {
			ApplicationErrorInfoTypeImpl error_code =
                    new ApplicationErrorInfoTypeImpl();
            error_code.error = new UIDType(
                intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
                intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);
            error_code.details = ExceptionMessages.not_exists_error;

            throw new ApplicationError(error_code);
		}
		ManagedObjectValueType mo_value =
			(ManagedObjectValueType) elements.get(Utils.name2string(name));
		return mo_value;
    }
    //
    //  IDL:itu.intt/itut_x780/ManagedObject_F/packagesGet:1.0
    //
    /**
     **  Implementation of the ::itut_x780::ManagedObject_F::packagesGet operation.
     **/
    public java.lang.String[]
    packagesGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
		if ( ! elements.containsKey(Utils.name2string(name))) {
			ApplicationErrorInfoTypeImpl error_code =
                    new ApplicationErrorInfoTypeImpl();
            error_code.error = new UIDType(
                intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
                intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);
            	error_code.details = ExceptionMessages.not_exists_error;

            throw new ApplicationError(error_code);
		}
		ManagedObjectValueType mo_value =
			(ManagedObjectValueType) elements.get(Utils.name2string(name));
		return mo_value.packages;
    }
    //
    //
    //  IDL:itu.intt/itut_x780/ManagedObject_F/creationSourceGet:1.0
    //
    /**
     **  Implementation of the ::itut_x780::ManagedObject_F::creationSourceGet operation.
     **/
    public intt.itu.itut_x780.SourceIndicatorType
    creationSourceGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
		if ( ! elements.containsKey(Utils.name2string(name))) {
			ApplicationErrorInfoTypeImpl error_code =
                    new ApplicationErrorInfoTypeImpl();
            error_code.error = new UIDType(
                intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
                intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);
            	error_code.details = ExceptionMessages.not_exists_error;

            throw new ApplicationError(error_code);
		}
		ManagedObjectValueType mo_value =
			(ManagedObjectValueType) elements.get(Utils.name2string(name));
		return mo_value.creationSource;
    }
    //
    //  IDL:itu.intt/itut_x780/ManagedObject_F/deletePolicyGet:1.0
    //
    /**
     **  Implementation of the ::itut_x780::ManagedObject_F::deletePolicyGet operation.
     **/
    public short
    deletePolicyGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //

		if ( ! elements.containsKey(Utils.name2string(name))) {
			ApplicationErrorInfoTypeImpl error_code =
                    new ApplicationErrorInfoTypeImpl();
            error_code.error = new UIDType(
                intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
                intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);
            	error_code.details = ExceptionMessages.not_exists_error;

            throw new ApplicationError(error_code);
		}
		ManagedObjectValueType mo_value =
			(ManagedObjectValueType) elements.get(Utils.name2string(name));
		return mo_value.deletePolicy;
    }
    //
    //  IDL:itu.intt/itut_x780/ManagedObject_F/destroy:1.0
    //
    /**
     **  Implementation of the ::itut_x780::ManagedObject_F::destroy operation.
     **/
    public void
    destroy(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError, intt.itu.itut_x780.DeleteError
    {
        //
        //  DONE : implement
        //
		if ( ! elements.containsKey(Utils.name2string(name))) {
			ApplicationErrorInfoTypeImpl error_code =
                    new ApplicationErrorInfoTypeImpl();
            error_code.error = new UIDType(
                intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
                intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);
            	error_code.details = ExceptionMessages.not_exists_error;

            throw new ApplicationError(error_code);

		}
		ManagedObjectValueType mo_value =
			(ManagedObjectValueType) elements.remove(Utils.name2string(name));
		org.omg.TimeBase.UtcT eventTime = new org.omg.TimeBase.UtcT(System.currentTimeMillis(),
					0,(short) 0,(short) 0);
		the_context_.push_objectDeletion_alarm(new ObjectDeletionImpl(eventTime, name,
										mo_value.objectClass,
										getUniqueNotificationIdentifier(),
										mo_value.creationSource,
										new AttributeValueType[0]));
    }
    // ==================================================================
    //
    // Public methods for the ::itut_x780Components::CCM_ManagedObjectMgmt local interface.
    //
    // ==================================================================
    //
    //  IDL:coach.ist/itut_x780Components/ManagedObjectMgmt/create:1.0
    //
    /**
     **  Implementation of the ::itut_x780Components::ManagedObjectMgmt::create operation.
     **/
    public void
	create(org.omg.CosNaming.NameComponent[] name,
			String objectClass,
			String[] packages,
			short deletePolicy,
			intt.itu.itut_x780.SourceIndicatorType sourceIndicator)
    throws intt.itu.itut_x780.CreateError, intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
		if (elements.containsKey(Utils.name2string(name))) {
			System.err.println(Utils.name2string(name) + " already exists!");
			CreateErrorInfoTypeImpl error_code = new CreateErrorInfoTypeImpl();
            error_code.error = new UIDType(
                intt.itu.itut_x780.CreateErrorConst.moduleName.value,
                intt.itu.itut_x780.CreateErrorConst.duplicateName.value);

            error_code.details =  ExceptionMessages.already_exists_error;
            throw new CreateError(error_code);
		}
		ManagedObjectValueTypeImpl value_type =
				new ManagedObjectValueTypeImpl(name, objectClass, packages,
						sourceIndicator, deletePolicy);

		elements.put(Utils.name2string(name), value_type);

		org.omg.TimeBase.UtcT eventTime = new org.omg.TimeBase.UtcT(System.currentTimeMillis(),
					0,(short) 0,(short) 0);

		//System.err.println("ManagedObjectProvider  attempts to push object creation alarm...");
		the_context_.push_objectCreation_alarm(new ObjectCreationImpl(eventTime, name,
										objectClass,
										getUniqueNotificationIdentifier(),
										sourceIndicator,
										new AttributeValueType[0]));

    }


    private int getUniqueNotificationIdentifier() {

       notifId++;

       return (notifId);
   }

}
