#ifndef MCCM_Interceptor_base_h
#define MCCM_Interceptor_base_h

#include <tao/corba.h>
#include <EnterpriseComponent.h>
#include <Correspondance_table.h>
#include <Lw_ComponentsC.h>
#include <map>
using namespace std;

struct MCCM_Args
{
  void* arg_0;
  void* arg_1;
  void* arg_2;
  void* arg_3;
  void* arg_4;
  void* arg_5;
  // ... add more here if needed ....
};

// -----------------------------------------------------------------------

class MCCM_Callback
{
 public:
  virtual void invoke( MCCM_Args* args ) = 0;

  // -- should really be a CORBA::LocalObject here --
  virtual void set_target_objref( microCCM::Object* the_obj ) = 0;
};

// -----------------------------------------------------------------------

class MCCM_Interceptor
{
 public:

  virtual void invoke( MCCM_Args* args ) = 0;
  virtual void set_callback( MCCM_Callback* ) = 0;
};

// ---

class MCCM_has_set_interceptor
{
 public:

  virtual void set_in_place_of_interceptor( const char* name_of_method,
					    MCCM_Interceptor* mib ) = 0;
};

// ---

class MCCM_Service_Integration_Points
{
 public:

  void set_in_place_of_interceptor( const char* facet_name,
				    const char* method_name,
				    MCCM_Interceptor* the_intercept );

  void register_has_set_interceptor( MCCM_has_set_interceptor* hsi,
				     const char* facet_name );

  void register_ext_session_context( Components::SessionContext* the_session_context );

  void register_internal_interface( microCCM::Object* the_obj,
				    long the_id );

 private:

  Correspondance_table< MCCM_has_set_interceptor* > thsi_;
  Components::SessionContext_ptr the_session_context_;
};

// --------------------------------------------------------------------

class MCCM_Service_Integration
{
 public:

  virtual void install_at_service_access_points( MCCM_Service_Integration_Points* ) = 0;
  virtual void accept_configuration( const CORBA::Any& conf_values ) = 0;
};

// ---------------------------------------------------------------------

class MCCM_Service_Integration_Factory
{
 public:

  virtual char* name() = 0;
  virtual MCCM_Service_Integration* create() = 0;
};

// ----------------------------------------------------------------------

class MCCM_Service_Integration_Factories
{
 public:

  static MCCM_Service_Integration* create( const char* name,
					   const CORBA::Any& cfg );

  static void register_service_integration_factory( MCCM_Service_Integration_Factory* );

 private:

  static Correspondance_table< MCCM_Service_Integration_Factory* > the_factories_;
};


#endif // MCCM_Interceptor_base_h
