/*====================================================================

created on 13 ao?t 2003
OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2001-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Hameau Fabien.
Contributor(s): ______________________________________.

*/
package org.objectweb.openccm.Containers.MetaInformation;

import org.objectweb.ccm.util.Table;
import org.omg.CORBA.LocalObject;
import org.omg.Components.InvalidName;

/**
 * @author hameau
 *
 * To change the template for this generated type comment go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
public class ComponentInstanceListImpl
extends LocalObject
implements ComponentInstanceList
{

  private Table _components; 
  
  public ComponentInstanceListImpl()
  {
    _components = new Table();
  }

  /* (non-Javadoc)
   * @see org.objectweb.openccm.Containers.MetaInformation.ComponentInstanceListOperations#get_component_instance(java.lang.String)
   */
  public ComponentInstance 
  get_component_instance(String name) 
  throws InvalidName
  {
    ComponentInstance result = (ComponentInstance) _components.get(name);
    if(result == null)
      throw new InvalidName();
    return result;
  }

  /* (non-Javadoc)
   * @see org.objectweb.openccm.Containers.MetaInformation.ComponentInstanceListOperations#get_named_component_instances(java.lang.String[])
   */
  public ComponentInstance[] 
  get_named_component_instances(String[] names) 
  throws InvalidName
  {
    ComponentInstance[] result = new ComponentInstance[names.length];

   // Iterate on all the connections.
  
   int i = 0;
   for(i=0;i<names.length;i++)
   {
     result[i] = (ComponentInstance)_components.get(names[i]);
     
     if(result[i] == null)
     {
       throw new InvalidName();
     }
    }
   
   return result;
  }

  /* (non-Javadoc)
   * @see org.objectweb.openccm.Containers.MetaInformation.ComponentInstanceListOperations#get_all_component_instances()
   */
  public ComponentInstance[] 
  get_all_component_instances()
  {
    ComponentInstance[] result = new ComponentInstance[_components.size()];
  
     // Iterate on all the connections.
     int idx = 0;
     for(java.util.Enumeration elements = _components.elements(); elements.hasMoreElements(); )
     {
       ComponentInstance info = (ComponentInstance)elements.nextElement();
         result[idx++] = info;
     }
     return result;
  }

  /* (non-Javadoc)
   * @see org.objectweb.openccm.Containers.MetaInformation.ComponentInstanceListOperations#add_component_instance(org.objectweb.openccm.Containers.MetaInformation.ComponentInstance)
   */
  public void add_component_instance(ComponentInstance cpi)
  {
    String key = cpi.type_reference().name() + cpi.toString().substring(cpi.toString().lastIndexOf("@"));
   
    _components.put(key,cpi);
    
  }

  /* (non-Javadoc)
   * @see org.objectweb.openccm.Containers.MetaInformation.ComponentInstanceListOperations#remove_component_instance(java.lang.String)
   */
  public void remove_component_instance(String name) 
  throws InvalidName
  {
    Object result = _components.remove(name);
    
    if (result == null) throw new InvalidName();
  }
}
