/*====================================================================

created on 10 avr. 2003

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2001-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Hameau Fabien.
Contributor(s): ______________________________________.

*/

package org.objectweb.openccm.Containers.MetaInformation;

import org.objectweb.ccm.util.Table;
import org.omg.CORBA.LocalObject;
import org.omg.Components.InvalidName;

/**
 * @author hameau
 */
public class ConsumerPortTypeListImpl
extends LocalObject
implements ConsumerPortTypeList
{
	private Table _consumers;
	
	public ConsumerPortTypeListImpl()
	{
	    _consumers = new Table();
	}

	public ConsumerPortType[] get_all_consumer_port_types()
	{
		ConsumerPortType[] result = new ConsumerPortType[_consumers.size()];

		// Iterate on all the connections.
		int idx = 0;
		for(java.util.Enumeration elements = _consumers.elements(); elements.hasMoreElements(); )
		{
				ConsumerPortType info = (ConsumerPortType)elements.nextElement();
				result[idx++] = info;
		}
		return result;
	}

	public ConsumerPortType[] get_named_consumer_port_types(String[] names)
	{
	ConsumerPortType[] result = new ConsumerPortType[names.length];

	// Iterate on all the connections.
		int i = 0;
		for(i=0;i<names.length;i++)
		{
				result[i] = (ConsumerPortType)_consumers.get(names[i]);
		}
		return result;
	}	

	public ConsumerPortType get_consumer_port_type(String name)
	{
			return (ConsumerPortType) _consumers.get(name);
	}

	public void add_consumer_port_type(ConsumerPortType _opt)
	{
		_consumers.put(_opt.name(),_opt);
	}

	public void remove_consumer_port_type(String name)
	{
		_consumers.remove(name);
	}

 
}
