/*====================================================================

created on 14 ao?t 2003
OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2001-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Hameau Fabien.
Contributor(s): ______________________________________.

*/
package org.objectweb.openccm.Containers.MetaInformation;

import org.objectweb.ccm.util.Table;
import org.omg.CORBA.LocalObject;
import org.omg.Components.InvalidName;

/**
 * @author hameau
 *
 * To change the template for this generated type comment go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
public class FacetPortInstanceListImpl
extends LocalObject
implements FacetPortInstanceList
{

  private Table _facets; 
  
  public FacetPortInstanceListImpl()
  {
    _facets = new Table();
  }

  /* (non-Javadoc)
   * @see org.objectweb.openccm.Containers.MetaInformation.FacetPortInstanceListOperations#get_facet_port_instance(java.lang.String)
   */
  public FacetPortInstance 
  get_facet_port_instance(String name) 
  throws InvalidName
  {
    FacetPortInstance result = (FacetPortInstance) _facets.get(name);
    if(result == null)
      throw new InvalidName();
    return result;
  }

  /* (non-Javadoc)
   * @see org.objectweb.openccm.Containers.MetaInformation.FacetPortInstanceListOperations#get_named_facet_port_instances(java.lang.String[])
   */
  public FacetPortInstance[] 
  get_named_facet_port_instances(String[] names) 
  throws InvalidName
  {
    FacetPortInstance[] result = new FacetPortInstance[names.length];

   // Iterate on all the connections.
  
   int i = 0;
   for(i=0;i<names.length;i++)
   {
     result[i] = (FacetPortInstance)_facets.get(names[i]);
     
     if(result[i] == null)
     {
       throw new InvalidName();
     }
    }
   
   return result;
  }

  /* (non-Javadoc)
   * @see org.objectweb.openccm.Containers.MetaInformation.FacetPortInstanceListOperations#get_all_facet_port_instances()
   */
  public FacetPortInstance[] 
  get_all_facet_port_instances()
  {
    FacetPortInstance[] result = new FacetPortInstance[_facets.size()];
  
     // Iterate on all the connections.
     int idx = 0;
     for(java.util.Enumeration elements = _facets.elements(); elements.hasMoreElements(); )
     {
       FacetPortInstance info = (FacetPortInstance)elements.nextElement();
         result[idx++] = info;
     }
     return result;
  }

  /* (non-Javadoc)
   * @see org.objectweb.openccm.Containers.MetaInformation.FacetPortInstanceListOperations#add_facet_port_instance(org.objectweb.openccm.Containers.MetaInformation.FacetPortInstance)
   */
  public void add_facet_port_instance(FacetPortInstance fpi)
  {
      String key = fpi.type_reference().name() ;//+ fpi.toString().substring(fpi.toString().lastIndexOf("@"));
 
      _facets.put(key,fpi);
  }

  /* (non-Javadoc)
   * @see org.objectweb.openccm.Containers.MetaInformation.FacetPortInstanceListOperations#remove_facet_port_instance(java.lang.String)
   */
  public void remove_facet_port_instance(String name) 
  throws InvalidName
  {
    Object result = _facets.remove(name);
    
    if (result == null) throw new InvalidName();
  }
}
