/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2004 INRIA & USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Christophe Demarey.
Contributor(s): ______________________________________.

====================================================================*/

package org.objectweb.openccm.pss.runtime.common.lib;


/**
 * This initializer is used to register a reference to the Persistent
 * State Service in ORB initial references.
 * This is a CORBA object but contains a local object.
 *
 * @author <a href="mailto:Christophe.Demarey@lifl.fr">Christophe Demarey</a>
 *
 * @version 0.1
 */

public class Initializer
    extends org.omg.CORBA.LocalObject
    implements org.omg.PortableInterceptor.ORBInitializer
{
    /**
     * Pre initialization
     */
    public void pre_init( org.omg.PortableInterceptor.ORBInitInfo info )
    {
        // Nothing to do
    }

    /**
     * Post initialization
     */
    public void post_init( org.omg.PortableInterceptor.ORBInitInfo info )
    {
        try
        {
            org.omg.CosPersistentState.ConnectorRegistry pss =
                new org.objectweb.openccm.pss.runtime.common.lib.ConnectorRegistry();
            info.register_initial_reference( "PSS", pss );
        }
        catch ( org.omg.PortableInterceptor.ORBInitInfoPackage.InvalidName ex )
        {
            System.err.println( "Initializer - Unable to resolve PersistentStateService" );
        }
    }
}
